;  Abridged revision history
;  Version 1.0
;  ASB 1Aug95 First version, put together from editpeakmp and cw_defroi
;  ASB  1Feb96 Changed to 3 mri windows and 4 metabolite windows
;  ASB 08Aug96 Added call to asb_defroi_update when bin width is
;              changed. Modified to save positions file in correct
;              directory.
;  ASB 05Sep96 Fixed bugs involving rois containing only one point.
;              Added second color table.
;              Added preliminary settings dialog.
;              Added code to read default file.
;  ASB 22Oct96 Added code to read and display segmented images, read
;              and display make sensitivity maps, and output
;              metabolite and sensitivity map values.
;  ASB 18Jul97 Added code to read 3dcsi data
;  ASB 21Jul97 Fixed bug in stting of slice number.
;  ASB  3Dec97 Added code to compute csi pixel location for resolution
;              other than 32x32
;  Qin 07Apr98 Added header reading
;  Qin 14Apr98 Replace "Run Peak Picker" by "Alan Peak" & "Jeff Peak"
;  Qin 15Apr98 replace s.mets[3,0,1,2] by s.mets[0,1,2,3] and
;              win#1. twinfl <--> NAA      win#2. twinnl <--> Cretine
;              win#3. twinnr <--> Choline  win#4. twinfr <--> Lactate 
;              So that Jeff's naa_scale_max works fine
;  Qin ?????   Added common block settings.
;              Added logic to display maps using Jeff Duyn's color
;              table.
;              Added widget bt40 and associated code to handle display
;              of average spectrum.
;              Added widgets botrowq, btnrow, bt11,
;              bt12,bt21,bt22,bt31,bt32,bt40
;              Added bt40 and smode to structure s.
;  ASB 14Jul98 Removed subroutine tvlcolor.
;  ASB 15Jul98 Removed subroutines init_mets,update_window
;  ASB 17Jul98 Changed logic for toggling between ROI and
;              pixel spectra.
;              Changed "Next MRI" and "Previous MRI" buttons
;  ASB 20JUL98 Minor changes for toggling specplot in point mode.
;              Removed header info widgets.
;              Removed superfluous wset calls.
;  ASB 21Jul98 Removed keyword width from call to specplot.
;              Changed "Settings" button to menu to select
;                 display_settings or recon_settings.
;  ASB 21Jul98 Converted Read MRI buttons to pulldown menu.
;  ASB 21Jul98 Converted peak picker buttons to pulldown menu.
;  ASB 22Jul98 Changed logic for updating metabolite maps.
;  ASB 23Jul98 Bring statistics window to front realized but hidden
;              when "Show statistics" button is pushed.
;  ASB 24Jul98 Added code to display roi on MRIs after chang of windowing.
;  ASB 27Jul98 Removed arguments in call to sumpeaks.
;  ASB 29Jul98 Added code to display individual pixels in statistics window.
;  ASB 29Jul98 Moved asb_defroi_update, asb_defroi_nmode and
;              asbdef_roi_draw to file asb_defroi_draw.pro.
;              Moved call to mkroistats to analyze_roi_event.
;  ASB 11Aug98 Added code to change sensitivity of some buttons.
;              Modified code for sumfile.
;              Fixed bug in 'Get ROI' button code.
;  ASB 25Aug98 Fixed bug in 'Save ROI' button code.
;              Made "Next MRI" and "Previous MRI" buttons insensitive.
;  ASB 27Aug98 Fixed bug in 'Raw Data File' button code.
;  ASB 28Aug98 Combined btnrow1, btnrow2, and btnrow3 into array btnrow.
;  ASB 15Sep98 Removed code of Jeff Duyn's peak picker to duynpick.pro
;  ASB 15Sep98 Added COMMON initcsi and removed system variables.
;  ASB  8Oct98 Added COMMON mrsidata.
;              Added code to call time domain processing routines.
;              Added code to display results of time domain
;              processing.
;              Moved Peak picker buttons to new Action pulldown menu.
;              Added code to pick peaks using water signal in TD or
;              FD.
;  ASB  9Oct98 Rearreanged buttons.  Added Save and Restore menus.
;              Move Code for Read Position file to restore_pos.pro.
;              Added code to restore time domain analysis results.
;              Moved code to restore ROI to restore_roi.pro.
;              Moved code to save ROI to save_roi.pro.
;  ASB  1Mar99 Removed PSD button and moved functionality to rsettings dialog. 
;              Moved MRI window and level to display settings dialog.
;              Added separate limits for each MRI window.
;              Rewrote logic for Save.Position File
;              Rewrote logic for Save.ROI
;  ASB  7Apr99 Added code to permit display of water map in window 4.
;	analyze_roi 	-
;  ASB 11Aug99 Moved initialization of mri to common_list.pro
;  ASB 15Sep99 Changed logic for editing td maps.
;              Changed logic for changing ROI stats when toggling
;              between TD and FD.
;  ASB 24Sep99 Added button to segmentation menu to read class volumes.
;  ASB  7Dec99 Added code to handle 6 types of water maps.
;	widget event handling routine
PRO	analyze_roi_event, event
COMMON posdata
COMMON update
COMMON editpeakmp
COMMON defroi
COMMON sumfile
COMMON rsettings
COMMON dsettings
COMMON roistats
COMMON defaults
COMMON initcsi
COMMON mrsidata

IF lastid EQ s.slider_w AND event.id NE s.slider_w THEN init_mets
lastid=event.id
wins=[s.gwins,s.mwins]
backing=[s.gbacking,s.mbacking]

;Code to track cursor in all draw windows and display spectrum
FOR i = 0,n_elements(s.draw)-1 DO BEGIN
    IF event.id EQ s.draw(i) THEN BEGIN

        wset,wins(i)

; IF not a widget_tracking event, plot spectrum
        
        thisEvent = Tag_Names(event, /Structure_Name)

        IF thisEvent EQ 'WIDGET_TRACKING' THEN BEGIN  
            move_cursors,event,thisEvent

        ENDIF ELSE BEGIN        ; draw widget event
                                ;If out of bounds, don't process
            IF (event.x LT 0) OR (event.y LT 0) OR $ ;Within region?
              (event.x GE s.image_size(0)) OR (event.y GE s.image_size(1)) THEN RETURN
            s.button=(s.button OR event.press) XOR event.release  ;Update button state
            vx = event.x / (256/pe_dim(0))
            vy = event.y / (256/pe_dim(1))
            IF positions(vx,vy) LE 0 THEN ref_pos(0) = 0	$
            ELSE ref_pos(0) = positions(vx,vy)
            CASE s.mode OF
                0: BEGIN ;Edit mode
                    move_cursors,event,thisEvent
                    CASE event.press OF
                        0: BEGIN ;no buttons
                            IF s.amode EQ 0 THEN BEGIN
                                update_specplot,vx,vy
                            ENDIF
                        END
                        
                        1: BEGIN ;left button
                            cur_pos=[vx,vy]
                            s.amode= 1
                            new_value=positions(vx,vy)
                            update_specplot,vx,vy
                        END
                        
                        2: BEGIN ;middle button
                            s.amode= 0
                            new_value=positions(vx,vy)
                            update_specplot,vx,vy
                        END
                        
                        4: BEGIN ;right button
                            s.amode = 0
                            widget_control,s.msg_w,set_value=s.text5
                            s.mode = 5
                        END

                        ELSE:   ;Do nothing if more than one button is pressed

                    ENDCASE

                END
                
                1: BEGIN ;polygon mode
                    update_specplot,vx,vy
                    dopolygon,event
                END

                2:BEGIN ;point mode
                    update_specplot,vx,vy
                    cur_pos=[vx,vy]
                    dopoint,event
                END
                    
                3: BEGIN ; Rectangle mode
                    update_specplot,vx,vy
                    dorectangle,event
                END

                4: BEGIN ; Circle mode
                    update_specplot,vx,vy
                    docircle,event
                END

                5: BEGIN ;Zap Mode
                    move_cursors,event,thisEvent
                    update_specplot,vx,vy
                    CASE event.press OF
                        1: BEGIN
                            positions(vx,vy) = -1 ;update position array
                            IF tdflag THEN BEGIN
                                zap_td(vx,vy)=0
                            ENDIF
                            init_mets,event ;update maps
                        END
                        2: BEGIN
                            positions(vx,*) = -1
                            IF tdflag THEN BEGIN
                                zap_td(vx,*)=0
                            ENDIF
                            init_mets,event ;update maps
                        END
                        4: BEGIN
                            positions(*,vy) = -1
                            IF tdflag THEN BEGIN
                                zap_td(*,vy)=0
                            ENDIF
                            init_mets,event ;update maps
                        END

                        ELSE:   ;Do nothing if more than one button is pressed
                    ENDCASE
                    IF event.press NE 0 THEN BEGIN
                        widget_control,s.junk_w,set_value=0
                        widget_control,s.msg_w,set_value=s.text0
                        s.mode = 0
                    ENDIF
     
                END
                
            ENDCASE
        ENDELSE ;thisEvent eq 'widget tracking'
            
        RETURN
    ENDIF
ENDFOR

CASE event.id OF
    s.slider_w: IF s.mode EQ 0 THEN BEGIN
        new_value = event.value
        IF new_value GT spc_len OR new_value LT 0 THEN RETURN
        wset,s.swin
        specplot,cur_pos(0),cur_pos(1),/show
        positions(cur_pos(0),cur_pos(1))=new_value
    ENDIF

    s.header_w: header_info

    s.dfileb_w : BEGIN
        tmp=read_raw_name()     ;Read raw data file name
        widget_control,s.save_ids(1),sensitive=0 ;Save Postions
    END

    s.pdmenu_w : pdmenu_event,event

    s.pdmenu_set_w : pdmenu_event,event
    
    s.pdmenu_seg_w : pdmenu_event,event
    
    s.pdmenu_mri_w : pdmenu_event,event

    s.pdmenu_action_w : pdmenu_event,event

    s.pdmenu_save_w : pdmenu_event,event

    s.pdmenu_restore_w : pdmenu_event,event
    
    s.tf_w : IF tdflag THEN BEGIN
        widget_control,s.tf_w,get_uvalue=foo
        foo=(foo+1) mod 2
        widget_control,s.tf_w,set_value=s.tf_labels(foo),set_uvalue=foo
        init_mets
        clear_roi
    ENDIF

    s.read_w : CASE event.value OF

        '  Quit  ' : BEGIN
            WIDGET_CONTROL, event.top, /DESTROY
        END
            
        'Show ROI Statistics' : BEGIN
            IF xregistered('mkroistats') EQ 0 THEN BEGIN
                asb_defroi_update            
                mkroistats
;                widget_control,s.but_ids(2),sensitive=0
            ENDIF
        END

        '  Mask  ': mask

    ENDCASE                     ;read event.value

    s.options_w: CASE event.value OF
    
        'Clear': clear_roi

        'Clear All':  clear_all
                
    ENDCASE                     ; options, event.value
        
    s.junk_w: CASE event.value OF  
    
        'Edit' : BEGIN
            clear_roi
            widget_control,s.msg_w,set_value=s.text0
            swap_windows
            s.mode = 0
        END            
        
        'Polygon': BEGIN
            clear_roi
            widget_control,s.msg_w,set_value=s.text1
            s.mode=1
        END           
        
        'Point': BEGIN
            clear_roi
            widget_control,s.msg_w,set_value=s.text2
            s.mode = 2
        END            
        
        'Rectangle':  BEGIN
            clear_roi
            widget_control,s.msg_w,set_value=s.text3
            s.mode = 3
        END            
        
        'Circle': BEGIN
            clear_roi
            widget_control,s.msg_w,set_value=s.text4
            s.mode = 4
        END
                            
    ENDCASE

; pixel-roi spectrum button
    s.prspec_w: BEGIN ;Toggle spectrum label
        IF s.smode THEN BEGIN ;Toggle to pixel mode
            s.smode = 0
        ENDIF ELSE BEGIN ;Toggle to roi mode
            IF count EQ 0 THEN RETURN
            s.smode=1
        ENDELSE
;Change button value
        widget_control,s.prspec_w,get_uvalue=labels
        widget_control,s.prspec_w,set_value=labels(s.smode)
;Replot spectrum
        update_specplot,cur_pos(0),cur_pos(1)
    END            

; Read volume threshold
    s.thresh_w : asb_defroi_nmode,/old

;Integration width changed; update roi statistics
;    s.width_w : BEGIN
;        asb_defroi_update
;    END

ENDCASE ;event.id

END ;	end event handler
                            
pro pdmenu_event, event ;handles events in slice menu
COMMON defroi
COMMON seg
COMMON posdata
COMMON initcsi

oldslice=cur_slice
CASE Event.Value OF 

    'Slice.1': BEGIN
        widget_control,s.slice_w,set_value='1'
        cur_slice=1
        nseg=[1,3,5]
        nsl=[[1,1,1],[3,3,3]]
        widget_control,s.save_ids(1),sensitive=0 ;Save Postions
        widget_control,s.dfilel_w,get_uvalue=tmp
        IF tmp NE 'init' THEN BEGIN
            widget_control,s.dfilel_w,set_uvalue='new'
            widget_control,s.slice_w,get_uvalue=pos_name
            pos=strpos(pos_name,'_sl_')
            strput,pos_name,'_sl_1',pos
            widget_control,s.slice_w,set_uvalue=pos_name
        ENDIF
    END
    
    'Slice.2': BEGIN
        widget_control,s.slice_w,set_value='2'
        cur_slice=2
        nseg=[7,9,11]
        nsl=[[2,2,2],[9,9,9]]
        widget_control,s.save_ids(1),sensitive=0 ;Save Postions
        widget_control,s.dfilel_w,get_uvalue=tmp
        IF tmp NE 'init' THEN BEGIN
            widget_control,s.dfilel_w,set_uvalue='new'
            widget_control,s.slice_w,get_uvalue=pos_name
            pos=strpos(pos_name,'_sl_')
            strput,pos_name,'_sl_2',pos
            widget_control,s.slice_w,set_uvalue=pos_name
        END
    END
    
    'Slice.3': BEGIN
        widget_control,s.slice_w,set_value='3'
        cur_slice=3
        nseg(0)=[13,15,17]
        nsl=[[3,3,3],[15,15,15]]
        widget_control,s.save_ids(1),sensitive=0 ;Save Postions
        widget_control,s.dfilel_w,get_uvalue=tmp
        IF tmp NE 'init' THEN BEGIN
            widget_control,s.dfilel_w,set_uvalue='new'
            widget_control,s.slice_w,get_uvalue=pos_name
            pos=strpos(pos_name,'_sl_')
            strput,pos_name,'_sl_3',pos
            widget_control,s.slice_w,set_uvalue=pos_name
        ENDIF
    END
    
    'Slice.4': BEGIN
        widget_control,s.slice_w,set_value='4'
        cur_slice=4
        nseg=[19,21,23]
        nsl=[[4,4,4],[21,21,21]]
        widget_control,s.save_ids(1),sensitive=0 ;Save Postions
        widget_control,s.dfilel_w,get_uvalue=tmp
        IF tmp NE 'init' THEN BEGIN
            widget_control,s.dfilel_w,set_uvalue='new'
            widget_control,s.slice_w,get_uvalue=pos_name
            pos=strpos(pos_name,'_sl_')
            strput,pos_name,'_sl_4',pos
            widget_control,s.slice_w,set_uvalue=pos_name
        ENDIF
    END

    'Action.Read Raw Data': BEGIN
        widget_control,s.dfilel_w,get_uvalue=stat
        IF stat EQ 'init' THEN BEGIN 
            tmp=read_raw_name()
            IF tmp EQ 0 THEN BEGIN
                readandrecon
            ENDIF
        ENDIF ELSE readandrecon            
    END

    'Action.Make B0 map (Peak Pickers).Alger method': BEGIN
                                ;If no filename has been chosen, pick filename
        widget_control,s.dfilel_w,get_uvalue=stat,/hourglass
        IF stat EQ 'init' THEN BEGIN
            tmp=read_raw_name()
            IF tmp EQ 0 THEN readandrecon
        ENDIF ELSE TMP = 0

        IF tmp THEN BEGIN
        ENDIF ELSE BEGIN
                                ;If no rawfile has been read, read new
                                ;rawfile

            IF stat EQ 'new' THEN BEGIN
                readandrecon
            END
                                ;run peak picker   
            positions = auto_mp_pick()
            widget_control,s.save_ids(1),sensitive=1 ;Save Positions
            widget_control,s.save_ids(4),sensitive=1 ;Save Positions
            widget_control,s.restore_ids(2),sensitive=1 ;Save Positions
            widget_control,s.restore_ids(3),sensitive=1 ;Save Positions
            init_mets           ; make and plot metabolite maps
        ENDELSE
    END

    'Action.Make B0 map (Peak Pickers).Duyn method': BEGIN
                                ;If no filename has been chosen, pick filename
        widget_control,s.dfilel_w,get_uvalue=stat,/hourglass
        IF stat EQ 'init' THEN BEGIN
            tmp=read_raw_name()
            IF tmp EQ 0 THEN readandrecon
        ENDIF ELSE TMP = 0

        IF tmp THEN BEGIN
        ENDIF ELSE BEGIN
                                ;If no rawfile has been read, read new
                                ;rawfile

            IF stat EQ 'new' THEN BEGIN
                readandrecon
            END
            duynpick            ; Find peaks
            init_mets           ; make and plot metabolite maps
        ENDELSE
    END

    'Action.Make B0 map (Peak Pickers).Water Peak (Frequency Domain)': BEGIN
                                ;If no filename has been chosen, pick filename
        widget_control,s.dfilel_w,get_uvalue=stat,/hourglass
        IF stat EQ 'init' THEN BEGIN
            tmp=read_raw_name()
            IF tmp EQ 0 THEN readandrecon
        ENDIF ELSE TMP = 0

        IF tmp THEN BEGIN
        ENDIF ELSE BEGIN
                                ;If no rawfile has been read, read new
                                ;rawfile

            IF stat EQ 'new' THEN BEGIN
                readandrecon
            END
            waterpick           ; Find peaks
            init_mets           ; make and plot metabolite maps
            
        ENDELSE
    END

    'Action.Make B0 map (Peak Pickers).Water Peak (Time Domain)': BEGIN
                                ;If no filename has been chosen, pick filename
        widget_control,s.dfilel_w,get_uvalue=stat,/hourglass
        IF stat EQ 'init' THEN BEGIN
            tmp=read_raw_name()
            IF tmp EQ 0 THEN readandrecon
        ENDIF ELSE TMP = 0

        IF tmp THEN BEGIN
        ENDIF ELSE BEGIN
                                ;If no rawfile has been read, read new
                                ;rawfile

            IF stat EQ 'new' THEN BEGIN
                readandrecon
            END
            tdpick              ; Find peaks using TD method
            init_mets           ; make and plot metabolite maps
            
        ENDELSE
    END

    'Action.Do Time Domain Analysis': BEGIN
        do_tdomain
    END

    'Action.Test Spectra': test_spectra

    'Save.Position File': BEGIN
        widget_control,s.read_w,get_uvalue=new_dir
        cd,new_dir
        widget_control,s.slice_w,get_uvalue=pos_name
        save,positions,file=pos_name
    END

    'Save.Time Domain Analysis Results': save_td

    'Save.ROI': save_roi

    'Save.PICT': BEGIN
            spawn,'pwd',new_dir
            widget_control,s.read_w,get_uvalue=old_dir
            cd,old_dir
            save_pict
            cd,new_dir(0)
            wset,s.gwins(0)
        END

    'Restore.Position File': restore_pos

    'Restore.Time Domain Analysis Results': restore_td

    'Restore.ROI': restore_roi

    'Read MRI.Read MRI 1' : read_mri,0

    'Read MRI.Read MRI 2' : read_mri,1

    'Read MRI.Read MRI 3' : read_mri,2        

    'Settings.Recon Settings': recon_settings

    'Settings.Display Settings': display_settings

    'Segmentation.Read Segmented Images':BEGIN
        rd_seg_ims
    END

    'Segmentation.Read Class Volumes':BEGIN
        rd_class_vols
    END

    'Segmentation.Display Segmented Images':BEGIN
        display_seg_ims
    END

    'Segmentation.Make Sensitivity Maps':BEGIN
        widget_control,event.top,/hourglass
        mk_sens_maps
    END

    'Segmentation.Display Sensitivity Maps':BEGIN
        print,'Display Sensitivity Maps selected'
        widget_control,event.top,/hourglass
        disp_sens
    END

    'Segmentation.Do Analysis':BEGIN
        print,'Do Analysis selected'
        seg_roi,event
    END

ENDCASE

END

;Program to reconstruct, edit and perform roi analysis on mrsi
;data. This program combines the functions of the programs called by
;the scripts rec1map, redo1map, and doanalyze. It includes an improved
;interface.
;Revision History
;ASB    08Aug96  First SCCS version
;	widget creation
PRO	analyze_roi, naa_pos
COMMON posdata
COMMON update, twinfl,twinnl,twinnr,twinfr,bwinfl,bwinnl,bwinnr,bwinfr
COMMON editpeakmp
COMMON defroi
COMMON defaults
COMMON seg
COMMON dsettings
COMMON rsettings
COMMON mri_act
COMMON initcsi

jhd=0
jjunk   = { CW_PDMENU_S, flags:0, name:'' }

;Compute noise, open and initialize output file

toplevel = WIDGET_BASE(TITLE='Analyze CSI DATA', /COLUMN)

base0 = widget_base(toplevel, /row) 

read_w = CW_BGROUP(base0, /ROW, /NO_RELEASE, /RETURN_NAME,  $
                   ['  Quit  ', '  Mask  ','Show ROI Statistics'],ids=but_ids)
widget_control,but_ids(2),sensitive=0
menu_desc_w = [ $
                { CW_PDMENU_S,       3, 'Read MRI' }, $ ;        0
                { CW_PDMENU_S,       0, 'Read MRI 1' }, $ ;        1
                { CW_PDMENU_S,       0, 'Read MRI 2' }, $ ;        2
                { CW_PDMENU_S,       0, 'Read MRI 3' } $ ;        3
                ]

pdmenu_mri_w = cw_pdmenu( base0, menu_desc_w, /return_full_name, $
                     uvalue='pdmenu')
   
menu_desc_w = [ $
                { CW_PDMENU_S,       3, 'Settings' }, $ ;        0
                { CW_PDMENU_S,       0, 'Recon Settings' }, $ ;        1
                { CW_PDMENU_S,       0, 'Display Settings' } $ ;        2
                ]

pdmenu_set_w = cw_pdmenu( base0, menu_desc_w, /return_full_name, $
                     uvalue='pdmenu')
   
thresh_w=cw_field(base0,title='Min. ROI Vol. %:',value=roivolmin,$
                  /return,/integer,xsize=5)
widget_control,thresh_w,set_uvalue=[-1]
num1_w = cw_field(base0,title='Points in ROI:',$
                 value='0',/return,xsize=4,/noedit,/int)
;pull down menu for segmentation actions
menu_desc_w = [ $
                { CW_PDMENU_S,       3, 'Segmentation' }, $              ; 0
                { CW_PDMENU_S,       0, 'Read Segmented Images' }, $     ; 1
                { CW_PDMENU_S,       0, 'Read Class Volumes' }, $        ; 2
                { CW_PDMENU_S,       0, 'Display Segmented Images' }, $  ; 3
                { CW_PDMENU_S,       0, 'Make Sensitivity Maps' }, $     ; 4
                { CW_PDMENU_S,       0, 'Display Sensitivity Maps' }, $  ; 5
                { CW_PDMENU_S,       2, 'Do Analysis' } $                ; 6
                ]

pdmenu_seg_w = cw_pdmenu( base0, menu_desc_w, /return_full_name, $
                     uvalue='pdmenu')
; second row
base1 = widget_base(toplevel, /row) 
header_w = widget_button(base1, value='Show Header Info')
dfileb_w = widget_button(base1, value='Raw Data File')
dfilel_w = widget_label( base1, value=string(replicate(32b,80)),uvalue='init')

menu_desc_w = [ $
                { CW_PDMENU_S,       3, 'Slice' }, $ ;        0
                { CW_PDMENU_S,       0, '1' }, $ ;        1
                { CW_PDMENU_S,       0, '2' }, $ ;        2
                { CW_PDMENU_S,       0, '3' }, $ ;        3
                { CW_PDMENU_S,       2, '4' } $ ;      4
                ]

pdmenu_w = cw_pdmenu( base1, menu_desc_w, /return_full_name, $
                     uvalue='1')
slice_w = widget_label( base1, value='1')
;initializations for segmentation menu
nseg=intarr(3)
nseg(0)=1
nseg(1)=3
nseg(2)=5                        
files=strarr(23)
nsl=[[1,1,1],[3,3,3]]
nclass=[1,2,3]
sl_sl=[0,0,0]
seg_stat=[0,0]
menu_desc_w = [ $
                { CW_PDMENU_S,       3, 'Action' }, $ ;                            0
                { CW_PDMENU_S,       0, 'Read Raw Data' }, $ ;                     1
                { CW_PDMENU_S,       1, 'Make B0 map (Peak Pickers)' }, $ ;        2
                { CW_PDMENU_S,       0, 'Alger method' }, $ ;                      3
                { CW_PDMENU_S,       0, 'Duyn method' }, $ ;                       4
                { CW_PDMENU_S,       0, 'Water Peak (Frequency Domain)' }, $ ;     5
                { CW_PDMENU_S,       2, 'Water Peak (Time Domain)' }, $ ;          6
                { CW_PDMENU_S,       0, 'Do Time Domain Analysis' }, $ ;           7
                { CW_PDMENU_S,       0, 'Test Spectra' } $ ;                      8
                ]

pdmenu_action_w = cw_pdmenu( base1, menu_desc_w, /return_full_name, $
                     uvalue='pdmenu',ids=action_ids)

;Third row
base2 = widget_base(toplevel, /row) 

junk_w = CW_BGROUP(base2, /ROW, Label_left = 'Mode:',$
                   /EXCLUSIVE, /NO_REL, /RETURN_NAME, $
                   ['Edit', 'Point','Polygon', 'Rectangle', 'Circle'],$
                   set_value=0)

options_w = CW_BGROUP(base2, /ROW, /NO_RELEASE, /RETURN_NAME,  $
                      ['Clear', 'Clear All'],ids=optbut_ids)

menu_desc_w = [ $
                { CW_PDMENU_S,       1, 'Save' }, $ ;                         0
                { CW_PDMENU_S,       0, 'Position File' }, $ ;                    1
                { CW_PDMENU_S,       0, 'Time Domain Analysis Results' }, $ ; 2
                { CW_PDMENU_S,       0, 'ROI' }, $ ;                          3
                { CW_PDMENU_S,       0, 'PICT' } $ ;                          4
                ]
pdmenu_save_w = cw_pdmenu(base2,menu_desc_w,/return_full_name,ids=save_ids)
widget_control,save_ids(2),sensitive=0
widget_control,save_ids(3),sensitive=0
widget_control,save_ids(4),sensitive=0

menu_desc_w = [ $
                { CW_PDMENU_S,       1, 'Restore' }, $ ;                         0
                { CW_PDMENU_S,       0, 'Position File' }, $ ;                    1
                { CW_PDMENU_S,       0, 'Time Domain Analysis Results' }, $ ; 2
                { CW_PDMENU_S,       0, 'ROI' } $ ;                          3
                ]
pdmenu_restore_w = cw_pdmenu(base2,menu_desc_w,/return_full_name,ids=restore_ids)
widget_control,restore_ids(2),sensitive=0
widget_control,restore_ids(3),sensitive=0

tf_labels=['Frequency Domain Metabolite Maps','Time Domain Metabolite Maps']
tf_w = widget_button(base2,value=tf_labels(0),uvalue=0)

;Make buttons initially insensitive
widget_control,optbut_ids(1),sensitive=0 ;Clear all
widget_control,save_ids(3),sensitive=0 ;Save ROI
widget_control,save_ids(1),sensitive=0 ;Save Postitions

xy_pnts = widget_base(toplevel, /row,uvalue=0)   

;Draw widgets
toprow = WIDGET_BASE(toplevel, /ROW)
pix_vals_w=widget_base(toplevel,row=1,/align_right) ;data display
botrow = WIDGET_BASE(toplevel, /ROW)

topfl = WIDGET_BASE(toprow, /COLUMN)
mlabel_w = WIDGET_LABEL(topfl,value='          ')
twinfl = WIDGET_DRAW(topfl, XSIZE=256, YSIZE=256,colors=209,$
  /motion_events, /tracking_events, /button_events)

topnl = WIDGET_BASE(toprow, /COLUMN)
mlabel_w = [mlabel_w,WIDGET_LABEL(topnl,value='          ')]
twinnl = WIDGET_DRAW(topnl, XSIZE=256,ysize=256,$
                     /motion_events, /tracking_events, /button_events)

topnr = WIDGET_BASE(toprow, /COLUMN)
mlabel_w = [mlabel_w,WIDGET_LABEL(topnr,value='          ')]
twinnr = WIDGET_DRAW(topnr, XSIZE=256,ysize=256,$
                     /motion_events, /tracking_events, /button_events)

topfr = WIDGET_BASE(toprow, /COLUMN)
mlabel_w = [mlabel_w,WIDGET_LABEL(topfr,value='          ')]
twinfr = WIDGET_DRAW(topfr, XSIZE=256,ysize=256,$
                     /motion_events, /tracking_events, /button_events)

naav_w=cw_field(pix_vals_w,title='NAA:',value='    ',/noedit,/int,xsize=4)
crev_w=cw_field(pix_vals_w,title='CRE:',value='    ',/noedit,/int,xsize=4)
chov_w=cw_field(pix_vals_w,title='CHO:',value='    ',/noedit,/int,xsize=4)
;inov_w=cw_field(pix_vals_w,title='INO:',value='    ',/noedit,/int,xsize=4)
lacv_w=cw_field(pix_vals_w,title='LAC:',value='    ',/noedit,/int,xsize=4)
h2o1v_w=cw_field(pix_vals_w,title='H2O 1:',value='    ',/noedit,/long,xsize=8)
h2o2v_w=cw_field(pix_vals_w,title='H2O 2:',value='    ',/noedit,/long,xsize=8)
h2o3v_w=cw_field(pix_vals_w,title='H2O 3:',value='    ',/noedit,/long,xsize=8)
h2o4v_w=cw_field(pix_vals_w,title='H2O 4:',value='    ',/noedit,/long,xsize=8)
h2o5v_w=cw_field(pix_vals_w,title='H2O 5:',value='    ',/noedit,/long,xsize=8)
h2o6v_w=cw_field(pix_vals_w,title='H2O 6:',value='    ',/noedit,/long,xsize=8)

botfl = WIDGET_BASE(botrow, /COLUMN)
label1_w = WIDGET_LABEL(botfl, VALUE='                 MRI 1                 ')
bwinfl = WIDGET_DRAW(botfl, XSIZE=256,ysize=256,$
                     /motion_events, /tracking_events, /button_events)
btnrow(0)=widget_base(botfl,row=1)

botnl = WIDGET_BASE(botrow, /COLUMN)
label2_w = WIDGET_LABEL(botnl, VALUE='                 MRI 2                 ')
bwinnl = WIDGET_DRAW(botnl, XSIZE=256,ysize=256,$
                     /motion_events, /tracking_events, /button_events)
btnrow(1) = WIDGET_BASE(botnl, /ROW)

botnr = WIDGET_BASE(botrow, /COLUMN)
label3_w = WIDGET_LABEL(botnr, VALUE='                 MRI 3                 ')
bwinnr = WIDGET_DRAW(botnr, XSIZE=256, YSIZE=256,$
                     /motion_events, /tracking_events, /button_events)
btnrow(2) = WIDGET_BASE(botnr, /ROW)

glabels_w=[label1_w,label2_w,label3_w]
zoom = [1,1]
image_size = [256,256]
offset = [0,0]   

botfr = WIDGET_BASE(botrow, /COLUMN)
prspec_w = WIDGET_BUTTON(botfr, VALUE='Pixel Spectrum',$
            uvalue=['               Pixel Spectrum               ',$
                    '                ROI Spectrum                '])
bwinfr = WIDGET_DRAW(botfr, XSIZE=256, YSIZE=165)
mn=(spc_len-1)*(last_ppm_lf-paxis(0))/(paxis(spc_len-1)-paxis(0))
mx=(spc_len-1)*(last_ppm_rt-paxis(0))/(paxis(spc_len-1)-paxis(0))
slider_w = WIDGET_SLIDER(botfr, /DRAG, /FRAME, MAX=mx, MIN=mn, $
                       /SUPPRESS, scroll=1)
btnrow4 = WIDGET_BASE(botfr, ROW=3)

text0=strarr(3)
text0(0)='Left button - select a point'
text0(1)='Middle button - deselect point'
text0(2)='Right button - change to zap mode'

text1=strarr(3)
text1(0)='Left button - add to perimeter'
text1(1)='Middle button - remove a point'
text1(2)='Right button - enter roi'

text2=strarr(3)
text2(0)='Left button - add point'
text2(1)='Middle button - remove point'
text2(2)='Right button - toggle spectrum'

text3=strarr(3)
text3(0)='Press left button at corner'
text3(1)='Drag to opposite corner'
text3(2)='Right button - enter roi'

text4=strarr(3)
text4(0)='Press left button at center'
text4(1)='Drag to point on circumference'
text4(2)='Right button - enter roi'

text5=strarr(3)
text5(0)='Left button - zap point'
text5(1)='Middle button - zap column'
text5(2)='Right button - zap row'

msg_w = WIDGET_text(btnrow4, VALUE=text0,ysize=3)

; Modification
positions=replicate(-1,pe_dim(0),pe_dim(1))
mwids=[twinfl,twinnl,twinnr,twinfr]
gwids=[bwinfl,bwinnl,bwinnr]
swid=bwinfr

;Save current directory
widget_control, toplevel, /REALIZE
spawn,'pwd',old_dir
widget_control,read_w,set_uvalue=old_dir(0)

;get window # of spectrum window
widget_control, swid, GET_VALUE=swin

;get window #s of guide windows and create backing store and xrepair
;and yrepair
ngw=n_elements(gwids)
gwins=intarr(ngw)
gbacking=intarr(ngw)
xrepair=intarr(ngw)
yrepair=intarr(ngw)

FOR i = 0,ngw-1 DO BEGIN
    widget_control, gwids(i), GET_VALUE=dum
    gwins(i)=dum
    wset,dum
    WINDOW, /PIXMAP, /FREE, xs = !d.x_size, ys=!d.y_size ;Save window
    gbacking(i) = !d.window
    DEVICE, copy = [0,0, !d.x_size, !d.y_size, 0, 0, dum] ;Save it
; repair windows
    window, /free, xsize=17, ysize=3, /pixmap 
    xrepair(i) = !d.window
    window, /free, xsize=3, ysize=17, /pixmap 
    yrepair(i) = !d.window
ENDFOR

;get window #s of metabolite windows
nmw=n_elements(mwids) ;# of metabolite windows
mwins=intarr(nmw)
mbacking=intarr(nmw)
xrep=intarr(nmw)
yrep=intarr(nmw)
FOR i = 0,nmw-1 DO BEGIN
    widget_control, mwids(i), GET_VALUE=dum
    mwins(i)=dum
    wset,dum
    WINDOW, /PIXMAP, /FREE, xs = !d.x_size, ys=!d.y_size ;Save window
    mbacking(i) = !d.window
    DEVICE, copy = [0,0, !d.x_size, !d.y_size, 0, 0, dum] ;Save it
; repair windows
    window, /free, xsize=17, ysize=3, /pixmap 
    xrep(i) = !d.window
    window, /free, xsize=3, ysize=17, /pixmap 
    yrep(i) = !d.window
ENDFOR
xrepair=[xrepair,xrep]
yrepair=[yrepair,yrep]

backing=[gbacking,mbacking]
wids=[gwids,mwids]
wins=[gwins,mwins]
nw=nmw+ngw

;Make cursors
xcursor=bytarr(17,3)
xcursor(*,1)=100
xcursor(8,0)=100
xcursor(8,2)=100

WINDOW, /PIXMAP, /FREE, xs = 17, ys=3 ;x cursor window
tv,xcursor
xcur=!d.window

ycursor=transpose(xcursor)

WINDOW, /PIXMAP, /FREE, xs = 3, ys=17 ;y cursor window
tv,ycursor
ycur=!d.window

p  = offset + image_size /2   
version=0 ;default data version = 5.5
s = { defroi_struct, $          ;Structure containing state
      read_w: read_w, $         ;read_w widget id
      but_ids: but_ids, $       ;ids of individual buttons in read_w
      optbut_ids: optbut_ids, $ ;ids of individual buttons in options_w
      options_w: options_w, $   ;options_w widget id
      junk_w: junk_w, $         ;junk_w widget id
      prspec_w: prspec_w,$      ; spectrum window mode widget ID
      xy_pnts: xy_pnts, $       ;Current roi vertex list
      npts : 0L, $              ;# of points in current roi
      subs : thresh_w, $        ;Widget holding prev subscripts
      thresh_w:thresh_w,$       ;Threshold widget
      header_w: header_w,$      ;Show header info widget
      num1_w : num1_w, $        ;Number text widget
      slice_w : slice_w,$       ;id of slice widget
      pdmenu_w : pdmenu_w,$     ;id of pdmenu widget
      pdmenu_mri_w : pdmenu_mri_w,$ ;id of pdmenu widget for read mri
      pdmenu_set_w : pdmenu_set_w,$ ;id of pdmenu widget for settings window
      pdmenu_action_w : pdmenu_action_w,$ ;id of pdmenu widget for peak picker
      action_ids : action_ids,$ ;ids of buttons in action menu
      pdmenu_save_w: pdmenu_save_w,$ ;save pulldown menu
      save_ids: save_ids,$      ;ids of buttons in save puldown menu
      pdmenu_restore_w: pdmenu_restore_w,$ ;restore pulldown menu
      restore_ids: restore_ids,$ ;ids of buttons in restore pulldown menu
      pdmenu_seg_w : pdmenu_seg_w,$ ;id of pdmenu widget for segmentation
      dfilel_w : dfilel_w,$     ;id of raw data file label widget
      dfileb_w : dfileb_w,$     ;id of raw data file button widget
      slider_w : slider_w,$     ;id of slider widget
      msg_w : msg_w,$           ;id of message widget
      text0 : text0,$           ;text for message widget
      text1 : text1,$           ;text for message widget
      text2 : text2,$           ;text for message widget
      text3 : text3,$           ;text for message widget
      text4 : text4,$           ;text for message widget
      text5 : text5,$           ;text for message widget
      mets : [0,1,2,5],$        ;list of metabolites to plot
      crev_w : crev_w,$,        ;CRE value widget
      chov_w : chov_w,$,        ;CHO value widget
      naav_w : naav_w,$,        ;NAA value widget
      lacv_w : lacv_w,$,        ;LAC value widget
      inov_w : lacv_w,$,        ;INO value widget
      h2o1v_w : h2o1v_w,$,      ;H20 1 value widget
      h2o2v_w : h2o2v_w,$,      ;H20 2 value widget
      h2o3v_w : h2o3v_w,$,      ;H20 3 value widget
      h2o4v_w : h2o4v_w,$,      ;H20 4 value widget
      h2o5v_w : h2o5v_w,$,      ;H20 5 value widget
      h2o6v_w : h2o6v_w,$,      ;H20 6 value widget
      tf_w:tf_w,$               ;Frequency Domain/time domain switch
      tf_labels:tf_labels,$     ;Frequency Domain/time domain labels
      glabels_w:glabels_w,$     ;Label widgets of mri windows
      mlabel_w : mlabel_w,$     ;labels of metabolite windows      
      mode: 0, $                ;major mode, initialize to edit
      amode: 0, $               ;0 for add, 1 for remove
      smode: 0, $               ;0 for pixel, 1 for roi
      draw: wids,$              ;widget id's of draw widgets
      gbacking: gbacking ,$     ;backing windows of guide windows
      mbacking: mbacking ,$     ;backing windows of metabolite windows
      swin: swin, $             ;spectrum window #
      gwins: gwins, $           ;guide window window #s
      mwins: mwins, $           ;metabolite map window #s
      button: 0, $              ;button state
      image_size : long(image_size), $ ;Image array size
      offset: fix(offset), $    ;offset of array within window
      zoom : fix(zoom), $       ;zoom factor
      drag: [0,0],$             ;Beginning of drag motion
      skip:0, $                 ; Flag to skip initialization steps
      xsize:256, $              ; Window size in x-direction
      ysize:256, $              ; Window size in y-direction
      xrepair:xrepair, $        ; Window index number of horizontal repair window.
      yrepair:yrepair, $        ; Window index number of vertical repair window.
      leftEndx:0, $             ; X starting point of horizontal repair.
      rightEndx:0,$             ; X ending point of horizontal repair.
      botEndx:0, $              ; Y starting point of horizontal repair.
      topEndx:0, $              ; Y ending point of horizontal repair.
      leftEndy:0, $             ; X starting point of vertical repair.
      rightEndy:0,$             ; X ending point of vertical repair.
      botEndy:0, $              ; Y starting point of vertical repair.
      topEndy:0, $              ; Y ending point of vertical repair.
      xcur:xcur,$               ; number of window containing x cursor
      ycur:ycur}                ; number of window containing y cursor


x1=128
x2=128
wset,swin
comp_noise,/init
sumpeaks

widget_control,toplevel,/clear_events
XMANAGER, 'analyze_roi', toplevel

END
