pro comp_noise,init=init
;This program computes the rms power in mp_mrsi data sets
;The noise power is computed in the frequency domain. It is integrated
;over all frequencies and over an area consisting of four 4x4 pixel
;squares located at the four corners of the mrsi fovs. The noise in
;the frequency bands nominally corresponding to the naa, cre, and cho
;peaks is also computed.
;REVISION HISTORY
; 980723 asb Rescued from old files.
;            Rewrote code to initialize and store masks.
; 980723 asb Removed code dealing with noise in different
;            frequency bands.
; 980811 asb Removed code that writes in sumfile.
; 980915 ASB Replaced !csi_dat with fd_dat in COMMON freqdomain.
; 980915 ASB Added COMMON initcsi and removed system variables.
; 980916 ASB Changed name of COMMON freqdomain to mrsidata.

COMMON mrsidata
COMMON sumfile
COMMON noise
COMMON initcsi

IF keyword_set(init) THEN BEGIN
    ppm_to_point = spec_freq * spc_len/ sweep_width
;Make total noise mask
    totmask=intarr(spc_len,32,32) ; mask for selecting points
    wat_width=2.5               ;width to omit around water line
    wat_min=spc_len/2-ppm_to_point*wat_width ;indices to omit
    wat_max=spc_len/2+ppm_to_point*wat_width ;  around water line
;make mask for sum that only omits water line
    FOR i=0,3 DO BEGIN
        FOR j=0,3 DO BEGIN
            totmask(0:wat_min,i,j)=1 
            totmask(wat_max:spc_len-1,i,j)=1 
        ENDFOR
    ENDFOR
    FOR i=0,3 DO BEGIN
        FOR j=28,31 DO BEGIN
            totmask(0:wat_min,i,j)=1 
            totmask(wat_max:spc_len-1,i,j)=1 
        ENDFOR
    ENDFOR
    FOR i=28,31 DO BEGIN
        FOR j=0,3 DO BEGIN
            totmask(0:wat_min,i,j)=1 
            totmask(wat_max:spc_len-1,i,j)=1 
        ENDFOR
    ENDFOR
    FOR i=28,31 DO BEGIN
        FOR j=28,31 DO BEGIN
            totmask(0:wat_min,i,j)=1 
            totmask(wat_max:spc_len-1,i,j)=1 
        ENDFOR
    ENDFOR
    totnum=total(totmask)
    RETURN
ENDIF
narr=abs(fd_dat)^2            ;square magnitude of data

;Start general sum

rmsnoise=sqrt(total(totmask*narr)/totnum)

RETURN

END

