;This procedure handles events in point mode.
;Revision History
;09Aug96 ASB First SCCS version
;05Sep96 ASB Fixed bug involving rois containing one point.
;20Jul98 ASB Added toggle display for right button.
;30Jul98 ASB Added common roistats.
;            Changed logic for storing and recalling rois.      
pro dopoint,ev
COMMON defroi
COMMON posdata
COMMON roistats
;move cursors
move_cursors,ev,'WIDGET_DRAW'

CASE ev.press OF
    1: tmode = 0                ;add a point
    2: tmode = 1                ;remove a point
    4: BEGIN                 ;Toggle display

        IF count EQ 0 THEN RETURN
        s.smode=(s.smode+1) mod 2
;Change button value
        widget_control,s.prspec_w,get_uvalue=labels
        widget_control,s.prspec_w,set_value=labels(s.smode)
        update_specplot,cur_pos(0),cur_pos(1)
        RETURN                  
    END
    ELSE: RETURN
ENDCASE

n = s.npts ; # of points in roi

;Pixel coordinates

x=ev.x 
y=ev.y

if (x lt 0) or (y lt 0) or $            ;Within region?
    (x ge s.image_size(0)) or (y ge s.image_size(1)) THEN RETURN

dum32=intarr(32,32)
dum32(x/8,y/8)=2                ;dum32 = 0 except for current point
dum256=rebin(dum32,256,256,/sample) ;dum256 = 0 except for current point

widget_control,s.subs,get_uvalue=t256 ;ROI on high resolution images

IF (size(t32))(0) NE 0 THEN BEGIN
    dum256(t256)=dum256(t256)+1
    dum32(t32)=dum32(t32)+1
ENDIF
IF tmode THEN BEGIN             ;remove a point
    t256=where(dum256 eq 1)
    t32=where(dum32 eq 1,count)
ENDIF ELSE BEGIN                ;add a point
    t256=where(dum256 ge 1)
    t32=where(dum32 ge 1,count)
ENDELSE

widget_control,s.subs,set_uvalue=t256

;asb_defroi_update

repair_windows,ev            ;erase cursors before plotting roi

;asb_defroi_draw,-1,/fill

;asb_defroi_draw, n-1            ;Draw new point
;update roi
asb_defroi_nmode

load_repair,ev                  ;Update repair window
draw_cursors,ev                 ;restore cursors

RETURN

END
