;This subroutine uses Jeff Duyn's algorithm to find the naa peak.
;Revision History
;980915 ASB Removed code from analyze_roi.pro.
;980915 ASB Replaced !csi_dat with fd_dat in COMMON freqdomain.
;980916 ASB Changed name of COMMON freqdomain to mrsidata.
;981008 ASB Added code to make buttons sensitive.
;991222 ASB Added code to compute rsize and rleft from acquisition 
;           parameters.
pro duynpick

COMMON defroi
COMMON mrsidata
COMMON posdata
COMMON initcsi
COMMON mets

pt_per_hz = float(spc_len/sweep_width)

most_likely = long((spc_len/2.0) + $
                   (pt_per_hz*spec_freq*(h2o_shift-naa_shift)))
rsize=55                        ;width of region to search for peak in
rleft=most_likely-rsize/2       ;start of region to search for peak in

                                ;make mask for spectra with data based
                                ;on amplitude around water peak
mask=fltarr(32,32)
for i=210,289 do mask=mask+abs(fd_dat(i,*,*))
mask=byte(35.*mask/max(mask)<1.)
ampmax=1250
naa_pos=pq(1,ampmax,range=[rleft,rleft+rsize],mask)
position=0.0
ampnaa=0.0
valid=0
for i=11,20 do begin
    for j=11,20 do begin
        if (naa_pos(i,j) gt -1) then begin 
            valid=valid+1
            position=position+naa_pos(i,j)
            ampnaa=ampnaa+abs(fd_dat(naa_pos(i,j),i,j)) 
        endif
    endfor
endfor
position=position/valid
ampnaa=ampnaa/valid
print,position,ampnaa
positions=pq(ampnaa/10.,ampnaa*4,range=[position-22,position+16],mask)
widget_control,s.save_ids(1),sensitive=1 ;Save Positions
widget_control,s.save_ids(4),sensitive=1 ;Save Positions
widget_control,s.restore_ids(2),sensitive=1 ;Save Positions
widget_control,s.restore_ids(3),sensitive=1 ;Save Positions

RETURN
END
