;This function smoothes the peak position map.
;If an element has two or more sets of neighbors in a line, the elements is
;set equal to the average of those neighbors.
;If an element has 1 or no sets of neighbors in a line, but has a
;measured value itself, its value remains unchanged.
;All other elements are set to 0.

function filter_freq,data,mask

s=size(data)
m=dblarr(s(1),s(2))

m1 = shift(mask, 1, 0)+shift(mask,-1, 0)
ix=where(m1 GT 1)
m1(*,*)=0
m1(ix)=1

m2 = shift(mask, 0,-1)+shift(mask, 0, 1)
ix=where(m2 GT 1)
m2(*,*)=0
m2(ix)=1

m3 = shift(mask, 1, 1)+shift(mask,-1,-1)
ix=where(m3 GT 1)
m3(*,*)=0
m3(ix)=1

m4 = shift(mask, 1,-1)+shift(mask,-1, 1)
ix=where(m4 GT 1)
m4(*,*)=0
m4(ix)=1

d1 = shift(data, 1, 0)+shift(data,-1, 0)
d2 = shift(data, 0,-1)+shift(data, 0, 1)
d3 = shift(data, 1, 1)+shift(data,-1,-1)
d4 = shift(data, 1,-1)+shift(data,-1, 1)

xx=double(m1)*d1+double(m2)*d2+double(m3)*d3+double(m4)*d4
ddiv=double(m1+m2+m3+m4)*2.
ix=where(ddiv GT 3.)
xx(ix)=xx(ix)/ddiv(ix)

ix=where(ddiv le 3. and mask eq 1)
xx(ix)=data(ix)

RETURN,xx
END
