;This program makes a window displaying the information in the raw
;data header of mcpsi studies.
;Revision History
; 21Jul98 ASB First version
; 29Jul98 ASB Tightened format
; 16Sep98 ASB Removed references to system variables.
;             Added COMMON initcsi, header.
;  9Oct98 ASB Changed the size of some text widgets.

pro header_info_event,ih
COMMON head_inf
widget_control,inf_head.ih_base_w,/destroy
END

pro header_info,init=init
COMMON head_inf
COMMON initcsi
COMMON header
COMMON defroi
ih_base_w=widget_base(title='Header Information', column = 1)
IF NOT keyword_set(init) THEN widget_control,ih_base_w,group_leader=s.read_w
; top row 
labelq_w = CW_FIELD(ih_base_w, title='Study Site',VALUE=study.site)

row1 = widget_base(ih_base_w,row=1)
label0_w= CW_FIELD(row1, title='Patient Name:',value=patient.name,xsize=25)
label1_w= CW_FIELD(row1, title='Patient ID:',value=patient.id,xsize=13)
label2_w= CW_FIELD(row1, title='Age:',value=patient.age,xsize=3)
label3_w= CW_FIELD(row1, title='Sex:',value=patient.sex,xsize=1)
row2 = widget_base(ih_base_w,row=1)
label5_w= CW_FIELD(row2, title='Date:',value=study.date,xsize=8)
label6_w= CW_FIELD(row2, title='Time:',value=study.time,xsize=5)
label4_w= CW_FIELD(row2, title='History:',value=patient.Hx,xsize=61)
row3 = widget_base(ih_base_w,row=1)
label7_w= CW_FIELD(row3, title='Pulse Seq:',value=study.PSD,xsize=33)
label8_w= CW_FIELD(row3, title='Protocol:',value=study.routine,xsize=25)
label9_w= CW_FIELD(row3, title='Type:',value=study.desc,xsize=23)

row4 = WIDGET_BASE(ih_base_w, /ROW)
labe0_w = CW_FIELD(row4, title='Sweep Width(Hz):',value=sweep_width,xsize=8)
labe1_w = CW_FIELD(row4, title='Number of points per echo:',value=fid_len,xsize=4)

row5 = WIDGET_BASE(ih_base_w, /ROW)
foo_w = cw_field(row4, title='Shape of k-space region:',value='Circular',xsize=8)
labe2_w = CW_FIELD(row4, title='Resolution',value=pe_dim(0),xsize=3)

labe7_w = CW_FIELD(row4, title='Bytes per point',value=ptsize,xsize=1)

row6 = WIDGET_BASE(ih_base_w, /ROW)
labe3_w = CW_FIELD(row6, title='OVS Positions:',$
                   VALUE=STRING(FORMAT='(I4,I4,I4,I4,I4,I4,I4,I4)', $
                      ovs.b1,ovs.b2,ovs.b3,ovs.b4,ovs.t1,ovs.t2,ovs.t3,ovs.t4))
labe4_w = CW_FIELD(row6, title='Study angle:', value=ovs.angle,xsize=3)

row7 = WIDGET_BASE(ih_base_w, /ROW)
labe5_w = CW_FIELD(row7, title='Shim values',xsize=12,$
                   VALUE=STRING(FORMAT='( I4,I4,I4)',aps.xshim,aps.yshim,aps.zshim))
                                  
labe6_w = CW_FIELD(row7, title='Suppression params',xsize=10,$
                   VALUE=STRING(FORMAT='(I5,I5)',aps.ws,aps.sat))
            
ihquit_w=widget_button(ih_base_w,value='Quit')

inf_head={ ih_base_w:ih_base_w,$
           labelq_w: labelq_w, $ ;id of header ---- study site 
           label0_w: label0_w, $ ;id of header ---- patient name 
           label1_w: label1_w, $ ;id of header ---- patient ID 
           label2_w: label2_w, $ ;id of header ---- patient age 
           label3_w: label3_w, $ ;id of header ---- patient sex 
           label4_w: label4_w, $ ;id of header ---- patient history 
           label5_w: label5_w, $ ;id of header ---- study date 
           label6_w: label6_w, $ ;id of header ---- study time 
           label7_w: label7_w, $ ;id of header ---- study pulse seq 
           label8_w: label8_w, $ ;id of header ---- study protocol 
           label9_w: label9_w, $ ;id of header ---- study type 
           labe0_w: labe0_w, $  ;id of header ---- spectro sweep_width
           labe1_w: labe1_w, $  ;id of header ---- spectro points
           labe2_w: labe2_w, $  ;id of header ---- spectro resolutions
           labe3_w: labe3_w, $  ;id of header ---- spectro OVS pos.
           labe4_w: labe4_w, $  ;id of header ---- spectro angle
           labe5_w: labe5_w, $  ;id of header ---- spectro shim
           labe6_w: labe6_w, $  ;id of header ---- spectro supre. param
           labe7_w: labe7_w  $   ;id of header ---- bytes per point 
         }
widget_control,ih_base_w,/realize
IF keyword_set(init) THEN widget_control,ih_base_w,/destroy $
  ELSE XMANAGER, 'header_info', ih_base_w;Register widget

END
