;This procedure draws the metabolite maps.
;Revision history
; 15Jul98 ASB Removed from analyze_roi.
;             Changed color table logic to permit display with the
;             same CT as MRI's.
; 17Jul98 ASB Moved call to get width to sumpeaks.
; 21Jul98 ASB Added code to specify maximum pixel value.
; 22Jul98 ASB Added common block mets.
;             Added keywords replot, metabolite.
; 27Jul98 ASB Removed argument list from call to sumpeaks.
;  6Oct98 ASB Added code to display maps made from results of time domain analysis.
;  2Mar99 ASB Added water and B0 to list of metabolites.
;  1Apr99 ASB Debugged code for displaying water map in window 4.
; 10Sep99 ASB Changed logic for displaying time domain maps.
; 24Nov99 ASB Added code to compute h2o map 6 ways.

pro init_mets,event,replot_only=replot_only,metabolite=metabolite
COMMON posdata
COMMON defroi
COMMON dsettings
COMMON mets
COMMON initcsi
COMMON mrsidata

nw=n_elements(s.mwins)<n_elements(s.mets)
watmap=0
mwins=s.mwins
widget_control,s.tf_w,get_uvalue=flag
IF NOT keyword_set(replot_only) AND NOT flag THEN sumpeaks

FOR kk = 0,nw-1 DO BEGIN
IF n_elements(metabolite) NE 0 THEN IF s.mets(kk) NE metabolite THEN goto,ENDLOOP
    WSET, mwins(kk)
    print,'kk = ',kk,'  s.mets(kk) = ',s.mets(kk),' title(kk)= ',mettitles(s.mets(kk))
    widget_control,s.mlabel_w(kk),set_value=mettitles(s.mets(kk)) 
    CASE s.mets(kk) OF
        0: IF flag THEN BEGIN
            im=naa_td*zap_td<max_naa
        ENDIF ELSE BEGIN
            im=naa<max_naa
        ENDELSE

        1: IF flag THEN BEGIN
            im=cre_td*zap_td<max_cre
        ENDIF ELSE BEGIN
            im=cre<max_cre
        ENDELSE

        2: IF flag THEN BEGIN
            im=cho_td*zap_td<max_cho
        ENDIF ELSE BEGIN
            im=cho<max_cho
        ENDELSE

        3: IF flag THEN BEGIN
            im=bytarr(pe_dim(0),pe_dim(1))
            im(*)=1
        ENDIF ELSE BEGIN
            im=lac<max_lac
        ENDELSE

        4:IF flag THEN BEGIN
            im=bytarr(pe_dim(0),pe_dim(1))
            im(*)=1
        ENDIF ELSE BEGIN
            im=ino<max_ino
        ENDELSE

        5:im=h2o(*,*,0)
        
        6:im=h2o(*,*,1)
        
        7:im=h2o(*,*,2)
        
        8:im=h2o(*,*,3)
        
        9:im=h2o(*,*,4)
        
        10:im=h2o(*,*,5)
        
        11: BEGIN
            ppm_to_point = spec_freq * spc_len/ sweep_width
            b0max=(4.75-2.023+max_b0)*ppm_to_point+spc_len/2
            b0min=(4.75-2.0233+min_b0)*ppm_to_point+spc_len/2
            im=((positions-b0min)<b0max>0)/(b0max-b0min)
        END

    ENDCASE

    IF n_elements(event) NE 0 THEN BEGIN
        s.mwins=[mwins(kk)]
        repair_windows,event
        wset,mwins(kk)
    ENDIF
    IF tmode THEN BEGIN
        show,rebin(im,256,256,/sample),1,0,window=kk
    ENDIF ELSE BEGIN
        show,rebin(im,256,256,/sample),2,0,window=kk
    ENDELSE
;make backing store
    WINDOW, /PIXMAP, /FREE, xs = !d.x_size, ys=!d.y_size ;Save window
    s.mbacking(kk) = !d.window
    DEVICE, copy = [0,0, !d.x_size, !d.y_size, 0, 0, mwins(kk)] ;Save it
    IF n_elements(event) NE 0 THEN BEGIN
        load_repair,event
        draw_cursors,event
    ENDIF
    ENDLOOP:
ENDFOR
s.mwins=mwins
                           
END	; end of init_mets procedure
