PRO initcsi,threet=threet

;   SCCS Id: @(#)initcsi.pro	1.23	11/24/92
;
;  301289  GSS  First writing
;          GSS  Added '!last_ppm_left', '!last_ppm_right'
;          GSS  Added '!last_freq_left', '!last_freq_right'
;  010190  GSS  Added system variables:
;                 !csi_dat  - Time domain data
;                 !csi_im   - Transformed data
;                 !csi_aim  - Magnitude Transformed data
;                 !csi_file - Name of the input file
;                 !last_x_pos - X index of the last pixel displayed
;                 !last_y_pos - Y index of the last pixel displayed
;                 !last_x_fid - X index of the last FID displayed
;                 !last_y_fid - Y index of the last FID displayed
;  900108  GSS  Added zero-filling.  Changed system variables:
;                 !num_points -> !fid_len and !spc_len
;               Added 'nozf' keyword to prevent zero-filling.
;  900110  GSS  Added proton image stuff.
;  901018  GSS  Added SCCS keywords.
;  901024  GSS  Added '/ver'.
;  901025  GSS  Added various support for variable size arrays and
;               other flexability enhancements.
;  910226  GSS  Misc. changes.  Mostly substituted defaults
;               for prompts.
;  910302  GSS  Added keyword 'ppm_ref' to allow the user to
;               set the ppm scale up however they like.
;               'ppm_ref' is a two element vector.
;               The first element is the ppm value and the second
;               is the freqency value it applies to.  Zero freq. is
;               always at 'np/2'.
;               NOTE:  This code *should* be split out into a 
;               separate utility.
;               ALSO, added keyword 'ppm_range'.  This is an alternative
;               way to specify the sweep_width.  'ppm_range' overrides
;               the specified or default sweep width.  It aslo sets the
;               ppm axis to match.
;               Fixed the interaction between 'zf_mult' and 'no_zf'.
;               'zf_mult' overrides 'no_zf'.
;  910304  GSS  Modified system variable, '!last_phase' from a scalar
;               to a two element array of zero and first order phase angles
;               and the intercept of the first order line.
;               Added sys. var. '!ref_pos'.  It is a two element array
;               containing the indicies of two locations in the spectrum.
;               Also removed sys. var. '!echo_loc'.
;  980304  Qin Sys. var !last_ppm_rt, _lt, _low, _up can be redefined
;               in settings button.
;  980414  Qin  Added !naa_scale_max sys var to control meta. wins.
;  980428  Qin  Deleted !rawdata_path, created !csi_ver
;  980721  ASB  Removed system variables !last_ppm_low, !last_pm_up,
;               and !naa_scale_max. created sysvar !max_spec_val
;  980915  ASB  Changed all system variables to common block elements.
;               Removed keywords sw, ppm_range.
;               Removed most keywords.
;  980916  ASB  Changed name of COMMON freqdomain to mrsidata.
;  990812  ASB  Added code to initialize td_dat.
;  991123  ASB  Added code to initialize td_dat1.
;  991222  ASB  Added code to handle 3T data.
COMMON initcsi
COMMON mrsidata
; *** Set the spectrometer frequency and echo position ***
IF keyword_set(threet) THEN BEGIN
sweep_width=2000.
fid_len=512
echo_pt=256
spec_freq=126.0
ENDIF ELSE BEGIN
sweep_width=1000.
fid_len=256
echo_pt=128
spec_freq=63.0
ENDELSE

IF ( echo_pt GT fid_len ) THEN echo_pt = fid_len
IF ( echo_pt LT 0 )       THEN echo_pt = 0

;*******   Display SCCS Version   *******
IF keyword_set( ver ) THEN BEGIN
   print, 'Current SCCS Version for "initcsi": 1.23 - 11/24/92'
   return
END

;Set default slice

cur_slice=1

; *** Get the Zero-filling and fid/spc lenghts ***

pe_dim = intarr(2)
pe_dim(0) = 32
pe_dim(1) = 32

pe_dim = fix(abs(pe_dim))


; *** Set the spatial dimensions ***
sp_dim = pe_dim ;  No zero-filling on the phase-encode axis

ppm_offset=4.75

spc_len=fid_len * 2
freq_axis = ((-1*indgen(spc_len))/float(spc_len)+0.5)*sweep_width
paxis=freq_axis/spec_freq + ppm_offset

last_ppm_rt=0.0   ; spectrum win: xmin
last_ppm_lf=4.0

max_spec_val=10000.0

ref_pos=[0, 0]

csi_dat=complexarr(spc_len, pe_dim(0), pe_dim(1))
csi_dat1=csi_dat
fd_dat=csi_dat
fd_dat1=fd_dat
td_dat=csi_dat
td_dat1=csi_dat
rawdata_path = ''

END  ; 'initcsi'
