pro slabstart_event,ev
COMMON slabstart,slbase_w,slstart_w,start

widget_control,slstart_w,get_value=start
widget_control,slbase_w,/destroy

END

function slabstart
COMMON slabstart
slbase_w=widget_base(col=1)
slstart_w=cw_field(slbase_w,/int,title='First slice in lowest slab',value=1)
slquit_w=widget_button(slbase_w,value='Quit')

widget_control,slbase_w,/clear_events,/realize
XMANAGER, 'slabstart', slbase_w,/modal
RETURN,start
END

;This function makes sensitivity maps for all classes and all slices.
pro mk_sens_maps
COMMON seg
;Read in segmented images, if necessary
IF seg_stat(0) EQ 0 THEN rd_seg_ims
apd=2
xres=256
yres=256
n_slices=23
n_slabs=4
nclasses=3
;slice_maps and slab_maps are initialized in rd_seg_images
;Initial slice weights. Get better values later using slice profile
start=slabstart()-1
slice_weights=fltarr(n_slabs,n_slices)
slice_weights(0,start:start+4)=0.2
slice_weights(1,start+6:start+10)=0.2
slice_weights(2,start+12:start+16)=0.2
slice_weights(3,start+18:start+22)=0.2

FOR class=1,nclasses DO BEGIN
    FOR slice=0,n_slices-1 DO BEGIN
        dummy=fltarr(xres,yres)
        index=where(seg_ims(*,*,slice) EQ class)
        IF index(0) NE -1 THEN BEGIN
            dummy(index)=1
            slice_maps(*,*,class-1,slice)=convolve_seg(dummy,2)
            FOR slab = 0,3 DO BEGIN
                IF slice_weights(slab,slice) NE 0 THEN BEGIN
                    slab_maps(*,*,class-1,slab)=slab_maps(*,*,class-1,slab)+$
                      slice_maps(*,*,class-1,slice)*slice_weights(slab,slice)
                ENDIF
            ENDFOR
        ENDIF
    ENDFOR
ENDFOR
seg_stat(1)=1
END

