;Programs to draw and move cursors at the same position in multiple
;windows.
;Revision History
;09Aug96 ASB First SCCS version

pro repair_windows,event
;This precedure removes the cursors from the windows
COMMON defroi

widget_control,event.id,get_value=curwin
wins=[s.gwins,s.mwins]
FOR kk = 0,n_elements(wins)-1 DO BEGIN
    IF wins(kk) NE curwin THEN BEGIN
        wset, wins(kk)
        Device, Copy=[0, 0, s.rightEndx-s.leftEndx+1,$
                      s.topEndx-s.botEndx+1,$
                      s.leftEndx, s.botEndx, s.xrepair(kk)],set_g=3
        Device, Copy=[0, 0, s.rightEndy-s.leftEndy+1,$
                      s.topEndy-s.botEndy+1,$
                      s.leftEndy, s.botEndy, s.yrepair(kk)],set_g=3
    ENDIF
ENDFOR

RETURN
END

pro load_repair,event,debug=debug
;This procedure stores the data needed to remove the cursors and
;restore the windows
COMMON defroi
widget_control,event.id,get_value=curwin

                                ; Update structure.

s.botEndy = (event.y - 8)>0
s.topEndy = (event.y + 8)<(s.ysize-1)
s.leftEndy = (event.x - 1)>0
s.rightEndy = (event.x + 1)<(s.xsize-1)

s.botEndx = (event.y - 1)>0
s.topEndx = (event.y + 1)<(s.ysize-1)
s.leftEndx = (event.x - 8)>0
s.rightEndx = (event.x + 8)<(s.xsize-1)
s.skip = 0

wins=[s.gwins,s.mwins]

FOR kk = 0,n_elements(wins)-1 DO BEGIN        
    IF wins(kk) NE curwin THEN BEGIN
        wset, s.xrepair(kk)
        Device, Copy=[s.leftEndx, s.botEndx, $
                      s.rightEndx-s.leftEndx+1,s.topEndx-s.botEndx+1, $
                      0, 0, wins(kk)],set_g=3
        WSet, s.yrepair(kk)
        Device, Copy=[s.leftEndy, s.botEndy, $
                      s.rightEndy-s.leftEndy+1,s.topEndy-s.botEndy+1, $
                      0, 0, wins(kk)],set_g=3
    ENDIF
ENDFOR

RETURN
END

pro draw_cursors,event
;This procedure draws the cursors
COMMON defroi
widget_control,event.id,get_value=curwin
wins=[s.gwins,s.mwins]
FOR kk = 0,n_elements(wins)-1 DO BEGIN
    IF wins(kk) NE curwin THEN BEGIN
        wset, wins(kk)
        Device, Copy=[0, 0, s.rightEndx-s.leftEndx+1,$
                      s.topEndx-s.botEndx+1,$
                      s.leftEndx, s.botEndx, s.xcur],set_g=3
        Device, Copy=[0, 0, s.rightEndy-s.leftEndy+1,$
                      s.topEndy-s.botEndy+1,$
                      s.leftEndy, s.botEndy, s.ycur],set_g=3
    ENDIF
ENDFOR

RETURN
END


pro move_cursors,event,thisEvent
;This proceedure moves the cursors in all of the draw windows
COMMON  defroi

IF thisEvent EQ 'WIDGET_TRACKING' THEN BEGIN
    If event.enter EQ 1 THEN BEGIN ; Coming into window for first time.
        s.skip = 1
        RETURN
    ENDIF ELSE BEGIN            ; Leaving window for last time. Repair the last damage.
        repair_windows,event
    ENDELSE                     ;event.enter eq 0
ENDIF ELSE BEGIN                ;endif thisevent eq widget_tracking

    IF (event.x LT 0) OR (event.y LT 0) OR $ ;Within region?
      (event.x GE s.image_size(0)) OR (event.y GE s.image_size(1)) THEN RETURN
    
    IF NOT s.skip THEN BEGIN    ;Initialize repair windows
        repair_windows,event
    ENDIF                       ; NOT s.skip
                                ; Calculate new ends of cursor.
    

                                 ; Load repair pixmaps.
    load_repair,event

                                ; Draw the cursors.
    
    draw_cursors,event
ENDELSE
RETURN
END
