;This program handles events generated by widgets added by Jianging Qin.
;VERSION SUMMARY
; 8 May 98 QIN First version
; 17Jul 98 ASB Fixed bug that caused program to crash if image didn't exist.
; 21Jul 98 ASB Added code to prevent crash when next or previous
;              button is pushed and no image has been selected.
; 12Aug 98 ASB Changed mess_widget to report_error.
; 28Aug98 ASB Combined bt11, bt21, and bt31 into array bt1.
;             Combined bt12, bt22, and bt32 into array bt2.
; 22Feb00 ASB Added print statements for debugging.
pro mri_action,event
common mri_act
common defroi

Widget_Control, event.id
mri_dim=256
CASE event.id OF

    bt1(0): IF n_elements(filename1) NE 0 THEN BEGIN ;next image, mri window 1
        mri_name=filename1
        d1=byte(mri_name)
        szd1=(size(d1))
        d1(szd1(1)-5)=d1(szd1(1)-5)+byte(1)
        IF d1(szd1(1)-5) EQ 58 THEN BEGIN
            d1(szd1(1)-5) = 48
            d1(szd1(1)-6) = d1(szd1(1)-6)+1
        ENDIF

        IF d1(szd1(1)-6) EQ 58 THEN BEGIN
            d1(szd1(1)-6) = 48
            d1(szd1(1)-7) = d1(szd1(1)-7)+1
        ENDIF
        IF d1(szd1(1)-7) le 57 THEN BEGIN
            mri_name=string(d1)
            ln=strlen(mri_name)-5
            fn=string(d1(0:ln))
            spawn,'if(-e '+fn+') echo 1',res
            IF res(0) EQ 1 THEN BEGIN
                filename1= mri_name
                read_mri,-1
            ENDIF ELSE report_error,'FILE '+fn+' does not exist' 
        ENDIF
    ENDIF

    bt2(0): IF n_elements(filename1) NE 0 THEN BEGIN ;previous image, mri window 1
            mri_name=filename1
            d1=byte(mri_name)
            szd1=(size(d1))
            d1(szd1(1)-5)=d1(szd1(1)-5)-byte(1)
            IF d1(szd1(1)-5) EQ 47 THEN BEGIN
                d1(szd1(1)-5) = 57
                d1(szd1(1)-6) = d1(szd1(1)-6)-1
            ENDIF

            IF d1(szd1(1)-6) EQ 47 THEN BEGIN
                d1(szd1(1)-6) = 57
                d1(szd1(1)-7) = d1(szd1(1)-7)-1
            ENDIF
            IF d1(szd1(1)-7) ge 48 THEN BEGIN
                mri_name=string(d1)
                ln=strlen(mri_name)-5
                fn=string(d1(0:ln))
                spawn,'if(-e '+fn+') echo 1',res
                IF res(0) EQ 1 THEN BEGIN
                    filename1= mri_name
                    read_mri,-1
                ENDIF ELSE report_error,'FILE '+fn+' does not exist' 
            ENDIF
    ENDIF

    bt1(1): IF n_elements(filename2) NE 0 THEN BEGIN ;next image, mri window 2
        mri_name=filename2
        d1=byte(mri_name)
        szd1=(size(d1))
        d1(szd1(1)-5)=d1(szd1(1)-5)+byte(1)
        IF d1(szd1(1)-5) EQ 58 THEN BEGIN
            d1(szd1(1)-5) = 48
            d1(szd1(1)-6) = d1(szd1(1)-6)+1
        ENDIF

        IF d1(szd1(1)-6) EQ 58 THEN BEGIN
            d1(szd1(1)-6) = 48
            d1(szd1(1)-7) = d1(szd1(1)-7)+1
        ENDIF
        IF d1(szd1(1)-7) le 57 THEN BEGIN
            mri_name=string(d1)
            ln=strlen(mri_name)-5
            fn=string(d1(0:ln))
            spawn,'if(-e '+fn+') echo 1',res
            print,'res = ',res
            IF res(0) EQ 1 THEN BEGIN
                filename2= mri_name
                read_mri,-2
            ENDIF ELSE report_error,'FILE '+fn+' does not exist' 
        ENDIF
    ENDIF

    bt2(1): IF n_elements(filename2) NE 0 THEN BEGIN ;previous image, mri window 2
        mri_name=filename2
        d1=byte(mri_name)
        szd1=(size(d1))
        d1(szd1(1)-5)=d1(szd1(1)-5)-byte(1)
        IF d1(szd1(1)-5) EQ 47 THEN BEGIN
            d1(szd1(1)-5) = 57
            d1(szd1(1)-6) = d1(szd1(1)-6)-1
        ENDIF

        IF d1(szd1(1)-6) EQ 47 THEN BEGIN
            d1(szd1(1)-6) = 57
            d1(szd1(1)-7) = d1(szd1(1)-7)-1
        ENDIF
        IF d1(szd1(1)-7) ge 48 THEN BEGIN
            mri_name=string(d1)
            ln=strlen(mri_name)-5
            fn=string(d1(0:ln))
            spawn,'if(-e '+fn+') echo 1',res
            print,'res = ',res
            IF res(0) EQ 1 THEN BEGIN
                filename2= mri_name
                read_mri,-2
            ENDIF ELSE report_error,'FILE '+fn+' does not exist' 
        ENDIF
    ENDIF

    bt1(2): IF n_elements(filename3) NE 0 THEN BEGIN ;next image, mri window 3
        mri_name=filename3
        d1=byte(mri_name)
        szd1=(size(d1))
        d1(szd1(1)-5)=d1(szd1(1)-5)+byte(1)
        IF d1(szd1(1)-5) EQ 58 THEN BEGIN
            d1(szd1(1)-5) = 48
            d1(szd1(1)-6) = d1(szd1(1)-6)+1
        ENDIF

        IF d1(szd1(1)-6) EQ 58 THEN BEGIN
            d1(szd1(1)-6) = 48
            d1(szd1(1)-7) = d1(szd1(1)-7)+1
        ENDIF
        IF d1(szd1(1)-7) le 57 THEN BEGIN
            mri_name=string(d1)
            ln=strlen(mri_name)-5
            fn=string(d1(0:ln))
            spawn,'if(-e '+fn+') echo 1',res
            IF res(0) EQ 1 THEN BEGIN
                filename3= mri_name
                read_mri,-3
            ENDIF ELSE report_error,'FILE '+fn+' does not exist' 
        ENDIF
    ENDIF

    bt2(2): IF n_elements(filename3) NE 0 THEN BEGIN ;previous image, mri window 3
        mri_name=filename3
        d1=byte(mri_name)
        szd1=(size(d1))
        d1(szd1(1)-5)=d1(szd1(1)-5)-byte(1)
        IF d1(szd1(1)-5) EQ 47 THEN BEGIN
            d1(szd1(1)-5) = 57
            d1(szd1(1)-6) = d1(szd1(1)-6)-1
        ENDIF

        IF d1(szd1(1)-6) EQ 47 THEN BEGIN
            d1(szd1(1)-6) = 57
            d1(szd1(1)-7) = d1(szd1(1)-7)-1
        ENDIF
        IF d1(szd1(1)-7) ge 48 THEN BEGIN
            mri_name=string(d1)
            ln=strlen(mri_name)-5
            fn=string(d1(0:ln))
            spawn,'if(-e '+fn+') echo 1',res
            IF res(0) EQ 1 THEN BEGIN
                filename3= mri_name
                read_mri,-3
            ENDIF ELSE report_error,'FILE '+fn+' does not exist' 
        ENDIF
    ENDIF

ENDCASE

END
