;This program creates a dialog box for naming the segment data file.
;Revision History
;09Aug96 ASB First SCCS version
;29Jan97 ASB Added code to name 3 files instead of 1
;                .txt for data, 
;                .sth for integration width
;                .roi for roi
;                 Known bug-- only tests for existance of .txt file
;16Sep98 ASB Removed !slice, added COMMON initcsi.
;23Feb00 ASB Changed code that calls qfile.
pro name_segfile_event,event
COMMON segfile
COMMON initcsi

;print,new_name_w,old_name_w,buttons_w,done_w
;print,tag_names(event)
;print,event
;put new name of old file in text window iff choice=0

CASE event.id OF
    new_name_w: BEGIN
        widget_control,new_name_w,get_value=new_name
        spawn,getenv('SPECHOME')+'/qfile '+new_name(0)+'.txt',res
        IF res(0) EQ 1 THEN BEGIN  ;file exists
            w_text=['File '+new_name+ ' exists.                  ',$
                    'Rename or choose option before clicking Done.']
            widget_control,message_w,set_value=w_text
            widget_control,buttons_w,/sensitive
            widget_control,buttons_w,get_value=choice
            IF choice EQ 0 THEN BEGIN
                widget_control,old_name_w,get_uvalue=dummy
                widget_control,old_name_w,set_value=dummy
                widget_control,old_name_w,/sensitive
            ENDIF ELSE BEGIN
                widget_control,old_name_w,sensitive=0
                widget_control,old_name_w,set_value=''
            ENDELSE
        ENDIF ELSE BEGIN        ;file doesn't exist
            w_text=['Enter new segfile name or click done.',$
                    '                                             ']
            widget_control,message_w,set_value=w_text
            widget_control,old_name_w,sensitive=0
            widget_control,buttons_w,sensitive=0
            widget_control,old_name_w,set_value=''
        ENDELSE           
    END
    
    old_name_w: BEGIN
        widget_control,old_name_w,get_value=old_name
        widget_control,old_name_w,set_uvalue=old_name
    END
    
    buttons_w: BEGIN
        widget_control,buttons_w,get_value=choice
        IF choice EQ 0 THEN BEGIN ;rename file
            widget_control,old_name_w,/sensitive
            widget_control,old_name_w,get_uvalue=dummy
            widget_control,old_name_w,set_value=dummy
        ENDIF ELSE BEGIN ;overwrite or append
            widget_control,old_name_w,sensitive=0
            widget_control,old_name_w,set_value='                  '
        ENDELSE
    END

    done_w: BEGIN
        widget_control,new_name_w,get_value=new_name
        print,'new_name=',new_name
        spawn,getenv('SPECHOME')+'/qfile '+new_name(0)+'.txt',res
        print,'res=',res
        IF res(0) EQ 1 THEN BEGIN ;file exists
            widget_control,buttons_w,get_value=choice
            help,choice
            CASE choice OF
                0: BEGIN ;rename old file
                    widget_control,old_name_w,get_uvalue=old_name
                    spawn,getenv('SPECHOME')+'/qfile '+old_name(0)+'.txt',res
                    IF res(0) EQ 1 THEN BEGIN ;file exists
                        w_text=['File '+old_name+ ' exists.                 ',$
                                'Choose another name or another action       ']
                        widget_control,message_w,set_value=w_text
                        widget_control,old_name_w,/sensitive
                        widget_control,buttons_w,/sensitive
                    ENDIF ELSE BEGIN ;file doesn't exist
                        spawn,'mv '+new_name(0)+'.txt '+old_name(0)+'.txt
                        spawn,'mv '+new_name(0)+'.wth '+old_name(0)+'.wth
                        spawn,'mv '+new_name(0)+'.roi '+old_name(0)+'.roi
                        apend=0
                        segfile=[new_name(0)+'.txt',new_name(0)+'.wth',$
                                 new_name(0)+'.roi']
                        widget_control,base_w,/destroy
                    ENDELSE
                END
                
                1: BEGIN
                    widget_control,new_name_w,get_value=new_name
                    segfile=[new_name(0)+'.txt',new_name(0)+'.wth',$
                             new_name(0)+'.roi']
                    apend=0
                    widget_control,base_w,/destroy
                END
                
                2: BEGIN
                    widget_control,new_name_w,get_value=new_name
                    segfile=[new_name(0)+'.txt',new_name(0)+'.wth',$
                             new_name(0)+'.roi']
                    apend=1
                    widget_control,base_w,/destroy
                END
            ENDCASE
        ENDIF ELSE BEGIN
            segfile=[new_name(0)+'.txt',new_name(0)+'.wth',$
                     new_name(0)+'.roi']
            apend=0
            widget_control,base_w,/destroy
        ENDELSE
    END        
ENDCASE

END

pro name_segfile
;This program queries for the name of the new segfile.
;If a file already exists with the chosen name, it issues a warning
;and gives the user a choice choosing another name of the new segfile,
;renaming the old segfile, overwriting the old segfile, or appending
;to the old segfile.
COMMON segfile
  
base_w=widget_base(title='Name segfile',/column)


message=['Enter name of segfile.                       ',$
         '                                             ']
  
message_w=widget_text(base_w,value=message,ysize=2,xsize=50)

new_segfile='seg_data'+strtrim(string(cur_slice),2)
new_name_w=cw_field(base_w,title='Segfile name:',value=new_segfile,/frame,/return,xsize=30)

choose_w=widget_base(base_w,/row)
old_segfile='seg_data'+strtrim(string(cur_slice),2)

buttons_w=cw_bgroup(choose_w,/exclusive,$
                     [ 'Rename old file ',$
                       'Overwrite ',$
                      'Append '])
                        

space_w=widget_base(choose_w,/column)

old_name_w=widget_text(space_w,value='                    ',uvalue=old_segfile,ysize=1,/editable)
widget_control,old_name_w,sensitive=0

widget_control,buttons_w,set_value=2
widget_control,buttons_w,sensitive=0

done_w=widget_button(base_w,value='Done')                   

widget_control,new_name_w,get_value=new_name
spawn,getenv('SPECHOME')+'/qfile '+new_name(0)+'.txt',res
IF res(0) EQ 1 THEN BEGIN       ;file exists
    w_text=['File ' +new_name+ '.txt exists.                  ',$
            'Rename or choose option before clicking Done.']
    widget_control,message_w,set_value=w_text
    widget_control,buttons_w,/sensitive
    widget_control,buttons_w,get_value=choice
ENDIF ELSE BEGIN                ;file doesn't exist
    w_text=['Enter new segfile name or click done.',$
            '                                             ']
    widget_control,message_w,set_value=w_text
ENDELSE           

widget_control,base_w,/realize

xmanager,'name_segfile',base_w,/modal
RETURN
END
