;This program creates a dialog box for naming the summary file.
;Revision History
;09Aug96 ASB First SCCS version
;18Jul97 ASB Added code to write 2 digit slice number for 3dcsi data
;16Sep98 ASB Replaced !slice with cur_slice, added COMMON initcsi.
; 3Mar99 ASB Changed test for Adelstein sequence, removing reference to psd_w.
;23Feb00 ASB Changed code that calls qfile.
pro name_sumfile_event,event
COMMON sumfile
COMMON initcsi

;print,new_name_w,old_name_w,buttons_w,done_w
;print,tag_names(event)
;print,event
;put new name of old file in text window iff choice=0

CASE event.id OF
    new_name_w: BEGIN
        widget_control,new_name_w,get_value=new_name
        spawn,getenv('SPECHOME')+'/qfile '+new_name(0),res
        IF res(0) EQ 1 THEN BEGIN  ;file exists
            w_text=['File '+new_name+ ' exists.                  ',$
                    'Rename or choose option before clicking Done.']
            widget_control,message_w,set_value=w_text
            widget_control,buttons_w,/sensitive
            widget_control,buttons_w,get_value=choice
            IF choice EQ 0 THEN BEGIN
                widget_control,old_name_w,get_uvalue=dummy
                widget_control,old_name_w,set_value=dummy
                widget_control,old_name_w,/sensitive
            ENDIF ELSE BEGIN
                widget_control,old_name_w,sensitive=0
                widget_control,old_name_w,set_value=''
            ENDELSE
        ENDIF ELSE BEGIN        ;file doesn't exist
            w_text=['Enter new sumfile name or click done.',$
                    '                                             ']
            widget_control,message_w,set_value=w_text
            widget_control,old_name_w,sensitive=0
            widget_control,buttons_w,sensitive=0
            widget_control,old_name_w,set_value=''
        ENDELSE           
    END
    
    old_name_w: BEGIN
        widget_control,old_name_w,get_value=old_name
        widget_control,old_name_w,set_uvalue=old_name
    END
    
    buttons_w: BEGIN
        widget_control,buttons_w,get_value=choice
        IF choice EQ 0 THEN BEGIN
            widget_control,old_name_w,/sensitive
            widget_control,old_name_w,get_uvalue=dummy
            widget_control,old_name_w,set_value=dummy
        ENDIF ELSE BEGIN
            widget_control,old_name_w,sensitive=0
            widget_control,old_name_w,set_value='                  '
        ENDELSE
    END

    done_w: BEGIN
        widget_control,new_name_w,get_value=new_name
        print,'new_name=',new_name
        spawn,getenv('SPECHOME')+'/qfile '+new_name(0),res
        print,'res=',res
        IF res(0) EQ 1 THEN BEGIN ;file exists
            widget_control,buttons_w,get_value=choice
            help,choice
            CASE choice OF
                0: BEGIN
                    widget_control,old_name_w,get_uvalue=old_name
                    spawn,getenv('SPECHOME')+'/qfile '+old_name(0),res
                    IF res(0) EQ 1 THEN BEGIN ;file exists
                        w_text=['File '+old_name+ ' exists.                 ',$
                                'Choose another name or another action       ']
                        widget_control,message_w,set_value=w_text
                        widget_control,old_name_w,/sensitive
                        widget_control,buttons_w,/sensitive
                    ENDIF ELSE BEGIN ;file doesn't exist
                        spawn,'mv '+new_name(0)+' '+old_name(0)
                        append=0
                        sumfile=new_name(0)
                        widget_control,base_w,/destroy
                    ENDELSE
                END
                
                1: BEGIN
                    widget_control,new_name_w,get_value=new_name
                    sumfile=new_name(0)
                    append=0
                    widget_control,base_w,/destroy
                END
                
                2: BEGIN
                    widget_control,new_name_w,get_value=new_name
                    sumfile=new_name(0)
                    append=1
                    widget_control,base_w,/destroy
                END
            ENDCASE
        ENDIF ELSE BEGIN
            sumfile=new_name(0)
            append=0
            widget_control,base_w,/destroy
        ENDELSE
    END        
ENDCASE

END

pro name_sumfile
;This program queries for the name of the new sumfile.
;If a file already exists with the chosen name, it issues a warning
;and gives the use a choice choosing another name of the new sumfile,
;renaming the old sumfile, overwriting the old sumfile, or appending
;to the old sumfile.
COMMON sumfile
COMMON defroi
COMMON initcsi
  
base_w=widget_base(title='Name sumfile',/column)


message=['Enter name of sumfile.                       ',$
         '                                             ']
  
message_w=widget_text(base_w,value=message,ysize=2,xsize=50)

IF version EQ 6 THEN BEGIN
    IF cur_slice LE 9 THEN strn='0'+strtrim(cur_slice,2) ELSE $
      strn=strtrim(cur_slice,2)
ENDIF ELSE strn=strtrim(cur_slice,2)

new_sumfile='sl'+strn+'.sum'
new_name_w=cw_field(base_w,title='Sumfile name:',value=new_sumfile,/frame,/return,xsize=30)

choose_w=widget_base(base_w,/row)
old_sumfile='sl'+strn+'.sum'

buttons_w=cw_bgroup(choose_w,/exclusive,$
                     [ 'Rename old file ',$
                       'Overwrite ',$
                      'Append '])
                        

space_w=widget_base(choose_w,/column)

old_name_w=widget_text(space_w,value='                    ',uvalue=old_sumfile,ysize=1,/editable)
widget_control,old_name_w,sensitive=0

widget_control,buttons_w,set_value=2
widget_control,buttons_w,sensitive=0

done_w=widget_button(base_w,value='Done')                   

widget_control,new_name_w,get_value=new_name
spawn,getenv('SPECHOME')+'/qfile '+new_name(0),res
IF res(0) EQ 1 THEN BEGIN       ;file exists
    w_text=['File '+new_name+ ' exists.                  ',$
            'Rename or choose option before clicking Done.']
    widget_control,message_w,set_value=w_text
    widget_control,buttons_w,/sensitive
    widget_control,buttons_w,get_value=choice
ENDIF ELSE BEGIN                ;file doesn't exist
    w_text=['Enter new sumfile name or click done.',$
            '                                             ']
    widget_control,message_w,set_value=w_text
ENDELSE           

widget_control,base_w,/realize

xmanager,'name_sumfile',base_w,/modal
RETURN
END
