;
;  This code is for Jeff Dyun's peak algorithm
;
;980915 ASB Replaced !csi_dat with fd_dat in COMMON freqdomain
;980915 ASB Added COMMON initcsi and removed system variables.
;980916 ASB Changed name of COMMON freqdomain to mrsidata.
;990812 ASB Added code to prevent crash when data are bad.

FUNCTION pq, noise, maxs, range=range, plot=plot,mask
COMMON mrsidata
COMMON initcsi
IF ( keyword_set( range ) AND (n_elements(range) EQ 2) ) THEN BEGIN
   left = range(0)
   right = range(1)
END ELSE BEGIN
   left = 1319
   right = 1410
END
cho_offset = -162
cre_offset = -135
lac_offset = 83

naa_pos = lonarr( sp_dim(0), sp_dim(1) )
val = lonarr( sp_dim(0),sp_dim(1))
val = long(((mask+shift(mask,1,1)+shift(mask,-1,-1))) GT 0)
n = right - left + 1

lines_found = 0


FOR j = 0, sp_dim(1)-1 DO BEGIN
   FOR i = 0, sp_dim(0)-1 DO BEGIN

      region = abs( fd_dat( left:right, i, j ) )

      biggest = where( region EQ max(region) )
      biggest = biggest(0)

      IF ( (region(biggest) GT noise) AND (region(biggest) LT maxs) AND $
        (abs(fd_dat(biggest+left-4,i,j)) LT max(region)/1.5)  AND (abs(fd_dat(biggest+left+4,i,j)) LT max(region)/1.5) AND $
           (biggest LT n-3) AND (biggest GT 2) AND (val(i,j) EQ 1)$
      ) THEN BEGIN

         IF keyword_set( plot ) THEN BEGIN
            pplot, i, j
            naa_ppm = paxis( biggest + left )
            cho_ppm = paxis( biggest + left + cho_offset )
            cre_ppm = paxis( biggest + left + cre_offset )
            plots, /data, [naa_ppm, naa_ppm], !y.crange
            plots, /data, [cho_ppm, cho_ppm], !y.crange
            plots, /data, [cre_ppm, cre_ppm], !y.crange
            plots, /data, [lac_ppm, lac_ppm], !y.crange
            wait, 0.5
         END

         naa_pos(i,j) = biggest + left
         lines_found = lines_found + 1

      END ELSE BEGIN

         naa_pos(i,j) = -1

      END
   END
END
tvscl,naa_pos

valid = where( (naa_pos NE -1) and (val EQ 1) )

IF lines_found NE 0 THEN BEGIN
    mean_naa_pos = float( total( naa_pos(valid) ) ) / float(lines_found)
ENDIF ELSE mean_naa_pos=0

print, lines_found, ' valid naa lines found inside brain.'
print, 'Mean naa position = ', mean_naa_pos

!p.multi = [0,1,2]

;*****  Plot Peak Scattergram:

amp = 0
pos = 0
for k=0,2 DO BEGIN
FOR j = 1, sp_dim(1)-2 DO BEGIN
   FOR i = 1, sp_dim(0)-2 DO BEGIN
         dum=0
         cnt=0
      IF (naa_pos(i,j) NE -1.0 AND (k EQ 0)) THEN BEGIN
         amp = [ amp, abs(fd_dat(naa_pos(i,j),i,j)) ]
         pos = [ pos, naa_pos(i,j) ]
      ENDIF
      IF (naa_pos(i,j) EQ -1.0 ) THEN BEGIN
         IF val(i,j) eq 0 THEN BEGIN  ; was 0
;            naa_pos(i,j) = mean_naa_pos
            naa_pos(i,j) = -1
         END ELSE BEGIN
            IF ( naa_pos(i-1,j) NE -1.0 ) THEN BEGIN            
               dum=dum+naa_pos(i-1,j)
               cnt=cnt+1
            END
            IF ( naa_pos(i+1,j) NE -1.0 ) THEN BEGIN            
               dum=dum+naa_pos(i+1,j)
               cnt=cnt+1
            END 
            IF ( naa_pos(i,j-1) NE -1.0 ) THEN BEGIN            
               dum=dum+naa_pos(i,j-1)
               cnt=cnt+1
            END
            IF ( naa_pos(i,j+1) NE -1.0 ) THEN BEGIN            
               dum=dum+naa_pos(i,j+1)
               cnt=cnt+1
            END
            IF cnt GT 0 THEN BEGIN
                naa_pos(i,j)=dum/cnt
            END
          END
      ENDIF
   END
END
END

window,0
wset,0
amp = amp(1:*)
pos = pos(1:*)

plot_io, pos, amp, psym=1, xstyle=1, xran=[left, right], $
         xtit='NAA Peak Position', ytit='NAA Peak Intensity', $
         tit = 'Scatter Plot of NAA Peak Instnsity vs. Position'

;*****  Plot Peak Position Histogram:

wset,0
plot, indgen( n )+left, xstyle=1, $
      histogram( naa_pos(valid), min=left, max=right ), $
      tit = 'Histogram of Valid NAA Line Positions', $
      xtit = 'NAA Peak Position', ytit='Occurences'

!p.multi = 0

RETURN, naa_pos

END
