;This program reads class images stored as 3d arrays and combines them
;to form segmented images.
;Revision History
; 990924 First version.
pro rd_class_vols
COMMON seg
COMMON defroi
xres=256
yres=256
n_slabs=4

;Choose a file for class 1
file=pickfile(filter='*seg*.img')

;extract root and generate filenames for other classes
len=strlen(file)
root=strmid(file,0,len-5)

;get length of file
openr,unit,file,/g
len=(fstat(unit)).size
free_lun,unit

;compute number of slices
n_slices=len/xres/yres

;make list of files
flist=findfile(root+'*img')
nclasses=n_elements(flist)

;allocate memory for class image
class=bytarr(256,256,n_slices)

;allocate memory for segmented image
seg_ims=class

;read volumes and make segmented images
FOR kk=1,n_elements(flist) DO BEGIN
    openr,unit,flist(kk-1),/g
    readu,unit,class
    free_lun,unit
    list=where(class GT 127)
    CASE kk OF
        1: seg_ims(list)=2
        2: seg_ims(list)=1
        ELSE: seg_ims(list)=kk
    ENDCASE
ENDFOR

seg_stat(0)=1
seg_stat(1)=0

;Initialize sensitivity maps
slice_maps=fltarr(32,32,nclasses,n_slices)
slab_maps=fltarr(32,32,nclasses,n_slabs)

files(0)='Class volume'
files(1)=root

RETURN
END

