;This program reads the default file ~/.Specdefaults
;Revision History
; 05Sep96 ASB First version
; 29Jan97 ASB Added default value for binwidth.
;             Changed code to use defaults if
;             ~/.Specdefaults exists, but is incomplete.
; 27Feb98 ASB Added default values for sapd_defs, tapd_defs,
;             sapd, tapd, filt_sym.  Doesn't read these from 
;             .Specdefaults yet.
; 18Sep98 ASB Added tdomain.
; 14Oct98 ASB Removed mrimin,mrimax.
; 10OCT99 ASB Added tapd1.
; 27Oct99 ASB Changed defaults for FERMI filter.
; 18May00 ASB Lengthened sapd_defs and tapd_defs.
;             Changed default value of tapd to 9.

pro rddefaults
COMMON defaults
file='~/.Specdefaults'

roivolmin=50
ct=0
binwidth=0.25
roiname='r1'
crechosep=0.5
chonoi=0.25
naanoi=0.25

spawn,'if(-e '+file+')echo 1',tmp 
IF tmp(0) EQ 1 THEN BEGIN
    spawn,'set foo = `grep "^ *MRImin " '+file+'`;echo $foo',tmp
    IF (size(tmp))(0) NE 0 THEN BEGIN
        spawn,'set foo = `grep "^ *MRImin " '+file+'`;echo $foo[2]',tmp
        reads,tmp,mrimin
        mrimin=fix(mrimin)
    ENDIF

    spawn,'set foo = `grep "^ *MRImax " '+file+'`;echo $foo',tmp
    IF (size(tmp))(0) NE 0 THEN BEGIN
        spawn,'set foo = `grep "^ *MRImax " '+file+'`;echo $foo[2]',tmp
        reads,tmp,mrimax
        mrimax=fix(mrimax)
    ENDIF

    spawn,'set foo = `grep "^ *ROIvolmin " '+file+'`;echo $foo',tmp
    IF (size(tmp))(0) NE 0 THEN BEGIN
        spawn,'set foo = `grep "^ *ROIvolmin " '+file+'`;echo $foo[2]',tmp
        reads,tmp,roivolmin
        roivolmin=fix(roivolmin)
    ENDIF

    spawn,'set foo = `grep "^ *CT " '+file+'`;echo $foo',tmp
    IF (size(tmp))(0) NE 0 THEN BEGIN
        spawn,'set foo = `grep "^ *CT " '+file+'`;echo $foo[2]',tmp
        reads,tmp,ct
        ct=fix(ct)
    ENDIF

    spawn,'set foo = `grep "^ *BINwidth " '+file+'`;echo $foo',tmp
    IF (size(tmp))(0) NE 0 THEN BEGIN
        spawn,'set foo = `grep "^ *BINwidth " '+file+'`;echo $foo[2]',tmp
        reads,tmp,binwidth
        binwidth=float(binwidth)
    ENDIF

    spawn,'set foo = `grep "^ *ROIname " '+file+'`;echo $foo',tmp
    IF (size(tmp))(0) NE 0 THEN BEGIN
        spawn,'set foo = `grep "^ *ROIname " '+file+'`;echo $foo[2]',tmp
        roiname=tmp(0)
    ENDIF

    spawn,'set foo = `grep "^ *CRECHOsep " '+file+'`;echo $foo',tmp
    IF (size(tmp))(0) NE 0 THEN BEGIN
        spawn,'set foo = `grep "^ *CRECHOsep " '+file+'`;echo $foo[2]',tmp
        reads,tmp,crechosep
        crechosep=float(crechosep)
    ENDIF

    spawn,'set foo = `grep "^ *CHOnoi " '+file+'`;echo $foo',tmp
    IF (size(tmp))(0) NE 0 THEN BEGIN
        spawn,'set foo = `grep "^ *CHOnoi " '+file+'`;echo $foo[2]',tmp
        reads,tmp,chonoi
        chonoi=float(chonoi)
    ENDIF

    spawn,'set foo = `grep "^ *NAAnoi " '+file+'`;echo $foo',tmp
    IF (size(tmp))(0) NE 0 THEN BEGIN
        spawn,'set foo = `grep "^ *NAAnoi " '+file+'`;echo $foo[2]',tmp
        reads,tmp,naanoi
        naanoi=float(naanoi)
    ENDIF

ENDIF 

;Not included in default file yet
sapd_defs=[[0.,0.],$
              [0.,0.],$
              [0.,0.],$
              [0.,0.],$
              [3.125,0.],$
              [0.75,0.2],$
              [50.,0.],$
              [1.,0.],$
              [0.5,0.],$
              [0.5,0.]]

tapd_defs=sapd_defs
tapd1_defs=tapd_defs
sapd=2
tapd=9
tapd1=9
filtsym=1                       ;circular
tdomain=0

END
