;This procedure reads an mri and loads it into mri(*,*,number)
;Revision History
;09Aug96 ASB First SCCS version
;04Mar98 Qin Added avg. spectrum cal. in call to sumpeaks
;14Mar98 Qin Removed the line: cd,new_dir(0) so that the data I* can
;            be read from any directories
;26May98 QIN Added common block mri_act
;            Changed logic for initial directory
;            Added logic to store filename
;22Jul98 ASB Removed superfluous call to sumpeaks.
;            Removed commented out lines.
;            Changed capitalization.
;            Changed indentation.
;            Removed COMMON dum.
;23Jul98 ASB Added code to draw roi on new image.
;24Jul98 ASB Changed code to redraw roi only on mris.
;28Aug98 ASB Added imtype(number)=0.
;15Sep98 ASB Added COMMON initcsi, eliminated system variables.
; 9Oct98 ASB Fixed bug in code if filename is not picked.
; 3Mar99 ASB Added COMMON mask.
;            Removed keywords pmin and pmax from call to update window.
;            Added code to control sensitivity of buttons that
;            select image used for masking.
;11Aug99 ASB Added code to swap bytes of mris.

pro read_mri,number
COMMON defroi
COMMON posdata
COMMON mri_act
COMMON initcsi
COMMON mask
COMMON dsettings

IF number GE 0 THEN BEGIN
    IF strlen(rawdata_path) lt 1 THEN BEGIN
        filename=pickfile(filter='I.*',get_path=qqq)
        IF filename EQ '' THEN RETURN
        rawdata_path=qqq
    ENDIF ELSE BEGIN
        filename=pickfile(filter='I.*',path=rawdata_path)
        IF filename EQ '' THEN RETURN
    ENDELSE
    IF number eq 0 THEN filename1=filename
    IF number eq 1 THEN filename2=filename
    IF number eq 2 THEN filename3=filename
ENDIF ELSE BEGIN
    IF number eq -1 THEN mmm=filename1
    IF number eq -2 THEN mmm=filename2
    IF number eq -3 THEN mmm=filename3
    filename=strmid(mmm,0,strlen(mmm)-4)
    number = -(number + 1) 
ENDELSE

imtype(number)=0
spawn,'set foo = '+filename+';echo $foo:h',new_dir
; *******      Qin removed this line: cd,new_dir(0)
IF strpos(filename,'.sft') EQ -1 THEN BEGIN 
    mri(*,*,number)=shift(rdsigna(file=filename),4,4)
    IF number eq 0 or number eq -1 THEN filename1=filename + '.sft
    IF number eq 1 or number eq -2 THEN filename2=filename + '.sft
    IF number eq 2 or number eq -3 THEN filename3=filename + '.sft
ENDIF ELSE mri(*,*,number)=rdsigna(file=filename)
IF xregistered('mask') NE 0 THEN $
  IF total(mri(*,*,number)) NE 0 THEN widget_control,gids(number+1),/sensitive

sfile=shorten_filename(filename)
widget_control,s.glabels_w(number),set_value=sfile
IF bswap(number) THEN BEGIN
    tmp=mri(*,*,number)
    byteorder,tmp
    mri(*,*,number)=tmp
ENDIF
update_window,number
mm=s.mode
s.mode=0
asb_defroi_draw,fill=2
s.mode=mm
RETURN
END
