;This program calls pickfile to read the name of a raw data file.
;Revision History
;09Aug96 ASB First SCCS version.
;18Jul97 ASB Aded code to read 3dcsi data
;14Apr98 Qin Removed two lines: cd,new_dir(0)  so that can read raw_file
;            from any directory.
;28Apr98 Qin Added logic to save file name
;24Jul98 ASB Added code to read raw file header.
;15Sep98 ASB Added COMMON initcsi, eliminated system variables.
; 9Oct98 ASB Added code to read lx headers.
; 3Mar99 ASB Removed reference to s.psd_w.

function read_raw_name
COMMON defroi
COMMON initcsi

IF version EQ 6 THEN BEGIN
    csifile=pickfile(filter='*.ica.t',title='Choose data file')
    IF csifile EQ '' THEN BEGIN
        RETURN,-1 
    ENDIF ELSE BEGIN
                                ;Update label widget
        widget_control,s.dfilel_w,set_value=csifile,set_uvalue='new'
                                ;Set slice
        spawn,'set num = '+csifile+'; set num = $num:r; set num = $num:r;'+$
          'set num = $num:e;echo $num',num 
        slnum=0
        reads,num,slnum
        cur_slice=slnum
        widget_control,s.slice_w,set_value=strtrim(string(slnum),2)
                                ;Change to patient directory
        spawn,'set foo = '+csifile+';echo $foo:h',new_dir
        
                                ;cd,new_dir(0)
                                ;save new dir name
        widget_control,s.read_w,set_uvalue=new_dir(0) 
                                ;Generate position file name
                                ;Find location of string Pxxxxx
        
        spawn,'set foo = '+csifile+';echo $foo:t',root_name
        len=strpos(root_name(0),'.ic')
        root_name=strmid(root_name(0),0,len)
        pos_name=root_name+'.pos'
        widget_control,s.slice_w,set_uvalue=pos_name
                                ;Label file as new
        widget_control,s.run_ids(0),sensitive=1
    ENDELSE
ENDIF ELSE BEGIN
    IF strlen(rawdata_path) LT 1 THEN BEGIN
        print,'1------rawdata_path = ',rawdata_path
        fn=pickfile(filter='*.mpcsi',title='Choose raw data file',get_path=wdata_path)
        rawdata_path=wdata_path
        print,'2-----rawdata_path = ',wdata_path
    ENDIF ELSE BEGIN 
        fn=pickfile(filter='*.mpcsi',title='Choose raw data file',path=rawdata_path)
    ENDELSE
    print,'rawdata_path = ',rawdata_path
    IF fn EQ '' THEN BEGIN
        RETURN,-1 
    ENDIF ELSE BEGIN
        csi_file=fn
        CASE version OF
            0: read_raw_header
            5: read_raw_header,/lx
            ELSE:
        ENDCASE
        
        pos=strpos(fn,'.mpcsi')
        csifile=strmid(fn,0,pos)
                                ;Update label widget
        widget_control,s.dfilel_w,set_value=csifile,set_uvalue='new'
                                ;Change to patient directory
        spawn,'set foo = '+fn+';echo $foo:h',new_dir
        
                                ;cd,new_dir(0)
                                ;save new dir name
        widget_control,s.read_w,set_uvalue=new_dir(0) 
                                ;Get slice number
                                ;Generate position file name
        spawn,'set foo = '+csifile+';echo $foo:t',root_name
        widget_control,s.slice_w,get_value=slice_str
        pos_name=root_name(0)+'_sl_'+slice_str+'.pos
        widget_control,s.slice_w,set_uvalue=pos_name
                                ;Label file as new
;        widget_control,s.run_ids(0),sensitive=1
    ENDELSE
    RETURN,0

ENDELSE
END
