;This procedure restores the results of the time domain analysis.
;Revision History
; 981009 ASB First version.
; 990303 ASB Added code to check if tdfile exists.
;            Added code to call pickfile if tdfile doesn't exist.

pro restore_td
COMMON mrsidata
COMMON defroi
COMMON initcsi

widget_control,s.slice_w,get_uvalue=tdfile
loc=strpos(tdfile,'pos')
strput,tdfile,'tdd',loc
widget_control,s.read_w,get_uvalue=new_dir
cd,new_dir

;Check to see if file exists

spawn,'if (-e '+tdfile+') echo 1',foo
IF foo(0) EQ 1 THEN BEGIN
    restore,tdfile
ENDIF ELSE BEGIN
    tdfile=pickfile(filter='*.tdd')
    spawn,'if (-f '+tdfile+') echo 1',foo
    IF foo(0) NE 1 THEN RETURN
    restore,tdfile
ENDELSE

;Make metabolite maps from time domain results
naa_td=sqrt(xm(*,*,0)^2+xm(*,*,1)^2)
cho_td=sqrt(xm(*,*,2)^2+xm(*,*,3)^2)
cre_td=sqrt(xm(*,*,4)^2+xm(*,*,5)^2)

;Reconstruct fitted spectra
Kmax=20 
ndata=fid_len-2
fndata=ndata-2*Kmax
t= (dindgen(2*ndata) - echo_pt) / double(sweep_width)
tin=[t(Kmax:ndata-Kmax-1),t(ndata+Kmax:2*ndata-Kmax-1)]

index=where(naa_td NE 0)
ns=n_elements(index)
IF index(0) EQ -1 THEN RETURN
fit_dat=complexarr(spc_len,pe_dim(0),pe_dim(1))
FOR kk=0,ns-1 DO BEGIN
    i1 = index(kk) mod pe_dim(0)
    i2 = index(kk) / pe_dim(0)

    funct, 10,tin, reform(xm(i1,i2,*)), xfit
    cyfit=dcomplex( xfit(0:fndata-1),xfit(fndata:fndata*2-1) )
    
    tmp=complexarr(spc_len)
    tmp(0)=cyfit
    tmp=shift(tmp,-fndata/2)
    fit_dat(*,i1,i2)=shift(fft(tmp),spc_len/2)
ENDFOR

;display time domain maps and spectra
tdflag=1
IF n_elements(width_w) EQ 1 THEN IF widget_info(width_w,/valid)$
  THEN widget_control,width_w,map=0
widget_control,s.tf_w,set_value=s.tf_labels(1),set_uvalue=1
init_mets
clear_roi

;if roi exists, display it
widget_control,s.num1_w,get_value=count
;IF count GT 0 THEN asb_defroi_draw,fill=3
IF n_elements(stats_w) EQ 1 THEN IF widget_info(stats_w,/valid) EQ 1 $
  THEN asb_defroi_update

RETURN
END
