;This program reads the raw data for Jan Willem's Time domain analysis
;program.
;Revision History

;            Added COMMON initcsi.
;            Removed commented out lines.
;            Removed superfluous code for generating filename.
;            Added COMMON header.
;            Removed logic for FAST acquisition.
; 980921 ASB Renormalized 32 bint data.
;            Replaced keywords with COMMON defaults.
PRO ride1, filename, $
           mpcsi=mpcsi,$
           lx=lx,$
           list=list,foo=foo

COMMON initcsi
COMMON header
COMMON mrsidata
COMMON defaults

headlen=39940
IF keyword_set(lx) THEN headlen=headlen+44
numslices=4

;*******   Create Filename   *******

extension = '.mpcsi'
csi_file = filename+extension

openr,unit,csi_file,/get        ;open file
point_lun,unit,headlen

raw_len = fid_len*2
IF ptsize EQ 4 THEN BEGIN       ;32 bit data
    nul_fid = lonarr( raw_len )
    raw_fid = lonarr( raw_len )
    csi_dat = dcomplex(csi_dat)
    print, 'Reading integer (32 bit) data.'
ENDIF ELSE BEGIN                ;16 bit data
    nul_fid = intarr( raw_len )
    raw_fid = intarr( raw_len )
    csi_dat = complex(csi_dat)
    print, 'Reading integer (16 bit) data.'
ENDELSE

index = indgen( fid_len ) * 2

                                ;*******   Read Raw Integer Data from File   *******
                                ;********* Clear Data Array ***

print, 'Zeroing data array...'

print, 'Reading and converting datafile...'
print, format='( "+", ' + string(pe_dim(1)-2) + '("-"), "+" )'
FOR i=0,skip-1 DO readu, unit, raw_fid
ymax=float(pe_dim(1)-1.0)/2.0
xmax=float(pe_dim(0)-1.0)/2.0
idm1=0
idm2=0
;d4=[4,2,1,3]                    ;order of slices
d4=[1,3,2,4]
list=intarr(772)
kkk=0
ll=0
FOR j = 0, pe_dim(1)-1 DO BEGIN
    rady=(float(j)-ymax)*(float(j)-ymax)/(ymax*ymax)
    print, format='( $, "*" )'
    FOR i = 0, pe_dim(0)-1 DO BEGIN
        idm2=idm2+1
        radius=rady+((float(i)-xmax)*(float(i)-xmax)/(xmax*xmax))
        IF radius LT 1.01 THEN BEGIN
            FOR k1=0,etl-1 DO FOR k2 = 0,d4(mpcsi-1)-2 DO readu, unit, raw_fid
            FOR kk=0,echo-1 DO readu, unit, raw_fid
            list(ll)=kkk
            ll=ll+1
            idm1=idm1+1
            csi_dat( 0, i, j ) = dcomplex( raw_fid(index), raw_fid(index+1) )
            FOR kk=0,etl-1-echo DO readu, unit, raw_fid
            FOR k1=0,etl-1 DO $
              FOR k2 = 0,numslices-1-d4(mpcsi-1) DO readu, unit, raw_fid
        ENDIF
        kkk=kkk+1
    ENDFOR
ENDFOR

IF ptsize EQ 4 THEN csi_dat=csi_dat/2l^16

print, 'pe_dim(0),pe_dim(1),raw_len', pe_dim(0),pe_dim(1),raw_len 
print
close,unit                      ;close file
free_lun,unit			;free logical unit number

;*******  Extract Selected Header Fields:

print, 'Extracting fields from header...'

RETURN

END
