pro save_pict_event,event
;VERSION 1.1
; ASB  8AUG95 First version
; ASB  1Feb96 Modified to include only three mris; Shifted sampled
; metabolite maps
; ASB  18JUL97 Changed to write two digit slice for 3dcsi
; QIN  30Apr98 Added code to save average spectrum.
; ASB  27Jul98 Removed arguments and keyword in call to sumpeaks.
;              Added COMMON mets.
; ASB   7Aug98 Added COMMON roistats.
;              Changed name of name_w in COMMON save_pict to pictname_w.
;              Removed call to s.width_w.
;              Changed text of some options bottons.
;              Removed call to sumpeaks.
;              Changed code for plotting spectra.
;              Added "Show integration limits" button.
;              Changed logic for keeping track of button state.
;              Made code for storing metabolite maps work with new
;              color tables.
; ASB  11Aug98 Fixed bug in option to smooth roi on metabolite map.
; ASB  16Sep98 Replaced !slice with cur_slice, added COMMON initcsi.
; ASB  18Nov98 Get psdtype from version (defroi)
; ASB   3Mar99 Changed logic for controlling windowing.
; ASB  24Mar99 Fixed bug in saving ROI average spectra.
; ASB   2Sep99 Fixed bug in test for Adalsteinsson's sequence.
; ASB   3Sep99 Fixed bug in rescaling guide images.
; ASB  14Sep99 Changed appearance.
;              Added options to save metabolite maps from time domain processing.
; ASB  23Feb00 Changed calls to qfile to make code more portable.

COMMON seg
COMMON posdata
COMMON defroi
COMMON grid
COMMON pictfile,pictfile,old_pictfile,buttons_w,new_name_w,pdone_w,pbase_w,message_w
COMMON save_pict,base_w,spmri_w,spfd_w,sptd_w,spseg_w,spsp_w,done_w,pictname_w,options_w
COMMON mets
COMMON dsettings
COMMON roistats
COMMON initcsi
COMMON mrsidata
files=['.mri1.PICT','.mri2.PICT','.mri3.PICT',$
       '.cho.PICT','.cre.PICT','.naa.PICT','.lac.PICT',$
       '.naa%cho.PICT','.naa%cre.PICT','.cho%cre.PICT','.naa%lac.PICT',$
       '.td_cho.PICT','.td_cre.PICT','.td_naa.PICT',$
       '.td_naa%cho.PICT','.td_naa%cre.PICT','.td_cho%cre.PICT',$
       '.seg1.PICT','.seg2.PICT','.seg3.PICT','.spec','.spectd']
       
IF version EQ 6 THEN BEGIN ;Adalsteinsson
    IF cur_slice LE 9 THEN strn='0'+strtrim(cur_slice,2) ELSE $
      strn=strtrim(cur_slice,2)
ENDIF ELSE strn=strtrim(cur_slice,2)

print,'save_pict_event called: event = ',event
print,tag_names(event)

CASE event.id OF
    pictname_w : widget_control,pictname_w,get_value=filename

    spmri_w: 
    spfd_w: 
    sptd_w: 
    spseg_w: 
    spsp_w: 
    options_w:

    done_w: BEGIN
;Get name of initial directory
        spawn,'pwd',new_dir
        widget_control,s.read_w,get_uvalue=old_dir,/hourglass
;Plot which windows
        widget_control,spmri_w,get_value=dummy ; mris
        widget_control,spfd_w,get_value=foo ;maps from FD analysis
        dummy=[dummy,foo]
        widget_control,sptd_w,get_value=foo ;maps from TD analysis
        dummy=[dummy,foo]
        widget_control,spseg_w,get_value=foo ;segmented images
        dummy=[dummy,foo]
        widget_control,spsp_w,get_value=foo ;spectra
        dummy=[dummy,foo]
        
;Plot options
        widget_control,options_w,get_value=option
;Root of PICT files
        widget_control,pictname_w,get_value=name
        device,set_graphics=3
;Get ROIs (low resolution)
        widget_control, s.subs, GET_UVALUE=t256
        lroi=intarr(32,32)
        IF (size(t32))(0) EQ 1 THEN lroi(t32)=1
        lroi=rebin(lroi,256,256,/samp)
;Get ROIs (high resolution)
        hroi=intarr(256,256)
        IF (size(t256))(0) EQ 1 THEN hroi(t256)=1
;Smooth ROIs in MRIs
        IF option(1) EQ 1 THEN BEGIN
            groi=hroi
        ENDIF ELSE BEGIN
            groi=lroi
        ENDELSE
        IF option(2) EQ 0 THEN BEGIN ; Fill in region
            t=where(groi eq 1)
        ENDIF ELSE BEGIN ; Show outline
            groi=roberts(float(groi)) ;use edge enhancement to generate outline
            t=where(groi NE 0)
        ENDELSE
;Save guide windows        
        FOR kk=0,2 DO BEGIN ; Guide images
            IF dummy(kk) EQ 1 THEN BEGIN
                image=reform(mri(*,*,kk),256,256);get image
;Set windowing for display
                mmax=max(image)*(max_v(kk)/100.)
                mmin=max(image)*(min_v(kk)/100.)

                show,image<mmax>mmin,1,0,im=im,/nodisplay,nogrid=option(0)
;plot,roi
                IF (size(t))(0) NE 0 THEN BEGIN
                    IF option(5) EQ 0 THEN BEGIN
                        im(t)=im(t)+100
                    ENDIF ELSE BEGIN
                        im(t)=150
                    ENDELSE
                ENDIF
                pictfile='sl'+strn+'.'+strtrim(name(0))+files(kk)
;Test to see if file exists
		pictfile=old_dir+'/'+pictfile
                spawn,getenv('SPECHOME')+'/qfile '+pictfile,res
                IF res(0) EQ 1 THEN rename_pictfile ;file exists                    
                write_pict,pictfile,im
            ENDIF ;dummy(kk) eq 1
        ENDFOR
;Smooth ROIs in metabolite maps?
        IF option(3) EQ 1 THEN BEGIN
            mroi=hroi
        ENDIF ELSE BEGIN
            mroi=lroi
        ENDELSE
        IF option(6) EQ 0 THEN BEGIN
            t=where(mroi eq 1)
        ENDIF ELSE BEGIN ; IF outline wanted, use edge enhancement
            mroi=roberts(float(mroi))
            t=where(mroi NE 0)
        ENDELSE
        FOR kk=3,6 DO BEGIN ;fd metabolite maps
            IF dummy(kk) EQ 1 THEN BEGIN
                CASE kk OF
                    3:image=cho<max_cho
                    4:image=cre<max_cre
                    5:image=naa<max_naa
                    6:image=lac<max_lac
                ENDCASE ;kk
;make metabolite map
                IF option(4) EQ 0 THEN image=rebin(image,256,256,/sample) $
                ELSE image=shift(rebin(image,256,256),4,4)

                IF tmode THEN show,image,1,0,/nodisplay,im=im,nogrid=option(3)$
                ELSE show,image,2,0,/nodisplay,im=im,nogrid=option(3)

;draw roi on metabolite map
                IF (size(t))(0) EQ 1 THEN BEGIN
                    IF option(6) THEN BEGIN
                        IF tmode THEN im(t)=150 $
                        ELSE im(t)=50
                    ENDIF ELSE BEGIN
                        IF tmode THEN im(t)=im(t)+100 $
                        ELSE im(t)=im(t)-100
                    ENDELSE
                ENDIF
                pictfile='sl'+strn+'.'+strtrim(name(0))+files(kk)

;Test to see if file exists
		pictfile=old_dir+'/'+pictfile
                spawn,getenv('SPECHOME')+'/qfile '+pictfile,res
                IF res(0) EQ 1 THEN rename_pictfile ;file exists                    
                write_pict,pictfile,im
            ENDIF ;dummy(kk) eq 1
        ENDFOR ; kk=3,6

        FOR kk=7,10 DO BEGIN ;fd metabolite ratio maps
            IF dummy(kk) EQ 1 THEN BEGIN
                CASE kk OF
                    7:BEGIN
                        ll=where(cho NE 0)
                        lm=where(cho eq 0)
                        im=cho
                        tmp=bytscl(float(naa(ll))/cho(ll),top=99)+102
                        im(ll)=tmp
                        im(lm)=101
                    END

                    8:BEGIN
                        ll=where(cre NE 0)
                        lm=where(cre eq 0)
                        im=cre
                        tmp=bytscl(float(naa(ll))/cre(ll),top=99)+102
                        im(ll)=tmp
                        im(lm)=101
                    END

                    9:BEGIN
                        ll=where(cre NE 0)
                        lm=where(cre eq 0)
                        im=cre
                        tmp=bytscl(float(cho(ll))/cre(ll),top=99)+102
                        im(ll)=tmp
                        im(lm)=101
                    END

                    10:BEGIN
                        ll=where(lac NE 0)
                        lm=where(lac eq 0)
                        im=lac
                        tmp=bytscl(float(naa(ll))/lac(ll),top=99)+102
                        im(ll)=tmp
                        im(lm)=101
                    END

                ENDCASE ;kk

;rebin metabolite ratio map
                IF option(3) EQ 0 THEN BEGIN
                    im=rebin(im,256,256,/sample)
                ENDIF ELSE BEGIN
                    im=shift(rebin(im,256,256),4,4)
                ENDELSE
;add grid, if desired
                IF option(2) EQ 0 THEN BEGIN
                    index=where(grid NE 0)
                    im(index)=grid(index)
                ENDIF
;draw roi on metabolite ratio map
                IF (size(t))(0) EQ 1 THEN im(t)=im(t)-101
                pictfile='sl'+strn+'.'+strtrim(name(0))+files(kk)
;Test to see if file exists
		pictfile=old_dir+'/'+pictfile
                spawn,getenv('SPECHOME')+'/qfile '+pictfile,res
                IF res(0) EQ 1 THEN rename_pictfile ;file exists                    
                write_pict,pictfile,im
            ENDIF ;dummy(kk) eq 1
        ENDFOR ; kk=7,10

        FOR kk=11,13 DO BEGIN ;TD metabolite maps
            IF dummy(kk) EQ 1 THEN BEGIN
                CASE kk OF
                    11:image=cho_td*zap_td<max_cho
                    12:image=cre_td*zap_td<max_cre
                    13:image=naa_td*zap_td<max_naa
                ENDCASE ;kk

;make metabolite map
                IF option(4) EQ 0 THEN image=rebin(image,256,256,/sample) $
                ELSE image=shift(rebin(image,256,256),4,4)

                IF tmode THEN show,image,1,0,/nodisplay,im=im,nogrid=option(3)$
                ELSE show,image,2,0,/nodisplay,im=im,nogrid=option(3)

;draw roi on metabolite map
                IF (size(t))(0) EQ 1 THEN BEGIN
                    IF option(6) THEN BEGIN
                        IF tmode THEN im(t)=150 $
                        ELSE im(t)=50
                    ENDIF ELSE BEGIN
                        IF tmode THEN im(t)=im(t)+100 $
                        ELSE im(t)=im(t)-100
                    ENDELSE
                ENDIF
                pictfile='sl'+strn+'.'+strtrim(name(0))+files(kk)

;Test to see if file exists
		pictfile=old_dir+'/'+pictfile
                spawn,getenv('SPECHOME')+'/qfile '+pictfile,res
                IF res(0) EQ 1 THEN rename_pictfile ;file exists                    
                write_pict,pictfile,im
            ENDIF ;dummy(kk) eq 1
        ENDFOR ; kk=11,13

        FOR kk=14,16 DO BEGIN ;td metabolite ratio maps
            IF dummy(kk) EQ 1 THEN BEGIN
                CASE kk OF
                    14:BEGIN
                        ll=where(cho_td*zap_td NE 0)
                        lm=where(cho_td*zap_td EQ 0)
                        im=cho_td*zap_td
                        tmp=bytscl(float(naa_td(ll))/cho_td(ll),top=99)+102
                        im(ll)=tmp
                        im(lm)=101
                    END

                    15:BEGIN
                        ll=where(cre_td*zap_td NE 0)
                        lm=where(cre_td*zap_td EQ 0)
                        im=cre_td*zap_td
                        tmp=bytscl(float(naa_td(ll))/cre_td(ll),top=99)+102
                        im(ll)=tmp
                        im(lm)=101
                    END

                    16:BEGIN
                        ll=where(cre_td*zap_td NE 0)
                        lm=where(cre_td*zap_td EQ 0)
                        im=cre_td
                        tmp=bytscl(float(cho_td(ll))/cre_td(ll),top=99)+102
                        im(ll)=tmp
                        im(lm)=101
                   END

               ENDCASE          ;kk

;rebin metabolite ratio map
                IF option(3) EQ 0 THEN BEGIN
                    im=rebin(im,256,256,/sample)
                ENDIF ELSE BEGIN
                    im=shift(rebin(im,256,256),4,4)
                ENDELSE
;add grid, if desired
                IF option(2) EQ 0 THEN BEGIN
                    index=where(grid NE 0)
                    im(index)=grid(index)
                ENDIF
;draw roi on metabolite ratio map
                IF (size(t))(0) EQ 1 THEN im(t)=im(t)-101
                pictfile='sl'+strn+'.'+strtrim(name(0))+files(kk)
;Test to see if file exists
		pictfile=old_dir+'/'+pictfile
                spawn,getenv('SPECHOME')+'/qfile '+pictfile,res
                IF res(0) EQ 1 THEN rename_pictfile ;file exists                    
                write_pict,pictfile,im
            ENDIF ;dummy(kk) eq 1
        ENDFOR ; kk=13,16

;Save guide windows        
        FOR kk=17,19 DO BEGIN ; Segmented images
            IF dummy(kk) EQ 1 THEN BEGIN
                dum=prep_seg_im(seg_ims(*,*,nseg(kk-17)-1))
                im=reform(dum,256,256);get image
;Set windowing for display
;                mmax=max(im)*float(pmax)/100.
;                mmin=max(im)*float(pmin)/100.
;Grid or no grid?
;                IF option(0) EQ 0 THEN BEGIN
;                    im = grid > bytscl(im<mmax>mmin,top=100)
;                ENDIF ELSE BEGIN
;                    im = bytscl(im<mmax>mmin,top=100)
;                ENDELSE
;plot,roi
;                IF (size(t))(0) NE 0 THEN BEGIN
;                    IF option(5) EQ 0 THEN BEGIN
;                        im(t)=im(t)+102
;                    ENDIF ELSE BEGIN
;                        im(t)=150
;                    ENDELSE
;                ENDIF
                pictfile='sl'+strn+'.'+strtrim(name(0))+files(kk)
;Test to see if file exists
		pictfile=old_dir+'/'+pictfile
                spawn,getenv('SPECHOME')+'/qfile '+pictfile,res
                IF res(0) EQ 1 THEN rename_pictfile ;file exists                    
                write_pict,pictfile,im
            ENDIF ;dummy(kk) eq 1
        ENDFOR

        IF dummy(20) EQ 1 AND count NE 0 THEN BEGIN ; wet spectra
            smode1=s.smode      ;save mode
            s.smode=0           ;individual spectrum mode            
            widget_control,s.tf_w,get_uvalue=flag ;save old flag
            widget_control,s.tf_w,set_uvalue=0 ;set flag to wet spectra
            window,/free,/pixmap,xsize=256,ysize=165 ;create pixmap
            FOR kk=0,count-1 DO BEGIN ;loop over spectra in roi
                vx=t32(kk) mod 32
                x1=vx*8
                vy=t32(kk)/32
                y1=vy*8
                kkstr=strtrim(string(vx),2)+'_'+strtrim(string(vy),2)
                pictfile='sl'+strn+'.'+strtrim(name(0))+$
                  files(20)+kkstr+'.PICT'
                new_value=positions(vx,vy)
                erase
                specplot,vx,vy,show=option(7),/imflag,image=im
                spawn,getenv('SPECHOME')+'/qfile '+pictfile,res
                IF res(0) EQ 1 THEN rename_pictfile ;file exists                    
                write_pict,pictfile,im
            ENDFOR
;---------  this is for saving pict with avg.spectrum if any
            s.smode=1           ;roi spectrum mode
            specplot,vx,vy,show=option(7),/imflag,image=im
            pictfile='sl'+strn+'.'+strtrim(name(0))+$
              files(20)+'_avg.PICT'
            spawn,getenv('SPECHOME')+'/qfile '+pictfile,res
            IF res(0) EQ 1 THEN rename_pictfile ;file exists                    
            write_pict,pictfile,im
            widget_control,s.tf_w,set_uvalue=flag ;restore flag
            s.smode=smode1      ;restore mode
            wdelete             ;delete pixmap
            
        ENDIF
        
        IF dummy(21) EQ 1 AND count NE 0 THEN BEGIN ; dry spectra
            smode1=s.smode      ;save mode
            s.smode=0           ;individual spectrum mode
            widget_control,s.tf_w,get_uvalue=flag ;save old flag
            widget_control,s.tf_w,set_uvalue=1 ;set flag to dry spectra
            window,/free,/pixmap,xsize=256,ysize=165 ;create pixmap
;            window,/free,xsize=256,ysize=165 ;dummy for debugging
            FOR kk=0,count-1 DO BEGIN ;loop over spectra in roi
                vx=t32(kk) mod 32
                x1=vx*8
                vy=t32(kk)/32
                y1=vy*8
                kkstr=strtrim(string(vx),2)+'_'+strtrim(string(vy),2)
                pictfile='sl'+strn+'.'+strtrim(name(0))+$
                  files(21)+kkstr+'.PICT'
                new_value=positions(vx,vy)
                erase
                specplot,vx,vy,show=option(8),/imflag,image=im
                spawn,getenv('SPECHOME')+'/qfile '+pictfile,res
                IF res(0) EQ 1 THEN rename_pictfile ;file exists                    
                write_pict,pictfile,im
            ENDFOR
;---------  this is for saving pict with avg.spectrum if any
;            s.smode=1           ;roi spectrum mode
;            specplot,vx,vy,show=option(7)
;            im=tvrd()
;            pictfile='sl'+strn+'.'+strtrim(name(0))+$
;              files(11)+'_avg.PICT'
;            write_pict,pictfile,im
;            widget_control,s.tf_w,set_uvalue=flag ;restore flag
;            s.smode=smode1      ;restore mode
;            wdelete             ;delete pixmap
        ENDIF
 
        widget_control,base_w,/destroy
    END

ENDCASE
    
END


pro save_pict
;This procedure creates a widget interface for choosing which images
;to save as pict files
COMMON save_pict
base_w=widget_base(title='PICT',/column)
row_w=widget_base(base_w,/row)
spmri_w=cw_bgroup(row_w,/col,/return_name,/nonexclusive,$
                   ['MRI 1','MRI 2','MRI 3'],$
                  label_top='MRIs',uvalue=intarr(3))
spfd_w=cw_bgroup(row_w,/col,/return_name,/nonexclusive,$
                   ['Choline','Creatine','NAA','Lactate',$
                    'NAA/CHO','NAA/CRE','CHO/CRE','NAA/LAC'],$
                 label_top='FD maps',uvalue=intarr(8))
sptd_w=cw_bgroup(row_w,/col,/return_name,/nonexclusive,$
                 ['Choline','Creatine','NAA',$
                  'NAA/CHO','NAA/CRE','CHO/CRE'],$
                 label_top='TD maps',uvalue=intarr(8))
spseg_w=cw_bgroup(row_w,/col,/return_name,/nonexclusive,$
                  ['Class 1','Class 2','Class 3'],$ 
                  label_top='Segmented Images',uvalue=intarr(3))
spsp_w=cw_bgroup(row_w,/col,/return_name,/nonexclusive,$
                 ['Wet','Dry'],$
                 label_top='Spectra',uvalue=intarr(3))
options_w=cw_bgroup(row_w,/col,/return_name,/nonexclusive,$
                    ['No grid on MRIs',$                     ; 0
                     'Smooth ROIs on MRIs',$                 ; 1
                     'Show ROI outline on MRIs',$       ; 2
                     'No grid on metabolite maps',$          ; 3
                     'Smooth metabolite maps',$              ; 4
                     'Smooth ROIs on metabolite maps',$      ; 5
                     'Show ROI outline on metabolite map',$;6
                     'Show integration limits on spectra',$ ; 7 
                     'Show TD fit results on spectra'],$ ; 8
                    label_top='Options',uvalue=intarr(9))

pictname_w=cw_field(base_w,title='PICT file name:',value='r1',/frame,/return,xsize=10)
done_w=widget_button(base_w,value='Done')                   
widget_control,base_w,/realize

xmanager,'save_pict',base_w,/modal

END
