;This procedure creates a dialog box for choosing settings
;Revision History
; 05Sep96 ASB First version, only changes color table
; 25Feb98 ASB Added code to choose filters and filter parameters
; 27Feb98 ASB Debugged code to choose filters and filter parameters

;This program handles events ruturned by the settings widgets.
pro settings_event,event
COMMON settings
COMMON defaults
COMMON defroi
CASE event.id OF 
                                ;Set color table
    setcolort_w: tvlcolor,event.value

                                ;Set csi version
    setftype_w: widget_control,event.id,get_value=version
                                
    setquit_w:BEGIN             ;Save neccesary info and quit
        widget_control,setspfilt_w,get_value=filtsym
        IF sapd GT 3 THEN BEGIN
            widget_control,sprm1value_w,get_value=tmp
            sapd_defs(0,sapd)=tmp
        ENDIF
        IF sapd EQ 5 THEN BEGIN
            widget_control,sprm2value_w,get_value=tmp
            sapd_defs(1,sapd)=tmp
        ENDIF
        IF tapd GT 3 THEN BEGIN
            widget_control,tprm1value_w,get_value=tmp
            tapd_defs(0,tapd)=tmp
        ENDIF
        IF tapd EQ 5 THEN BEGIN
            widget_control,tprm2value_w,get_value=tmp
            tapd_defs(1,tapd)=tmp
        ENDIF
        widget_control,setbase_w,/destroy
    END 

                                
    spdmenu_w:filter_event,event;Change spatial filter
                                
    tpdmenu_w:filter_event,event;Change temporal filter
                                
    setspfilt_w:                ;Change spatial filter type

    ELSE: set_apd,event         ;Change filter parameter
ENDCASE
END

;This program handles events generated by the pull down menus
pro filter_event,event
COMMON settings
COMMON defaults
CASE event.value OF
    'Spatial filter type.Rectangular':BEGIN
                                ;Change filter type name
        widget_control,sfilter_w,set_value=titles(0)
                                ;Show only parameters that are used
        widget_control,sprm1base_w,map=0
        widget_control,sprm2base_w,map=0
        sapd=0
    END
    'Spatial filter type.Bartlett   ':BEGIN
                                ;Change filter type name
        widget_control,sfilter_w,set_value=titles(1)
                                ;Show only parameters that are used
        widget_control,sprm1base_w,map=0
        widget_control,sprm2base_w,map=0
        sapd=1
    END
    'Spatial filter type.Hann       ':BEGIN
                                ;Change filter type name
        widget_control,sfilter_w,set_value=titles(2)
                                ;Show only parameters that are used
        widget_control,sprm1base_w,map=0
        widget_control,sprm2base_w,map=0
        sapd=2
    END
    'Spatial filter type.Hamming    ':BEGIN
                                ;Change filter type name
        widget_control,sfilter_w,set_value=titles(3)
                                ;Show only parameters that are used
        widget_control,sprm1base_w,map=0
        widget_control,sprm2base_w,map=0
        sapd=3
    END
    'Spatial filter type.Gaussian   ':BEGIN
                                ;Change filter type name
        widget_control,sfilter_w,set_value=titles(4)
                                ;Set value of parameter
        widget_control,sprm1value_w,/map,set_value=strtrim(string(sapd_defs(0,4)),2)
                                ;Set name of parameter
        widget_control,sprm1label_w,set_value='Beta:'
                                ;Show only parameter that is used
        widget_control,sprm1base_w,/map
        widget_control,sprm2base_w,map=0        
        sapd=4
    END
    'Spatial filter type.Fermi      ':BEGIN
                                ;Change filter type name
        widget_control,sfilter_w,set_value=titles(5)
                                ;Set values of parameters
        widget_control,sprm1value_w,/map,set_value=strtrim(string(sapd_defs(0,5)),2)
        widget_control,sprm2value_w,/map,set_value=strtrim(string(sapd_defs(1,5)),2)
                                ;Set names of parameters
        widget_control,sprm1label_w,set_value='Mu:'
        widget_control,sprm2label_w,set_value='Beta:'
                                ;Show both parameters
        widget_control,sprm1base_w,/map
        widget_control,sprm2base_w,/map
        sapd=5
    END
    'Spatial filter type.Chebyshev  ':BEGIN
                                ;Change filter type name
        widget_control,sfilter_w,set_value=titles(6)
                                ;Set value of parameter
        widget_control,sprm1value_w,/map,set_value=strtrim(string(sapd_defs(0,6)),2)
                                ;Set name of parameter
        widget_control,sprm1label_w,set_value='Beta:'
                                ;Show only parameter that is used
        widget_control,sprm1base_w,/map
        widget_control,sprm2base_w,map=0
        sapd=6
    END
    'Spatial filter type.Exponential':BEGIN
                                ;Change filter type name
        widget_control,sfilter_w,set_value=titles(7)
                                ;Set value of parameter
        widget_control,sprm1value_w,/map,set_value=strtrim(string(sapd_defs(0,7)),2)
                                ;Set name of parameter
        widget_control,sprm1label_w,set_value='Alpha:'
                                ;Show only parameter that is used
        widget_control,sprm1base_w,/map
        widget_control,sprm2base_w,map=0
        sapd=7
    END
    'Spatial filter type.Cosine     ':BEGIN
                                ;Change filter type name
        widget_control,sfilter_w,set_value=titles(8)
                                ;Set value of parameter
        widget_control,sprm1value_w,/map,set_value=strtrim(string(sapd_defs(0,8)),2)
                                ;Set name of parameter
        widget_control,sprm1label_w,set_value='Plateau width:'        
                                ;Show only parameter that is used
        widget_control,sprm1base_w,/map
        widget_control,sprm2base_w,map=0
        sapd=8
    END
    'Temporal filter type.Rectangular':BEGIN
                                ;Change filter type name
        widget_control,tfilter_w,set_value=titles(0)
                                ;Show only parameters that are used
        widget_control,tprm1base_w,map=0
        widget_control,tprm2base_w,map=0
        tapd=0
    END
    'Temporal filter type.Bartlett   ':BEGIN
                                ;Change filter type name
        widget_control,tfilter_w,set_value=titles(1)
                                ;Show only parameters that are used
        widget_control,tprm1base_w,map=0
        widget_control,tprm2base_w,map=0
        tapd=1
    END
    'Temporal filter type.Hann       ':BEGIN
                                ;Change filter type name
        widget_control,tfilter_w,set_value=titles(2)
                                ;Show only parameters that are used
        widget_control,tprm1base_w,map=0
        widget_control,tprm2base_w,map=0
        tapd=2
    END
    'Temporal filter type.Hamming    ':BEGIN
                                ;Change filter type name 
        widget_control,tfilter_w,set_value=titles(3)
                                ;Show only parameters that are used
        widget_control,tprm1base_w,map=0
        widget_control,tprm2base_w,map=0
        tapd=3
    END
    'Temporal filter type.Gaussian   ':BEGIN
                                ;Change filter type name
        widget_control,tfilter_w,set_value=titles(4)
                                ;Set value of parameter
        widget_control,tprm1value_w,/map,set_value=strtrim(string(tapd_defs(0,4)),2)
                                ;Set name of parameter
        widget_control,tprm1label_w,set_value='Beta:'
                                ;Show only parameter that is used
        widget_control,tprm1base_w,/map
        widget_control,tprm2base_w,map=0
        tapd=4
    END
    'Temporal filter type.Fermi      ':BEGIN
                                ;Change filter type name
        widget_control,tfilter_w,set_value=titles(5)
                                ;Set values of parameters
        widget_control,tprm1value_w,/map,set_value=strtrim(string(tapd_defs(0,5)),2)
        widget_control,tprm2value_w,/map,set_value=strtrim(string(tapd_defs(1,5)),2)
                                ;Set names of parameters
        widget_control,tprm1label_w,set_value='Mu:'
        widget_control,tprm2label_w,set_value='Beta:'
                                ;Show both parameters
        widget_control,tprm1base_w,/map
        widget_control,tprm2base_w,/map
        tapd=5
    END
    'Temporal filter type.Chebyshev  ':BEGIN
                                ;Change filter type name
        widget_control,tfilter_w,set_value=titles(6)
                                ;Set value of parameter
        widget_control,tprm1value_w,/map,set_value=strtrim(string(tapd_defs(0,6)),2)
                                ;Set name of parameter
        widget_control,tprm1label_w,set_value='Beta:'
                                ;Show only parameter that is used
        widget_control,tprm1base_w,/map
        widget_control,tprm2base_w,map=0
        tapd=6
    END
    'Temporal filter type.Exponential':BEGIN
                                ;Change filter type name
        widget_control,tfilter_w,set_value=titles(7)
                                ;Set value of parameter
        widget_control,tprm1value_w,/map,set_value=strtrim(string(tapd_defs(0,7)),2)
                                ;Set name of parameter
        widget_control,tprm1label_w,set_value='Alpha:'
                                ;Show only parameter that is used
        widget_control,tprm1base_w,/map
        widget_control,tprm2base_w,map=0       
        tapd=7
    END
    'Temporal filter type.Cosine     ':BEGIN
                                ;Change filter type name
        widget_control,tfilter_w,set_value=titles(8)
                                ;Set value of parameter
        widget_control,tprm1value_w,/map,set_value=strtrim(string(tapd_defs(0,8)),2)
                                ;Set name of parameter
        widget_control,tprm1label_w,set_value='Plateau width:'        
                                ;Show only parameter that is used
        widget_control,tprm1base_w,/map
        widget_control,tprm2base_w,map=0
        tapd=8
    END
    ENDCASE
END

;This program handles events generated when apd parameters are changed
pro set_apd,event
COMMON settings
COMMON defaults
CASE event.id OF
    sprm1base_w:BEGIN
        widget_control,sfilter_w,get_value=ftype
        CASE ftype OF
            'Gaussian   ':BEGIN
                                ;Read new value of parameter
                widget_control,sprm1value_w,get_value=tmp
                                ;Set value of parameter in common block
                sapd_defs(0,4)=tmp
                                ;Display parameter in standard format
                widget_control,sprm1value_w,set_value=strtrim(float(tmp),2)
            END
            'Fermi      ':BEGIN
                                ;Read new value of parameter
                widget_control,sprm1value_w,/map,get_value=tmp
                                ;Set value of parameter in common block
                sapd_defs(0,5)=tmp
                                ;Display parameter in standard format
                widget_control,sprm1value_w,set_value=strtrim(float(tmp),2)
            END
            'Chebyshev  ':BEGIN
                                ;Read new value of parameter
                widget_control,sprm1value_w,/map,get_value=tmp
                                ;Set value of parameter in common block
                sapd_defs(0,6)=tmp
                                ;Display parameter in standard format
                widget_control,sprm1value_w,set_value=strtrim(float(tmp),2)
            END
            'Exponential':BEGIN
                                ;Read new value of parameter
                widget_control,sprm1value_w,/map,get_value=tmp
                                ;Set value of parameter in common block
                sapd_defs(0,7)=tmp
                                ;Display parameter in standard format
                widget_control,sprm1value_w,set_value=strtrim(float(tmp),2)
            END
            'Cosine     ':BEGIN
                                ;Read new value of parameter
                widget_control,sprm1value_w,/map,get_value=tmp
                                ;Set value of parameter in common block
                sapd_defs(0,8)=tmp
                                ;Display parameter in standard format
                widget_control,sprm1value_w,set_value=strtrim(float(tmp),2)
            END
        ENDCASE
    END

    sprm2base_w:BEGIN
                                ;Read new value of parameter
        widget_control,sprm2value_w,/map,get_value=tmp
                                ;Set value of parameter in common block
        sapd_defs(1,5)=tmp
                                ;Display parameter in standard format
        widget_control,sprm2value_w,set_value=strtrim(float(tmp),2)
    END
    tprm1base_w:BEGIN
        widget_control,tfilter_w,get_value=ftype
        CASE ftype OF
            'Gaussian   ':BEGIN
                                ;Read new value of parameter 
                widget_control,tprm1value_w,get_value=tmp
                                ;Set value of parameter in common block
                tapd_defs(0,4)=tmp
                                ;Display parameter in standard format
                widget_control,tprm1value_w,set_value=strtrim(float(tmp),2)
            END
            'Fermi      ':BEGIN
                                ;Read new values of parameters
                widget_control,tprm1value_w,/map,get_value=tmp
                                ;Set value of parameter in common block
                tapd_defs(0,5)=tmp
                                ;Display parameter in standard format
                widget_control,tprm1value_w,set_value=strtrim(float(tmp),2)
            END
            'Chebyshev  ':BEGIN
                                ;Read new value of parameter
                widget_control,tprm1value_w,/map,get_value=tmp
                                ;Set value of parameter in common block
                tapd_defs(0,6)=tmp
                                ;Display parameter in standard format
                widget_control,tprm1value_w,set_value=strtrim(float(tmp),2)
            END
            'Exponential':BEGIN
                                ;Read new value of parameter
                widget_control,tprm1value_w,/map,get_value=tmp
                                ;Set value of parameter in common block
                tapd_defs(0,7)=tmp
                                ;Display parameter in standard format
                widget_control,tprm1value_w,set_value=strtrim(float(tmp),2)
            END
            'Cosine     ':BEGIN
                                ;Read new value of parameter
                widget_control,tprm1value_w,/map,get_value=tmp
                                ;Set value of parameter in common block
                tapd_defs(0,8)=tmp
                                ;Display parameter in standard format
                widget_control,tprm1value_w,set_value=strtrim(float(tmp),2)
            END
        ENDCASE
    END
    tprm2base_w:BEGIN
                                ;Read new value of parameter
        widget_control,tprm2value_w,/map,get_value=tmp
                                ;Set value of parameter in common block
        tapd_defs(1,5)=tmp
                                ;Display parameter in standard format
        widget_control,tprm2value_w,set_value=strtrim(float(tmp),2)
    END
ENDCASE
END

;This subroutine creates the settings widget
pro settings
COMMON settings
COMMON defaults
COMMON defroi
junk={CW_PDMENU_S,flags:0,name:''}
setbase_w=widget_base(column=1,title='Settings') ; Base widget
                                ;Select color table widget
setcolort_w=cw_bgroup(setbase_w,label_left='Color table',['Blue-Red','BGR'],$
                   set_value=0,/exclusive,row=1)
                                ;Select file type widget
setftype_w=cw_bgroup(setbase_w,label_left='Raw File Type',['55','5xb','5xa','5x','4x'],$
                   set_value=version,/exclusive,row=1)
                                ;Spatial filter symmetry widget
setspfilt_w=cw_bgroup(setbase_w,label_left='Spatial filter symmetry',$
                      ['Rectangular','Circular'],set_value=filtsym,/exclusive,row=1)

                                ;Spatial filter type pull down menu
row4_w=widget_base(setbase_w,row=1)
menu_desc_w = [ $
                { CW_PDMENU_S,       1, 'Spatial filter type' }, $ ;        0
                { CW_PDMENU_S,       0, 'Rectangular' }, $ ;        1
                { CW_PDMENU_S,       0, 'Bartlett   ' }, $ ;        2
                { CW_PDMENU_S,       0, 'Hann       ' }, $ ;        3
                { CW_PDMENU_S,       0, 'Hamming    ' }, $ ;        4
                { CW_PDMENU_S,       0, 'Gaussian   ' }, $ ;        5
                { CW_PDMENU_S,       0, 'Fermi      ' }, $ ;        6
                { CW_PDMENU_S,       0, 'Chebyshev  ' }, $ ;        7
                { CW_PDMENU_S,       0, 'Exponential' }, $ ;        8
                { CW_PDMENU_S,       0, 'Cosine     ' } $ ;        9
                ]
                                ;define titles
titles=['Rectangular',$
        'Bartlett   ',$
        'Hann       ',$
        'Hamming    ',$
        'Gaussian   ',$
        'Fermi      ',$
        'Chebyshev  ',$
        'Exponential',$
        'Cosine     ']
                                ;define parameter names
param_names=strarr(2,9)
param_names(*)  ='              '
param_names(0,4)='Beta:         '

param_names(0,5)='Mu:           '
param_names(1,5)='Beta:         '

param_names(0,6)='Beta:         '

param_names(0,7)='Alpha:        '

param_names(0,8)='Plateau width:'


spdmenu_w = cw_pdmenu(row4_w, menu_desc_w, /return_full_name, $
                     uvalue='pdmenu')

                                ;filter type name widget
sfilter_w = widget_label(row4_w, value=titles(sapd))
                                ;base widget for spatial filter param values
sprmbase_w=widget_base(row4_w,row=1)
                                ;spatial parameter 1 compound widget
sprm1base_w=cw_field(sprmbase_w,title=param_names(0,8),$
                     value=strtrim(string(0),2),/ret,/float)
sprm1label_w=widget_info(sprm1base_w,/child) ;spatial parameter 1 name widget
sprm1value_w=widget_info(sprm1label_w,/sib) ;spatial parameter 1 value widget

widget_control,sprm1label_w,set_value=param_names(0,sapd);set label
                                ;set value
widget_control,sprm1value_w,set_value=strtrim(string(sapd_defs(0,sapd)),2)

IF sapd LE 3 THEN BEGIN ;Don't map parameter widget unless it's needed
    widget_control,sprm1base_w,map=0
ENDIF

                                ;spatial parameter 2 compound widget
sprm2base_w=cw_field(sprmbase_w,title=param_names(0,8),$
                     value=strtrim(string(0),2),/ret,/float)
sprm2label_w=widget_info(sprm2base_w,/child) ;spatial parameter 2 name widget
sprm2value_w=widget_info(sprm2label_w,/sib) ;spatial parameter 2 value widget

widget_control,sprm2label_w,set_value=param_names(1,sapd) ;set label
                                ;set value
widget_control,sprm2value_w,set_value=strtrim(string(sapd_defs(1,sapd)),2)

IF sapd NE 5 THEN BEGIN ;Don't map paramater widget unless it's needed
    widget_control,sprm2base_w,map=0
ENDIF

                                ;Temporal filter type pull down menu
row5_w=widget_base(setbase_w,row=1)
menu_desc_w = [ $
                { CW_PDMENU_S,       1, 'Temporal filter type' }, $ ;        0
                { CW_PDMENU_S,       0, 'Rectangular' }, $ ;        1
                { CW_PDMENU_S,       0, 'Bartlett   ' }, $ ;        2
                { CW_PDMENU_S,       0, 'Hann       ' }, $ ;        3
                { CW_PDMENU_S,       0, 'Hamming    ' }, $ ;        4
                { CW_PDMENU_S,       0, 'Gaussian   ' }, $ ;        5
                { CW_PDMENU_S,       0, 'Fermi      ' }, $ ;        6
                { CW_PDMENU_S,       0, 'Chebyshev  ' }, $ ;        7
                { CW_PDMENU_S,       0, 'Exponential' }, $ ;        8
                { CW_PDMENU_S,       0, 'Cosine     ' } $ ;        9
                ]

tpdmenu_w = cw_pdmenu(row5_w, menu_desc_w, /return_full_name, $
                     uvalue='pdmenu')

                                ;filter type name widget
tfilter_w = widget_label(row5_w, value=titles(tapd))
                                ;base widget for temporal filter param values
tprmbase_w=widget_base(row5_w,row=1)
                                ;temporal parameter 1 compound widget
tprm1base_w=cw_field(tprmbase_w,title=param_names(0,8),$
                     value=strtrim(string(0),2),/ret,/float)
tprm1label_w=widget_info(tprm1base_w,/child) ;temporal parameter 1 name widget
tprm1value_w=widget_info(tprm1label_w,/sib) ;spatial parameter 1 value widget

widget_control,tprm1label_w,set_value=param_names(0,tapd) ;set label
                                ;set value
widget_control,tprm1value_w,set_value=strtrim(string(tapd_defs(0,tapd)),2)

IF tapd LE 3 THEN BEGIN ;Don't map parameter widget unless it's needed
    widget_control,tprm1base_w,map=0
ENDIF

                                ;spatial parameter 2 compound widget
tprm2base_w=cw_field(tprmbase_w,title=param_names(0,8),$
                     value=strtrim(string(0),2),/ret,/float)

tprm2label_w=widget_info(tprm2base_w,/child) ;spatial parameter 2 name widget
tprm2value_w=widget_info(tprm2label_w,/sib) ;spatial parameter 2 value widget

widget_control,tprm2label_w,set_value=param_names(1,tapd) ;set label
                                ;set value
widget_control,tprm2value_w,set_value=strtrim(string(tapd_defs(1,tapd)),2)
IF tapd NE 5 THEN BEGIN         ;Don't map parameter widget unless it's needed
    widget_control,tprm2base_w,map=0
ENDIF

setquit_w=widget_button(setbase_w,value='Quit') ;Quit widget

widget_control,setbase_w,/realize ;Realize widgets

xmanager,'settings',setbase_w,/modal ;Register widgets

END
