; This program displays an image in the current window
; It superposes the grid over the image
;Revision History
;09Aug96 ASB First SCCS version
;18Jul97 ASB Added keyword pos for use in debugging.
;14Apr98 Qin replace pos by "max", max = naa_scale_max
;15Jul98 ASB Removed print statements and commented out lines
;            Added comments.
;10Aug98 ASB Added keywords im, nogrid, and nodisplay for use with
;            save_pict.
;28Aug98 ASB Added keyword noscale.
;15Feb99 ASB Added code to erase window if image is all 0.
;20Mar00 ASB replaced arguments top and offset with ctab.
;25May00 ASB Fixed bug in display if empty metabolite map is selected.

pro show,image,ctab,max,im=im,nogrid=nogrid,nodisplay=nodisplay,$
         noscale=noscale,window=window

COMMON grid
COMMON posdata
COMMON ctable

CASE ctab OF
    1: BEGIN
        top=100
        offset=0
    END
    2: BEGIN
        top=100
        offset=coffset1
    END
    3: BEGIN
        offset=0
    END
ENDCASE

sz=size(image) ;get size of image
ndex=where(image NE 0) ; do nothing if image is all zeros
IF ndex(0) NE -1 THEN BEGIN
    im1=image(ndex)
    mn=min(im1) ;find minimum nonzero pixel value in image
    IF NOT keyword_set(noscale) THEN BEGIN
        IF max NE 0 THEN BEGIN  ;scale nonzero pixel values
            im1=bytscl(im1+1-mn,top=top,max=max)
        ENDIF ELSE IF max eq 0 THEN BEGIN
            im1=bytscl(im1+1-mn,top=top)
        ENDIF
    ENDIF
;Offset image to use proper color table
    im=replicate(byte(offset),sz(1),sz(2))
    im(ndex)=im(ndex)+im1
ENDIF ELSE im=image

; overlay grid
IF NOT keyword_set(nogrid) THEN im(index)=grid(index)    
;display image
IF NOT keyword_set(nodisplay) THEN BEGIN
    tv,im
    IF dispflag THEN backup(*,*,window)=im
ENDIF
    
RETURN
END

