;Program to compute area under peaks in MRSI data
;Revision History
;??????? GSS or JRA ???????????
;09Aug96 ASB First SCCS version
;18Jul97 ASB Removed reference to !spectro
;17Jul98 ASB Added call to get width, removed width from calling
;            sequence.
;            Removed arguments from common statement.
;            Changed naa_pos to positions to be consistant with
;            definition in common_list.
;27Jul98 ASB Replaced argument list with COMMON mets.
;            Changed inos to ino.
;29Jul98 ASB Added common blocks roistats, defaults.
;            Integration width now stored in variable binwidth.
; 980915 ASB Replaced !csi_dat with fd_dat in COMMON freqdomain.
; 980915 ASB Added COMMON initcsi and removed system variables.
; 980916 ASB Changed name of COMMON freqdomain to mrsidata.
; 990406 ASB Added h2o_offset.
;            Replaced chem shifts with variables passed in COMMON
;            mets.
; 991123 ASB Added 3 more ways to generate water map.
PRO sumpeaks
COMMON posdata
COMMON defroi
COMMON mets
COMMON roistats
COMMON defaults
COMMON mrsidata
COMMON initcsi

naa = fltarr( sp_dim(0), sp_dim(1) )
cho = fltarr( sp_dim(0), sp_dim(1) )
cre = fltarr( sp_dim(0), sp_dim(1) )
lac = fltarr( sp_dim(0), sp_dim(1) )
ino= fltarr( sp_dim(0), sp_dim(1) )
h2o= fltarr( sp_dim(0), sp_dim(1),6)

;IF n_elements(width) EQ 0 THEN width =[0.1]
ppm_to_point = spec_freq * spc_len/ sweep_width
cho_offset = (naa_shift - cho_shift) * ppm_to_point
cre_offset = (naa_shift - cre_shift) * ppm_to_point
lac_offset = (naa_shift - lac_shift) * ppm_to_point
ino_offset = (naa_shift - ino_shift) * ppm_to_point
h2o_offset = (naa_shift - h2o_shift) * ppm_to_point

ir=round(binwidth*ppm_to_point/2.0)

FOR j = 0, sp_dim(1)-1 DO BEGIN
   FOR i = 0, sp_dim(0)-1 DO BEGIN
      IF ( positions(i,j) NE -1 ) THEN BEGIN
        pt = positions(i,j)
        cho2=pt+cho_offset+ir
        cre1=pt+cre_offset-ir
        IF cho2 GT cre1 THEN begin
            cho2=pt+(cho_offset+cre_offset)/2
            cre1=cho2+1
        ENDIF
	naa(i,j) = TOTAL(ABS(fd_dat(pt-ir:pt+ir,i,j)))
	cho(i,j) = TOTAL(ABS(fd_dat(pt+cho_offset-ir:cho2,i,j)))
	cre(i,j) = TOTAL(ABS(fd_dat(cre1:pt+cre_offset+ir,i,j)))
	lac(i,j) = TOTAL(ABS(fd_dat(pt+lac_offset-ir:pt+lac_offset+ir,i,j)))
	ino(i,j) = TOTAL(ABS(fd_dat(pt+ino_offset-ir:pt+ino_offset+ir,i,j)))

                                ;area under water peak in FID
        h2o(i,j,0) = TOTAL(ABS(fd_dat1(pt+h2o_offset-ir:pt+h2o_offset+ir,i,j)))
                                ;area under water peak in echo
        h2o(i,j,1) = TOTAL(ABS(fd_dat(pt+h2o_offset-ir:pt+h2o_offset+ir,i,j)))
                                ;largest value in FID
        h2o(i,j,2) = max(abs(td_dat1(*,i,j)))
                                ;largest value in echo
        h2o(i,j,3) = max(abs(td_dat(*,i,j)))

      END
   ENDFOR
ENDFOR
                                ;Power in FID
h2o(*,*,4)=sqrt(total(abs(td_dat1)^2,1))/1024
                                ;Power in echo
h2o(*,*,5)=sqrt(total(abs(td_dat)^2,1))/1024

RETURN

END
