;Program to compute area under peaks in MRSI data
;17JUL97 ASB First SCCS version
;980915  ASB Replaced !csi_dat with fd_dat in COMMON freqdomain.
;980915  ASB Added COMMON initcsi and removed system variables.
;980916  ASB Changed name of COMMON freqdomain to mrsidata.

;This version uses a call_external to a c program to decrease running time.
PRO 	sumpeaks_c, naa, cho, cre, lac, inos,width=width
COMMON	posdata, naa_pos, mri, new_value
COMMON mrsidata
COMMON initcsi

naa = fltarr( !sp_dim(0), !sp_dim(1) )
cho = fltarr( !sp_dim(0), !sp_dim(1) )
cre = fltarr( !sp_dim(0), !sp_dim(1) )
lac = fltarr( !sp_dim(0), !sp_dim(1) )
inos= fltarr( !sp_dim(0), !sp_dim(1) )

IF n_elements(width) EQ 0 THEN width =[0.1]
ppm_to_point = spec_freq * spc_len/ sweep_width

cho_offset = (2.023 - 3.25) * ppm_to_point
cre_offset = (2.023 - 3.05) * ppm_to_point
lac_offset = (2.023 - 1.33) * ppm_to_point
inos_offset = (2.023 - 3.53) * ppm_to_point

offsets=[cho_offset,cre_offset,lac_offset,inos_offset]

ir=fix(width(0)*ppm_to_point/2.0+0.5)

tmpdat=abs(fd_dat)
sz=size(tmpdat)
mets=fltarr(sz(2),sz(3),5)
pos=naa_pos
file='/afs/alw.nih.gov/ninds/jralger/mp_mrsi/newspec/development/sumpeaks.so'
foo=call_external(file,'_sumpeaks',tmpdat,sz,pos,offsets,ir,mets)
              
naa(i,j)=mets(*,*,0)   
cho(i,j)=mets(*,*,1)   
cre(i,j)=mets(*,*,2)   
lac(i,j)=mets(*,*,3)   
inos(i,j)=mets(*,*,4)   
                  
;FOR j = 0, !sp_dim(1)-1 DO BEGIN
;   FOR i = 0, !sp_dim(0)-1 DO BEGIN
;      IF ( naa_pos(i,j) NE -1 ) THEN BEGIN
;        pt = naa_pos(i,j)
;        cho2=pt+cho_offset+ir
;        cre1=pt+cre_offset-ir
;        IF cho2 GT cre1 THEN begin
;            cho2=pt+(cho_offset+cre_offset)/2
;            cre1=cho2+1
;        ENDIF
;	naa(i,j) = TOTAL(ABS(fd_dat(pt-ir:pt+ir,i,j)))
;	cho(i,j) = TOTAL(ABS(fd_dat(pt+cho_offset-ir:cho2,i,j)))
;	cre(i,j) = TOTAL(ABS(fd_dat(cre1:pt+cre_offset+ir,i,j)))
;	lac(i,j) = TOTAL(ABS(fd_dat(pt+lac_offset-ir:pt+lac_offset+ir,i,j)))
;	inos(i,j) = TOTAL(ABS(fd_dat(pt+inos_offset-ir:pt+inos_offset+ir,i,j)))
;      END
;   ENDFOR
;ENDFOR

RETURN

END
