;This procedure creats a widget that lets the user monitor the
;progress of the time domain analysis.
;Revision History
; 981009 First Version.
; 990303 Fixed bug in calls to widget_control.
; 990429 Changed initial value of "quit" widget to "Abort".
pro td_widget_event,ev
COMMON td_widget
IF ev.id NE active_w THEN BEGIN
    widget_control,ev.id,get_uvalue=top
    widget_control,top,/destroy
ENDIF
END

pro td_widget
COMMON td_widget
COMMON defroi

old=0
IF n_elements(sttime_w) NE 0 THEN old=widget_info(sttime_w,/valid) 
IF old EQ 0 THEN BEGIN
;make widget if it doesn't exist.
    tdbase_w=widget_base(title='Time Domain Fitting In Progress',column=1,$
                         group_leader=s.read_w)

    base1_w=widget_base(tdbase_w,row=1)
    time_w=widget_base(base1_w,column=1)
    sttime_w=cw_field(time_w,title='Start time:',value='00:00:00',/noedit,/string,xsize=8)
    cttime_w=cw_field(time_w,title='Current time:',value='00:00:00',/noedit,/string,xsize=8)
    ectime_w=cw_field(time_w,title='Estimated completion time:',$
                      value='????????',/noedit,/string,xsize=8)

    number_w=widget_base(base1_w,column=1)
    tot_w=cw_field(number_w,title='Number of spectra to fit:',value=0,/noedit,$
                   /integer,xsize=4)
    com_w=cw_field(number_w,title='Number of spectra remaining:',value=0,/noedit,$
                   /integer,xsize=4)
    nfit_w=cw_field(number_w,title='Number of spectra already fit:',value=0,/noedit,$
                    /integer,xsize=4)
    cur_w=cw_field(number_w,title='Current spectrum:',value='',/noedit,/string,xsize=5)

    perf_w=widget_base(tdbase_w,column=1)
    sum_w=widget_label(perf_w,value='Performance Summary')
    svd1_w=cw_field(perf_w,title='SVD1:',value=0,/float)
    
    root_w=cw_field(perf_w,title='Rooting:',value=0,/float)
    svd2_w=cw_field(perf_w,title='SVD2:',value=0,/float)
    dry_w=cw_field(perf_w,title='Total Drying:',value=0,/float)

    fit_w=cw_field(perf_w,title='Fitting:',value=0,/float)

    active_w=cw_bgroup(perf_w,['SVD1','Rooting','SVD2','Fitting'],$
                       label_left='Current task:',/exclusive,row=1)
    tdplot_w=widget_draw(tdbase_w,xsize=485,ysize=300)

    quit_w=widget_button(tdbase_w,value='Abort',uvalue=tdbase_w)
    widget_control,tdbase_w,/clear_events,/realize
    widget_control,tdplot_w,get_value=tdplot
    xmanager,'td_widget',tdbase_w
    RETURN
ENDIF

;Initialize values if widget does exist
widget_control,sttime_w,set_value='00:00:00'
widget_control,cttime_w,set_value='00:00:00'
widget_control,ectime_w,set_value='00:00:00'
widget_control,tot_w,set_value=0
widget_control,com_w,set_value=0
widget_control,nfit_w,set_value=0
widget_control,cur_w,set_value=''

widget_control,svd1_w,set_value=0
widget_control,root_w,set_value=0
widget_control,svd2_w,set_value=0
widget_control,dry_w,set_value=0
widget_control,fit_w,set_value=0

END
