;This program sets up the color tables for analyze_roi.  It used to be
;included in the file analyze_roi.pro
;Revision History
; 14 July 98 asb Removed from analyze_roi.
;                Changed to two arguments.
;                Added bluescale ct
;                Changed ct entries for lines on spec plot

pro tvlcolor,table1,table2
COMMON ctable
IF dispflag THEN BEGIN
    red=bytarr(256)
    green=bytarr(256)
    blue=bytarr(256)
    coffset1=128
    coffset2=101
ENDIF ELSE BEGIN
    red=bytarr(209)
    green=bytarr(209)
    blue=bytarr(209)
    coffset1=101
    coffset2=202
ENDELSE    
IF n_elements(table) EQ 0 THEN table = 0
CASE table1 OF
    0: BEGIN ;Greyscale
	up1=bindgen(101)*2.55

        red(0)=up1
        green(0)=up1
        blue(0)=up1
    END

    1: BEGIN ;blue-red
        up2=bindgen(50)*255/59
        down2=rotate(up2,2)

        red(0)=[0,up2,replicate(255,50)]
        green(0)=[0,up2,down2]
        blue(0)=[0,replicate(255,50),down2]

    END

    2: BEGIN ;rgb
	up2=bindgen(34)*7.73
        up3=up2(1:32)
	down2=rotate(up2,2)

	red(0)=[0,replicate(0,34),up3,replicate(255,34)]
	green(0)=[0,up2,replicate(255,32),down2]
	blue(0)=[0,down2,replicate(0,66)]
    END

    3: BEGIN ;bluescale
	up1=bindgen(101)*2.55
        
        red(0)=bindgen(101)*1.5
        green(0)=bindgen(101)*1.5
        blue(0)=up1
    END

ENDCASE

CASE table2 OF
    0: BEGIN ;Greyscale
	up1=bindgen(101)*2.55

        red(coffset1)=up1
        green(coffset1)=up1
        blue(coffset1)=up1
    END

    1: BEGIN ;blue-red
        up2=bindgen(50)*255/59
        down2=rotate(up2,2)

        red(coffset1)=[0,up2,replicate(255,50)]
        green(coffset1)=[0,up2,down2]
        blue(coffset1)=[0,replicate(255,50),down2]

    END

    2: BEGIN ;rgb
	up2=bindgen(34)*7.73
        up3=up2(1:32)
	down2=rotate(up2,2)

        red(coffset1)=[0,replicate(0,34),up3,replicate(255,34)]
        green(coffset1)=[0,up2,replicate(255,32),down2]
        blue(coffset1)=[0,down2,replicate(0,66)]
    END

    3: BEGIN ;bluescale
        up1=bindgen(101)

        red(coffset1)=up1*1.5
        green(coffset1)=up1*1.5
        blue(coffset1)=up1*2.55
    END

ENDCASE

;Add colors used to draw integration limit lines on specplots
    red(coffset2)=  [255,255,  0, 50,64,84,255]
    green(coffset2)=[0,  255,255, 50,64,84,255]
    blue(coffset2)= [0,    0,  0,255,64,84,255]

tvlct,red,green,blue
END
