;This procedure updates the plot in the spectrum window.
;Revision History
;09Aug96 ASB First SCCS version
;04Mar98 Qin call specplot for avg. spectrum
;20Jul98 ASB Removed keyword avg_spectrum for call to specplot.
;21Jul98 ASB Removed call to obtain width.
;            Removed width keyword from call to specplot.
; 9Oct98 ASB Added COMMON initcsi.
;            Added test to position to protect against crashing due to
;            the point being out of range.
;30May00 ASB Added code to prevent error if called before mx is defined.
pro update_specplot,vx,vy
COMMON defroi
COMMON posdata
COMMON initcsi

IF n_elements(vx) EQ 0 THEN BEGIN
    vx=last_pos(0)
    vy=last_pos(1)
ENDIF

wset,s.swin            
new_value=positions(vx,vy)
IF n_elements(mx) NE 0 AND n_elements(mn) NE 0 THEN BEGIN
    IF (new_value NE -1) AND (new_value GE mn) AND (new_value LE mx) THEN BEGIN
        widget_control,s.slider_w,set_value=positions(vx,vy)
        specplot,vx,vy,show=1
    ENDIF ELSE specplot,vx,vy
ENDIF ELSE specplot,vx,vy
RETURN
END
