;This program redraws the images 
;Revision History
; 15Jul98 ASB Removed from analyze_roi.
;             Changed logic for MRI's to permit same CT 
;             Changed top for segmented image to 208           
; 21Jul98 ASB Changed name of common block from settings to dsettings.
; 25Aug98 ASB Added keyword noscale in call to show segmented image.
;             Added code to sensitize and desensitize "Next MRI" and
;             Previous MRI" buttons.
; 27Aug98 ASB Added code to create and destroy widgets underneath mri
;             windows. 
; 28Aug98 asb Combined btnrow1, btnrow2, and btnrow3 into array
;             btnrow.
;             Combined bt11, bt21, and bt31 into array bt1.
;             Combined bt12, bt22, and bt32 into array bt2.
;             Combined txt1_w, txt2_w, and txt3_w into array txt_w.
;  3Mar99 ASB Removed keywords pmax, pmin.
;             Added code to getpmin and pmax from COMMON rsettings.

PRO modify_widgets,window
COMMON mri_act


        IF widget_info(bt1(window),/valid) AND imtype(window) NE 0 THEN BEGIN
            widget_control,bt1(window),/destroy
            widget_control,bt2(window),/destroy
        ENDIF

        IF widget_info(txt_w(window),/valid) AND $
          (imtype(window) EQ -1 OR imtype(window) EQ 0) THEN BEGIN
            widget_control,txt_w(window),/destroy
        ENDIF

        IF NOT widget_info(bt1(window),/valid) AND imtype(window) EQ 0 THEN BEGIN
            bt2(window)= WIDGET_BUTTON(btnrow(window), VALUE="Previous MRI",$
                                EVENT_PRO="mri_action",xsize=120)
            bt1(window)= WIDGET_BUTTON(btnrow(window), VALUE="Next MRI",$
                                EVENT_PRO="mri_action",xsize=120)
        ENDIF

        IF NOT widget_info(txt_w(window),/valid) AND $
          (imtype(window) EQ -2 OR imtype(window) EQ -3) THEN BEGIN
            txt_w(window)=cw_field(btnrow(window),title='Sensitivity:',value=0,/integer)
        ENDIF


END

PRO	update_window,window
COMMON posdata
COMMON defroi
COMMON seg
COMMON dsettings
COMMON mri_act

;default max,min
pmin=min_v(window)
pmax=max_v(window)
;replot window
WSET, s.gwins(window)
CASE imtype(window) OF
    -3:BEGIN ;slab sensitivity map
        class=nclass(window)-1
        slab=nsl(window,0)-1
        dum=rebin(slab_maps(*,*,class,slab),256,256,/samp)
        dum(0)=1.1
        show,dum,1,0,window=window+n_elements(s.mwins)
    END
    -2:BEGIN ;slice sensitivity map
        class=nclass(window)-1
        slice=nsl(window,1)-1
        dum=rebin(slice_maps(*,*,class,slice),256,256,/samp)
        dum(0)=1.1
        show,dum,1,0,window=window+n_elements(s.mwins)
    END
    -1:BEGIN;segmented image
        modify_widgets,window
        dum=prep_seg_im(seg_ims(*,*,nseg(window)-1))
        dum(0)=1
        show,dum,3,0,/noscale,window=window+n_elements(s.mwins)
    END
    0:BEGIN ;mri
        modify_widgets,window
        dum=mri(*,*,window)
        mmax=max(dum)*float(pmax)/100.
        mmin=max(dum)*float(pmin)/100.        
        show,dum<mmax>mmin,1,0,window=window+n_elements(s.mwins)
    END
    ELSE:
ENDCASE

;make backing store
wset,s.gwins(window)
WINDOW, /PIXMAP, /FREE, xs = !d.x_size, ys=!d.y_size ;Save window
s.gbacking(window) = !d.window
DEVICE, copy = [0,0, !d.x_size, !d.y_size, 0, 0, s.gwins(window)] ;Save it

END	; end of update_window procedure

