;Revision History
;??????? GSS or JRA ????????
;09Aug96 ASB First SCCS version
;
; Window procedure for !csi_dat, for windowing in spatial domain.
; Choices of windows: 1) 1+cos, 2) sin 3) gauss (to zero by substraction)
; wb controles the width of the gauss curve or the part that the 1+cos window
; will be equal to one.
; If sym is active, a symetric window will be used, otherwise he will be at
; !dim/2 {half point asymetric}.
;
pro windcsi,type,wb,sym=sym

if (n_params() eq 0) then err=1 else err=(type lt 0 or type gt 3)
if err then read,'windowtype, 1) 1+cos 2)sin 3) gauss ?',type
if (type ne 2 and n_params() ne 2) then read,'window width?',wb
if (type ne 2) then wb=((wb < 1.0) > 0.0)   		; trim wb within range

symk= keyword_set(sym)
ix=indgen(!x_pe+2)
iy=indgen(!y_pe+2)
wx=float(ix)
wy=float(iy)
x=(wx-symk*0.5)
y=(wy-symk*0.5)
case type of
1:	begin
	wbind=fix((1-wb)*!x_pe)/2
	wx(0:wbind)=(1-cos(x(0:wbind)/float(wbind)*!pi))/2.0
	print,wbind,!x_pe-wbind,size(wx)
	wx(!x_pe-wbind+1:*)=(1+cos(x(0:wbind)/float(wbind)*!pi))/2.0
	if (wb gt 0) then wx(wbind+1:!x_pe-wbind)=1.0
	wbind=fix((1-wb)*!y_pe)/2
	wy(0:wbind)=(1-cos(y(0:wbind)/float(wbind)*!pi))/2.0
	wy(!y_pe-wbind+1:*)=(1+cos(y(0:wbind)/float(wbind)*!pi))/2.0
	if (wb gt 0) then wy(wbind+1:!y_pe-wbind)=1.0
	end
2:	begin 
	wx=sin(x/float(!x_pe+2-symk)*!pi)
	wy=sin(y/float(!y_pe+2-symk)*!pi)
	end
3:	begin 
	wx=exp(-((x-!x_pe/2.0-1+symk)/!x_pe/wb)^2)
	wx=(wx-wx(0))/(wx(!x_pe/2+1)-wx(0))
	wy=exp(-((y-!y_pe/2.0-1+symk)/!y_pe/wb)^2)
	wy=(wy-wy(0))/(wy(!y_pe/2+1)-wy(0))
	end
endcase
window=wx(1:!x_pe)#wy(1:!y_pe)
for i=0,!x_pe-1 do for j=0,!y_pe-1 do !csi_dat(*,i,j)=!csi_dat(*,i,j)*window(i,j)
return
end
	

