pro windcsix,wb,sym=sym
;
; Window procedure for !csi_dat, for windowing in spatial domain.
; Choices of windows: 1) 1+cos, 2) sin 3) gauss (to zero by substraction)
; wb controles the width of the gauss curve or the part that the 1+cos window
; will be equal to one.
; If sym is active, a symetric window will be used, otherwise he will be at
; !dim/2 {half point asymetric}.
;
symk= keyword_set(sym)
wndow=dcomplexarr(34,34)
filtpts=double(!x_pe)*wb/2.0

FOR j=1,!x_pe DO BEGIN
  FOR i=1,!y_pe DO BEGIN
    
    rad = ((double(i)-(double(!y_pe+1)/2))^2+ (double(j)-(double(!x_pe+1)/2))^2)^0.5
    radf=rad-double(!x_pe-1)/2.0+filtpts
    IF rad GT (-.05+double(!x_pe-1)/2.0) THEN BEGIN
      wndow(i,j)=dcomplex(0)
    ENDIF ELSE IF rad GT (double(!x_pe/2.0)-filtpts) THEN BEGIN
      wndow(i,j)=dcomplex((cos(!dpi*radf*0.5/filtpts)))
    ENDIF ELSE BEGIN
      wndow(i,j)=dcomplex(1.0)
    ENDELSE
  END
END

for i=0,!x_pe-1 do for j=0,!y_pe-1 do !csi_dat(*,i,j)=!csi_dat(*,i,j)*wndow(i+1,j+1)
;for i=0,!x_pe-1 do for j=0,!y_pe-1 do !csi_dat(*,i,j)=!csi_dat(*,i,j)*0
return
end
	

