function apply_phase, in_arr, in_phase

; function to apply a zeroth and first order phase correction

dims=size(in_arr)
dim0=dims(1)
dim1=dims(2)

x_vals=float(indgen(dim0)-dim0/2)

for i=0, dim1-1 do begin
  temp_arr=in_arr(*,i)
  temp_arr=shift(fft(shift(temp_arr, dim0/2), 1), dim0/2)
  temp_pha=in_phase(i,0)+in_phase(i,1)*x_vals
  re_temp=float(temp_arr)*cos(temp_pha)+imaginary(temp_arr)*sin(temp_pha)
  im_temp=-float(temp_arr)*sin(temp_pha)+imaginary(temp_arr)*cos(temp_pha)
  temp_arr=complex(re_temp, im_temp)
  temp_arr=shift(fft(shift(temp_arr, dim0/2), -1), dim0/2)
  in_arr(*,i)=temp_arr
endfor

return, in_arr

end
