function grad_test_results, fname, ret_val=ret_val

if (n_elements(ret_val) eq 0) then ret_val=0

in_arr=read_varian_bin_data(fname)

dims=size(in_arr)
fid_size=dims(1)/2
num_fids=dims(2)

stability=fltarr(num_fids)
amp_stability=fltarr(num_fids)
bo_stability=fltarr(num_fids)
out_spectra=complexarr(fid_size*4, num_fids)

for i=0, num_fids-1 do begin
  tmp_arr=reform(in_arr(*,i), 2, fid_size)
  cmplx_tmp_arr=reform(complex(tmp_arr(0,*), tmp_arr(1,*)))
  filled_cmplx_tmp_arr=complexarr(fid_size*4)
  filled_cmplx_tmp_arr(0:fid_size-1)=cmplx_tmp_arr
  ft_filled_cmplx_tmp_arr=shift(fft(filled_cmplx_tmp_arr,1),fid_size*2)
  out_spectra(*,i)=ft_filled_cmplx_tmp_arr
  max_val=where( abs(ft_filled_cmplx_tmp_arr) eq $
               max( abs(ft_filled_cmplx_tmp_arr) ) )
  max_val=max_val(0)
  phase_spec=atan(imaginary(ft_filled_cmplx_tmp_arr(max_val)), $
     float(ft_filled_cmplx_tmp_arr(max_val)))
  stability(i)=phase_spec
  amp_stability(i)=abs(ft_filled_cmplx_tmp_arr(max_val))
  bo_stability(i)=max_val
endfor

diff_stability=stability-total(stability)/n_elements(stability)
frac_amp_stability= 100.0 * $
   (amp_stability-total(amp_stability)/n_elements(amp_stability)) / $
           (total(amp_stability)/n_elements(amp_stability))

diff_stability=diff_stability/!pi*180.0

if (ret_val eq 0) then begin
  return, out_spectra
endif

if (ret_val eq 1) then begin
  plot, ytitle="phase stab, degs", diff_stability, $
         yrange=[min(diff_stability), max(diff_stability)]
  tmp_mean=total(diff_stability)/n_elements(diff_stability)
  tmp_var=total((diff_stability-tmp_mean)^2)/ $
           (n_elements(diff_stability)-1)
  print, "mean = ", tmp_mean
  print, "stdev = ", sqrt(tmp_var)
  return, diff_stability
endif

if (ret_val eq 2) then begin
  plot, ytitle="percent amp stab", frac_amp_stability, $
         yrange=[min(frac_amp_stability), max(frac_amp_stability)]
  tmp_mean=total(frac_amp_stability)/n_elements(frac_amp_stability)
  tmp_var=total((frac_amp_stability-tmp_mean)^2)/ $
           (n_elements(frac_amp_stability)-1)
  print, "mean = ", tmp_mean
  print, "stdev = ", sqrt(tmp_var)
  return, frac_amp_stability
endif

if (ret_val eq 3) then begin
  plot, ytitle="bo drift, arb units", bo_stability, $
           yrange=[min(bo_stability), max(bo_stability)]
  return, bo_stability
endif

return, diff_stability

end
