;=============================================================================
function phase_fit, phase_vals, mag_vals, fit_order
;=============================================================================
; does a weighted phase fit on a 1D phase profile

dims=size(phase_vals)
dim0=dims(1)
 
; calculate the weighting array
weight_arr=(mag_vals*mag_vals)

; weighted least squares
x_vals=float(indgen(dim0)-dim0/2)
fit_params=polyfitw(x_vals, phase_vals, weight_arr, fit_order)

return, fit_params  ; returns the phase fit coefficients
 
end
