pro quick_recon, dir, slice, fstem

on_error, 2

acq_params=read_epi_header(dir+'/dat.fid/fid.header')

if (acq_params.err eq -1) then goto, break_out

npoints=acq_params.np
nviews=acq_params.nv
nslices=acq_params.ns
nints=acq_params.num_ints
ntpts=acq_params.num_images*acq_params.num_dels

tmp_arr=read_varian_bin_data(dir+'/ref.fid/fid')
ref_arr=varian_bin_to_epi(tmp_arr,npoints,nviews,nslices,nints,1)

tmp_arr=read_varian_bin_data(dir+'/dat.fid/fid') 
data_arr=varian_bin_to_epi(tmp_arr,npoints,nviews,nslices,nints,ntpts)

if ((n_elements(data_arr) gt 1) and (n_elements(ref_arr) gt 1)) then begin
  data_arr=ss_phased_fft(ref_arr, data_arr, npoints, nviews, nslices, nints, $
     ntpts, slice, verbose=0, baseline=1)
endif

write_data, dir, fstem, data_arr, npoints, nviews, 1, ntpts, $
  header_flag=1, slice_no=slice

break_out:

end
