pro raw_varian_recon, exp_dir
 
on_error, 2
verbose=1

data_file=exp_dir+'/acqfil/fid'
data_file=exp_dir+'/ref.fid/fid'

acq_params=read_epi_header(data_file+'.header')

if (acq_params.err eq -1) then goto, break_out

npoints=acq_params.np
nviews=acq_params.nv
nslices=acq_params.ns
nints=acq_params.num_ints
ntpts=acq_params.num_images*acq_params.num_dels

tmp_arr=read_varian_bin_data(data_file) 
data_arr=varian_bin_to_epi(tmp_arr,npoints,nviews,nslices,nints,ntpts)

for sl_no=0, nslices-1 do begin
  for i=0, nviews/(2*nints)-1 do begin
    data_arr(*,2*i*nints:(2*i+1)*nints,sl_no)= $
      rotate(data_arr(*,2*i*nints:(2*i+1)*nints,sl_no), 2)
  endfor
endfor

for sl_no=0, nslices-1 do begin
  tvscl, rebin(abs(data_arr(*,*,sl_no)), 128, 128, sample=1), sl_no
endfor

wait, 2

tvscl, data_arr(*,*,0)
profiles, data_arr(*,*,0)
print, npoints

for sl_no=0, nslices-1 do begin
  data_arr(*,*,sl_no)=shift(fft(shift(data_arr(*,*,sl_no), $
           npoints/4, nviews/2), 1), npoints/4, nviews/2)
  tvscl, rebin(abs(data_arr(*,*,sl_no)), 128, 128, sample=1), sl_no
endfor

if (ntpts eq 1) then begin
  adjct
  wait, 2
end

break_out:

end
