function ref_phase_fit, in_arr1, in_arr2

debug_flag=0

dims=size(in_arr1)
dim0=dims(1)
out_arr=fltarr(2) ; output array (0th and 1st order phase diff)

; for each slice and diffusion value, need to calculate the 1st order phase diff
fit_order=1 ; order of the polynomial fit

center_weight_flag=1
; if the center weighting flag is set then the phase fit is weighted to the 
; center of the profile in addition to the intensity weighting
if (center_weight_flag eq 0) then center_wt_arr=fltarr(dim0)+1.0
if (center_weight_flag eq 1) then begin
  temp_arr=(float(indgen(dim0))-dim0/2)/(dim0/2)
  weight_fact=0.8  ; 0.2 gives about 80% at edges, 0.4 gives 65%, 0.6 gives 55%
  center_wt_arr=exp(-weight_fact*temp_arr*temp_arr)
endif

temp_prof1=in_arr1
temp_prof1=shift(fft(shift(temp_prof1, dim0/2), 1), dim0/2) 
pha_temp_prof1=acos(float(temp_prof1)/abs(temp_prof1))
pha_temp_prof1=pha_temp_prof1*2.0*((imaginary(temp_prof1) gt 0.0)-0.5)
temp_prof2=in_arr2
temp_prof2=shift(fft(shift(temp_prof2, dim0/2), 1), dim0/2) 
pha_temp_prof2=acos(float(temp_prof2)/abs(temp_prof2))
pha_temp_prof2=pha_temp_prof2*2.0*((imaginary(temp_prof2) gt 0.0)-0.5)
pha_diff0=pha_temp_prof2-pha_temp_prof1 ; phase difference
pha_diff0=phase_correct(pha_diff0) ; unwrap pi bounces

pha_vals=phase_fit(pha_diff0, abs(temp_prof1)*center_wt_arr, fit_order)

if (debug_flag) then begin
  plot, pha_diff0, yrange=[min(pha_diff0), max(pha_diff0)]
  x_vals=float(indgen(dim0)-dim0/2)
  y_vals=fltarr(dim0)+pha_vals(0)
  for mm=1, fit_order do begin
    y_vals=y_vals+pha_vals(mm)*x_vals
    x_vals=x_vals*x_vals
  endfor
  oplot, y_vals
  wait, 1
endif

out_arr(0)=pha_vals(0)  ; zeroth order phase fit value
out_arr(1)=pha_vals(1)  ; first order phase fit value

return, out_arr

end
