pro ref_varian_recon, exp_dir
 
on_error, 2
verbose=1

window, xsize=256, ysize=256

!err=0

while (!err ne 4) do begin
  ref_file=exp_dir+'/acqfil/fid'

  acq_params=read_epi_header(ref_file+'.header')

  if (acq_params.err eq -1) then goto, break_out

  npoints=acq_params.np
  nviews=acq_params.nv
  nslices=acq_params.ns
  nints=acq_params.num_ints
  ntpts=acq_params.num_images*acq_params.num_dels

  if (nslices gt 1) then begin
    print, "Error: Only single slice reference scan analysis allowed..."
    goto, break_out
  endif

  tmp_arr=read_varian_bin_data(ref_file)
  ref_arr=reform(tmp_arr, 2, npoints/2, nviews/nints)
  ref_arr=complex(ref_arr(0,*,*), ref_arr(1,*,*))
  ref_im=reform(ref_arr)

  for i=0, nviews/(2*nints)-1 do begin
    ref_im(*,2*i)=rotate(ref_im(*,2*i), 2)
  endfor

  tvscl, rebin(abs(ref_im), 256, 256, sample=1)
  wait, 1
  print, "LMB to reload, RMB to quit..."
  cursor, xerr, yerr, /WAIT, /DEVICE
endwhile

break_out:

end
