function ss_phased_fft, ref_arr, in_arr, npoints, nviews, nslices, nints, $
   ntpts, slice, verbose=verbose, baseline=baseline

if (n_elements(verbose) eq 0) then verbose=0
if (n_elements(baseline) eq 0) then baseline=0

;=============================================================================
; CALCULATE THE EPI NYQUIST GHOST PHASE CORRECTION
;=============================================================================
; odd_k is the odd k space line nearest spin echo
; even_k is the even k space line nearest spin echo
odd_k=nviews/2-1
even_k=nviews/2

ref_arr=reform(ref_arr(*,*,slice-1))
ref_phases=ref_phase_calc(ref_arr, odd_k, even_k)

if (verbose) then begin
  tvscl, abs(ref_arr(*,*))
endif

ref_phase_arr=fltarr(nviews, 2)
  for i=0, nviews/(2*nints)-1 do begin
    for j=0, nints-1 do begin
      k_line=i*2*nints+j
      ref_phase_arr(k_line, *)=ref_phases(*)
    endfor
endfor
 
if (verbose) then begin
  ref_arr(*,*)=apply_phase(ref_arr(*,*), $
         reform(ref_phase_arr(*,*), nviews, 2))
  tvscl, abs(ref_arr(*,*))
endif
 
in_arr=reform(in_arr(*,*,slice-1,*))

if (baseline eq 1) then begin
  for time_no=0, ntpts-1 do begin
    base_line=total(in_arr(*,nviews-1, time_no))/(npoints/2)
    in_arr(*,*,time_no)=in_arr(*,*,time_no)-base_line
  endfor
endif

for time_no=0, ntpts-1 do begin
  in_arr(*,*, time_no)=apply_phase(in_arr(*,*, time_no), $
                       reform(ref_phase_arr(*,*), nviews, 2))
  if (verbose) then tvscl, abs(shift(fft(shift(in_arr(*,*, time_no), $
       npoints/4, nviews/2), 1), npoints/4, nviews/2))
endfor

return, in_arr

end
