function transmit_stability, fname

in_arr=read_varian_bin_data(fname)

dims=size(in_arr)
fid_size=dims(1)/2
num_fids=dims(2)

stability=fltarr(num_fids)

for i=0, num_fids-1 do begin
  tmp_arr=reform(in_arr(*,i), 2, fid_size)
  cmplx_tmp_arr=reform(complex(tmp_arr(0,*), tmp_arr(1,*)))
  stability(i)=total(abs(cmplx_tmp_arr))
endfor

mean_stability=total(stability)/num_fids

frac_stability=stability/mean_stability*100.0

plot, frac_stability, yrange=[min(frac_stability), max(frac_stability)]

return, frac_stability

end
