pro slice_select_stability

ans=string(0)
print, format='($, "non shaped waveform (1) or shaped waveform (2)")'
read, ans
ans=strtrim(string(ans), 2)
orient=string(0)
print, format='($, "Input orientation (trans, sag or cor)")'
read, orient

fname='~/vnmrsys/qa_tests/slice_select_stability_'+orient+ans+'.fid/fid'

im=read_varian_bin_data(fname)

dims=size(im)
fid_size=dims(1)/2
n_fids=dims(2)
im=reform(im, 2, fid_size, n_fids)
im=reform(complex(im(0,*,*),im(1,*,*)))

; subtract off the first fid, which should be the baseline offset

for i=1, n_fids-1 do begin
  im(*,i)=im(*,i)-im(*,0)
endfor

im=im(*,2:n_fids-1)
n_fids=n_fids-2

; zero_fill

big_im=complexarr(fid_size*4,n_fids)
big_im(0:fid_size-1,*)=im

for i=0, n_fids-1 do begin
  big_im(*,i)=shift(fft(big_im(*,i)),fid_size*2)
endfor

big_im=abs(big_im)

running_av=fltarr(n_fids)

for i=0, n_fids-1 do begin
  running_av(i)=max(big_im(*,i))
endfor

overall_av=total(running_av)/n_fids
running_av=running_av/overall_av*100.0

plot, title='slice select stability', running_av, yrange=[98,102]

var_stab=total((running_av-100.0)^2)/(n_fids-1)

print, "standard deviation (%) = ", sqrt(var_stab)
print, "max excursion = ", max(running_av)-100.0
print, "min excursion = ", min(running_av)-100.0

end
