pro test

; read, fid
; fid=fix(fid)

; str_fid=strtrim(string(fid),2)
; fname='/scratch/devdir/001292_1999_09_13/series_3.'+str_fid+'.fid/fid'
fname='/export/home/devdir/vnmrsys/exp3/acqfil/fid'

im=read_varian_bin_data(fname)

dims=size(im)
fid_size=dims(1)/2
n_fids=dims(2)
im=reform(im, 2, fid_size, n_fids)
im=reform(complex(im(0,*,*),im(1,*,*)))

; subtract off the first fid, which is not in steady state

im=im(*,2:n_fids-1)
n_fids=n_fids-2

; zero_fill

big_im=complexarr(fid_size*4,n_fids)
big_im(0:fid_size-1,*)=im

for i=0, n_fids-1 do begin
  big_im(*,i)=shift(fft(big_im(*,i)),fid_size*2)
endfor

big_im=abs(big_im)

running_av=fltarr(n_fids)

for i=0, n_fids-1 do begin
  running_av(i)=max(big_im(*,i))
endfor

overall_av=total(running_av)/n_fids
running_av=running_av/overall_av*100.0

plot, title='shaped pulse stability', running_av, yrange=[90,120]

var_stab=total((running_av-100.0)^2)/(n_fids-1)

print, "standard deviation (%) = ", sqrt(var_stab)
print, "max excursion = ", max(running_av)-100.0
print, "min excursion = ", min(running_av)-100.0

end
