pro wav_analyze

fname=string(0)
print, format='($,"Enter .fid filename")'
read, fname

im=read_varian_bin_data(fname+'/fid')
dims=size(im)
nslices=long(21)
nvols=dims(2)

im=reform(im, 2, 4096, nslices*nvols)

; set thresholds to try to get rid of some of the 50Hz hum
varian_thresh=max(im(0,*,*))/20
siemens_thresh=max(im(1,*,*))/20

re_im=im(0,*,*)
mask=where(abs(re_im) lt varian_thresh)
if (total(mask) gt -1) then begin
  re_im(mask)=0
  im(0,*,*)=re_im
endif

im_im=im(1,*,*)
mask=where(abs(im_im) lt siemens_thresh)
if (total(mask) gt -1) then begin
  im_im(mask)=0
  im(1,*,*)=im_im
endif

varian_var=fltarr(nslices*nvols)
siemens_var=fltarr(nslices*nvols)

; calculate sum-of-squares-difference
for i=0, nslices*nvols-1 do begin
  varian_var(i)=total((im(0,*,i)-im(0,*,0))^2)
  siemens_var(i)=total((im(1,*,i)-im(1,*,0))^2)
endfor

plot, varian_var
wait, 2
plot, siemens_var
wait, 2

stop

end
