#ifndef LINT
static char SCCSid[] = "@(#)sh2pul.c 13.1 10/10/97 Copyright (c) 1991-1996 Varian Assoc.,Inc. All Rights Reserved";
#endif

/*  sh2pul - Shaped Two-Pulse Sequence */ 
/*  shaped pulses using waveform generators or linear modulators */

#include <standard.h>

pulsesequence()
{
    int image;

    image=getval("image");
    getstr("pwpat",pwpat);
    getstr("p1pat",p1pat);
    if ((p1pat[0] == '\0') && (p1 != 0))
    {
        text_error("The parameter p1pat is missing or has a null value!");
        abort(1);
    }
    if ((pwpat[0] == '\0') && (pw != 0))
    {
        text_error("The parameter pwpat is missing or has a null value!");
        abort(1);
    }
    if (te < p1/2+pw/2) {
        text_error("te too short");
        abort(1);
    }
    status(A);
    sp4off();
      hsdelay(tr);
    status(B);
      obspower(tpwr1);
      obsoffset(tof-3.45*sfrq);
      if (image > 0) {
        sp4on();
        shaped_pulse(p1pat,p1,zero,rof1,rof2);
        sp4off();
      }
      obsoffset(tof);
      hsdelay(te/2-p1/2-pw/2);
    status(C);
      obspower(tpwr);
      sp1on();
      if (image > 0) {
        sp4on();
        shaped_pulse(pwpat,pw,oph,rof1,rof2);
        sp4off();
      }
      sp1off();
      hsdelay(te/2-pw/2);
}
