#ifndef LINT
static char SCCSid[] = "@(#)s2pul.c 11.1 05/07/96 Copyright (c) 1991-1996 Varian Assoc.,Inc. All Rights Reserved";
#endif

/*  set_freq - standard two-pulse sequence */

#include <standard.h>
#include "group.h"
#include "sequence_utilities.h"

pulsesequence()
{

   int image;
   double grate, grise, tep, pw_gss, pw_gssr;
   char shape_name[MAXSTR], err_string[MAXSTR];

   /*************************************************************************/
    /* get the global parameters */
    /*************************************************************************/
    P_getreal(GLOBAL,"grise",&grise,1); /* grad risetime to full strength */
    if ((grise < 0.0) || (grise > 0.002)) {
      sprintf(err_string,"%s: impropper grise time defined in global file\n",
                       seqfil);
      printf(err_string);
      log_error(err_string);
      abort(1);
    }
    P_getreal(GLOBAL,"tep",&tep,1); /* small tweaker time (us) to allow for
                            the gradient propagation time, causes echoes to
                            appear symmetrically about echo center line */
    tep=tep/1e6;
    /*************************************************************************/

   image=getval("image");
   grate = trise/gmax;

   sprintf(shape_name,"gss");
   pw_gss=create_trap_gradient(fabs(gss),shape_name,rof1+p1+rof2,grate,ix);

   sprintf(shape_name,"gssr");
   pw_gssr=create_trap_gradient(fabs(gss),shape_name,
           p1/2+rof2-grate*fabs(gss)/2.0,grate,ix);

   /* equilibrium period */
   status(A);
   sp4off();
   delay(tr);

   /* --- tau delay --- */
   status(B);

   /* --- observe period --- */
   status(C);
   obspower(tpwr1);
   if (image != 0) {
     if (image == 1) {  /* non shaped gradient mode */
       obl_gradient(0.0,0.0,gss);
       delay(grate*fabs(gss));
       sp4on();
       shaped_pulse(p1pat,p1,oph,rof1,rof2);
       sp4off();
       zero_all_gradients();
       delay(grate*fabs(gss));
       obl_gradient(0.0,0.0,-gss);
       delay(grate*fabs(gss));
       delay(p1/2+rof2-grate*fabs(gss)/2.0);
       zero_all_gradients();
       delay(grate*fabs(gss));
     } else {  /* shaped gradient mode */
       obl_shapedgradient("","","gss",pw_gss,0.0,0.0,gss,1,NOWAIT);
       delay(grate*fabs(gss)+tep);
       sp4on();
       shaped_pulse(p1pat,p1,oph,rof1,rof2);
       sp4off();
       if ((grate*fabs(gss)-tep) > 0.0) delay(grate*fabs(gss)-tep);
       obl_shapedgradient("","","gssr",pw_gssr,0.0,0.0,-gss,1,WAIT);
     }
   }

   acquire(np, 1.0/sw);
}
