pro calc_grad, map

; this code calculates the grad of the inputted array

common share1, roimap, dim0, dim1, dim2
common grads, gx, gy, gz

; first need to construct larger field_tmp so all shifts are legal
map_tmp=fltarr(dim0+2,dim1+2,dim2+2)
roi_tmp=fltarr(dim0+2,dim1+2,dim2+2)
map_tmp(1:dim0,1:dim1,1:dim2)=map(0:dim0-1,0:dim1-1,0:dim2-1)
roi_tmp(1:dim0,1:dim1,1:dim2)=float(roimap(0:dim0-1,0:dim1-1,0:dim2-1))

; calc grads
; Gradients are only used if both pixels have non-zero values.

roi1=shift(roi_tmp,1,0,0)
roi2=shift(roi_tmp,-1,0,0)
gxr=(map_tmp-shift(map_tmp,1,0,0))*roi1
gxl=((map_tmp-shift(map_tmp,-1,0,0))*(-1))*roi2
gx_tmp=(gxr+gxl)/(roi1*roi2+1.0)

roi1=shift(roi_tmp,0,1,0)
roi2=shift(roi_tmp,0,-1,0)
gyf=(map_tmp-shift(map_tmp,0,1,0))*roi1
gyb=((map_tmp-shift(map_tmp,0,-1,0))*(-1))*roi2
gy_tmp=(gyf+gyb)/(roi1*roi2+1.0)
    
roi1=shift(roi_tmp,0,0,1)
roi2=shift(roi_tmp,0,0,-1)
gzu=(map_tmp-shift(map_tmp,0,0,1))*roi1
gzd=((map_tmp-shift(map_tmp,0,0,-1))*(-1))*roi2
gz_tmp=(gzu+gzd)/(roi1*roi2+1.0)
  
; now need to map larger grad arrays onto properly sized arrays
gx=fltarr(dim0,dim1,dim2)
gx(0:dim0-1,0:dim1-1,0:dim2-1)=gx_tmp(1:dim0,1:dim1,1:dim2)
gy=fltarr(dim0,dim1,dim2)
gy(0:dim0-1,0:dim1-1,0:dim2-1)=gy_tmp(1:dim0,1:dim1,1:dim2)
gz=fltarr(dim0,dim1,dim2)
gz(0:dim0-1,0:dim1-1,0:dim2-1)=gz_tmp(1:dim0,1:dim1,1:dim2)
 

end
