pro adjt_win_event, event
common groupleader, base
common adjt_info, adjt_base

WIDGET_CONTROL, event.id, GET_UVALUE = eventval

CASE eventval OF
       "ADJ_LEV": BEGIN
            adjlev
            END

     "HARD_COPY": BEGIN
            WIDGET_CONTROL, base, SENSITIVE=0
            WIDGET_CONTROL, adjt_base, SENSITIVE=0
            screen_dump=tvrd(0,0,512,512)
            old_device=!D.NAME  ; make note of device type, eg 'X'
            set_plot, 'PS'   ; set up for postscript output
            device, file='~/idl.ps'    ; so it writes to home directory
            tv, screen_dump
            device, /close
            set_plot, old_device    ; set back to original device 
            print, 'screen sent to default printer device...'
            spawn, "hostname", hostname
            hostname=hostname(0)
            case hostname of
              'cyclops': begin
                 spawn, 'lpr -Pomega4T ~/idl.ps'
                 end
               else: spawn, 'lp ~/idl.ps'
            endcase
            WIDGET_CONTROL, base, SENSITIVE=1
            WIDGET_CONTROL, adjt_base, SENSITIVE=1
            end

       "INFO_TEXT": BEGIN
 print, ""
 print, "     This program is provided free to the user from the author."
 print, "     It is based on some IDL code originally developed by Han Wen"
 print, "     of the Laboratory of Cardiac Energetics, NHLBI, and was"
 print, "     subsequently expanded and developed by Peter Jezzard of NIH."
 print, "     Please report any bugs to jezzard@nih.gov, and I will do my"
 print, "     best to fix them, but I would appreciate not receiving"
 print, "     requests for help (other than initially) or additional"
 print, "     features. If you need additional features then please feel"
 print, "     free to edit the source code as needed. Eventually, there may"
 print, "     be a user manual, but so far I haven't had time to write one."
 print, "     Meanwhile, refer to Han Wen and Farouc A. Jaffer, An In Vivo"
 print, "     Automated Shimming Method Taking into Account Shim Current"
 print, "     Constraints, Magn. Reson. Med. 34:898-904 (1995) for further"
 print, "     details and please reference this paper and acknoweldge P."
 print, "     Jezzard if you use this software."
 print, ""

            END

ENDCASE

end

;*******************************************************************
pro adjt_win, GROUP=GROUP
common groupleader, base
common adjt_info, adjt_base

adjt_base=WIDGET_BASE(TITLE = 'OPTIONS', $
                   /COLUMN, $     ;Organize subsequent widgets in columns.
                   XOFFSET=200, YOFFSET=100, XSIZE=140)

adjt_button=WIDGET_BUTTON(adjt_base, $
                   VALUE="adjust grey levels", $
                   UVALUE="ADJ_LEV")

hard_copybutton=WIDGET_BUTTON(adjt_base, $
                   VALUE="hard copy", $
                   UVALUE="HARD_COPY")

info_button=WIDGET_BUTTON(adjt_base, $
                   VALUE="info", $
                   UVALUE="INFO_TEXT")

;realize the widgets:
WIDGET_CONTROL, adjt_base, /REALIZE

; Hand off to the XMANAGER:
XMANAGER, 'adjt_win', adjt_base, GROUP_LEADER = GROUP, /just_reg
end
