; written by Marcus Weiger, March 2001

FUNCTION Maxi, a, b
   IF a GE b THEN result = a ELSE result = b
   RETURN, result
END

;--------------------------------------------------

FUNCTION Mini, a, b
   IF a LT b THEN result = a ELSE result = b
   RETURN, result
END

;--------------------------------------------------
PRO avw_write, im, fname, voxdim

; JW, Mar 01, added voxel dimensions (fltarr(8)) as input params

COMMON Avw, avw_key, avw_dim, avw_his

; fill header
avw_head
s = SIZE(im)
n_dims = s(0)
n_cols = s(1)
n_rows = s(2)
IF n_dims GT 2 THEN n_slices = s(3) ELSE n_slices = 1
IF n_dims GT 3 THEN n_vols = s(4) ELSE n_vols = 1
help, im, output = h
data_types = ['BYTE', 'INT', 'LONG', 'FLOAT', 'COMPLEX', 'DOUBLE']
FOR i = 0, 5 DO BEGIN
   compare = stregex(h, data_types(i))
   IF compare(0) GT 0 THEN act_data_type = i
END

avw_key.sizeof_hdr(0)    = 348
avw_key.extents(0)       = 16384
avw_key.regular(0)       = 114
avw_dim.dim(0)           = n_dims
avw_dim.dim(1)           = n_cols
avw_dim.dim(2)           = n_rows
avw_dim.dim(3)           = n_slices
avw_dim.dim(4)           = n_vols
avw_dim.pixdim(*)        = voxdim(*)
CASE act_data_type OF
   0: BEGIN
      avw_dim.datatype(0) = 2
      avw_dim.bitpix(0) = 8
   END
   1: BEGIN
      avw_dim.datatype(0) = 4
      avw_dim.bitpix(0) = 16
   END
   2: BEGIN
      avw_dim.datatype(0) = 8
      avw_dim.bitpix(0) = 32
   END
   3: BEGIN
      avw_dim.datatype(0) = 16
      avw_dim.bitpix(0) = 32
   END
   4: BEGIN
      avw_dim.datatype(0) = 32
      avw_dim.bitpix(0) = 64
   END
   5: BEGIN
      avw_dim.datatype(0) = 64
      avw_dim.bitpix(0) = 64
   END
ENDCASE
IF avw_dim.datatype(0) EQ 32 THEN BEGIN 
   avw_dim.glmax(0)      = mini(MAX(ABS(im)),2e32-1)
   avw_dim.glmin(0)      = maxi(MIN(ABS(im)),-2e32+1)
END ELSE BEGIN
   avw_dim.glmax(0)      = mini(MAX(im),2e32-1)
   avw_dim.glmin(0)      = maxi(MIN(im),-2e32+1)
END

; write header
GET_LUN, unit
OPENW, unit, fname+'.hdr'
WRITEU, unit, avw_key, avw_dim, avw_his
CLOSE, unit
FREE_LUN, unit

; write data
CASE avw_dim.datatype(0) OF 
   2:  tmp_im=REFORM(BYTARR(n_cols, n_rows, n_slices))
   4:  tmp_im=REFORM(INTARR(n_cols, n_rows, n_slices))
   8:  tmp_im=REFORM(LONARR(n_cols, n_rows, n_slices))
   16: tmp_im=REFORM(FLTARR(n_cols, n_rows, n_slices))
   32: tmp_im=REFORM(COMPLEXARR(n_cols, n_rows, n_slices))
   64: tmp_im=REFORM(DBLARR(n_cols, n_rows, n_slices))
ENDCASE

GET_LUN, unit
OPENW, unit, fname+'.img'
FOR i=0, n_vols-1 DO BEGIN
   IF (n_slices EQ 1) THEN tmp_im(*,*)=im(*,*,i) ELSE tmp_im(*,*,*)=im(*,*,*,i)
   WRITEU, unit, tmp_im
ENDFOR
CLOSE, unit
FREE_LUN, unit
END
