PRO cal_system_win_event, event
; This is the event handler for a text widget with a label.

; Get the widget ID of any widget touched and put it into 'eventval'.
; Pressing the RETURN key inside a text widget generates an event:

common file_info, directory, filename, filename2, map_dim0, map_dim1, $
       map_slices, map2_dim0, map2_dim1, map2_slices, file_type, smooth_val
common misc_flags, data_loaded_flag, field_unwrapped_flag
common groupleader, base
common cal_sys_bases, cal_sys_base, diff_fieldmap, calc_arr, nudge_im_slide
common field_map_data, phsmap, allimg, fieldmap, strucmap
common shareroi, roimap, topb, botb, lefb, rightb
common roi_def_info, thresh_val, erosion_val, start_im, stop_im, draw_im,$
   num_slices, drawn_roi, dilation_val, edit_im, nudge_im
common shareunwrap, alignrow, aligncolumn, connectionmap, uncoloredmap,$
      colortab, colorlink, colorindex, colorindmap, totcolor, linkcord,$
      pointbak, slcn,map, max_colors, bounce_thresh, roiconnmap, connmap,$
      no_color_bounce
common shareshim, slo, slsep, fov, fovz, te, plane

WIDGET_CONTROL, event.id, GET_UVALUE = eventval

; Perform different actions based upon 'eventval':

temp_var=string(0)

CASE eventval OF
	"DIRECTORY": BEGIN
		  ;A RETURN has been pressed in the Directory field
                  WIDGET_CONTROL, event.id, GET_VALUE=temp_var
                  directory=temp_var(0)
		  END

	"FILENAME": BEGIN
		  ;A RETURN has been pressed in the Filename field
                  WIDGET_CONTROL, event.id, GET_VALUE=temp_var
                  filename2=temp_var(0)
		  END

        "SMOOTH":BEGIN
                  WIDGET_CONTROL, event.id, GET_VALUE=str
                  smooth_val=fix(str(0))
                  END

        "FIT_WIN":BEGIN
                  WIDGET_CONTROL, cal_sys_base, SENSITIVE=0
                  if (n_elements(diff_fieldmap) gt 0) then begin
                    fit_coeff_win
                  endif else begin
                    print, "Error: no difference field map generated..."
                    WIDGET_CONTROL, cal_sys_base, SENSITIVE=1
                  endelse
                  END

      "NUDGE_VAL":BEGIN
                WIDGET_CONTROL, event.id, GET_VALUE=str
                nudge_im=fix(str(0))
                if (nudge_im lt start_im) then begin
                  nudge_im=start_im
                  WIDGET_CONTROL, nudge_im_slide, SET_VAL=nudge_im
                endif
                if (nudge_im gt stop_im) then begin
                  nudge_im=stop_im
                  WIDGET_CONTROL, nudge_im_slide, SET_VAL=nudge_im
                endif
                END 

        "NUDGE_MAP":BEGIN
                print, "nudge from image : "+strtrim(string(nudge_im), 2)
                if (n_elements(diff_fieldmap) lt 1) then begin
                  print, "Error: Difference fieldmap not yet generated..."
                endif else begin
                  WIDGET_CONTROL, cal_sys_base, SENSITIVE=0
                  print, "left button in area to decrease by 2*pi"
                  print, "middle button in area to increase by 2*pi"
                  print, "right button to end"
                  tmp_im=bytscl(diff_fieldmap(*,*,nudge_im-1))
                  dims=size(tmp_im)
                  tvscl, rebin(tmp_im, 512, 512, sample=1)
                  tvrdc, x_pos, y_pos, 1, /dev
                  while (!err ne 4) do begin
                    if (!err eq 1) then begin
                      x_pos=x_pos/(512/dims(1))
                      y_pos=y_pos/(512/dims(2))
                      if (roimap(x_pos,y_pos,nudge_im-1) eq 1) then begin
                        color_index=colorindmap(x_pos,y_pos,nudge_im-1)
                        tmp_colorindmap=colorindmap(*,*,nudge_im-1)
                        new_colorindmap=tmp_colorindmap*0
                        mask=where(tmp_colorindmap eq color_index)
                        if (total(mask) gt -1) then new_colorindmap(mask)=1
                        tmp_fieldmap=diff_fieldmap(*,*,nudge_im-1)
                        tmp_fieldmap=tmp_fieldmap-new_colorindmap*2*!pi/te
                        diff_fieldmap(*,*,nudge_im-1)=tmp_fieldmap
                      endif
                    endif
                    if (!err eq 2) then begin
                      x_pos=x_pos/(512/dims(1))
                      y_pos=y_pos/(512/dims(2))
                      if (roimap(x_pos,y_pos,nudge_im-1) eq 1) then begin
                        color_index=colorindmap(x_pos,y_pos,nudge_im-1)
                        tmp_colorindmap=colorindmap(*,*,nudge_im-1)
                        new_colorindmap=tmp_colorindmap*0
                        mask=where(tmp_colorindmap eq color_index)
                        if (total(mask) gt -1) then new_colorindmap(mask)=1
                        tmp_fieldmap=diff_fieldmap(*,*,nudge_im-1)
                        tmp_fieldmap=tmp_fieldmap+new_colorindmap*2*!pi/te
                        diff_fieldmap(*,*,nudge_im-1)=tmp_fieldmap
                      endif
                    endif
                    tmp_im=bytscl(diff_fieldmap(*,*,nudge_im-1))
                    dims=size(tmp_im)
                    tvscl, rebin(tmp_im, 512, 512, sample=1)
                    tvrdc, x_pos, y_pos, 1, /dev
                  endwhile
                  dims=size(diff_fieldmap)
                  b0mapimg=bytscl(diff_fieldmap)
                  err=display_ims(b0mapimg(*,*,*,0))
                  WIDGET_CONTROL, cal_sys_base, SENSITIVE=1
                endelse
                END

	"EXECUTE": BEGIN
                  data_loaded_flag=0
                  WIDGET_CONTROL, cal_sys_base, SENSITIVE=0
                  done_flag=0
                  load_ok_flag=0
                  ; check to see if file is there
                  spawn, './find_file.scr '+directory+'/'+filename2, $
                          roi_def_flag
                  if (fix(roi_def_flag(0)) eq 1) then begin
                    load_ok_flag=1
                  endif else begin
                    load_ok_flag=0
                    print, 'Error : File '+directory+'/'+filename2+ $
                               ' not found'
                  endelse

                  err=-1
                  if (load_ok_flag eq 1) then begin
                    print, "loading base field map data..."

                    erase
                    data_loaded_flag=1
                    print, "reading in "+directory+"/"+filename2+"..."
                    base_fieldmap=fieldmap
                    base_roimap=roimap ; to stop roimap getting overwritten
                    base_phsmap=phsmap ; make a note of phsmap
                    base_allimg=allimg ; make a note of allimg array
                    case file_type of
                      0: begin ; Omega data
                        err=read_omega_data(directory+'/'+filename2,smooth_val)
                      end
                      1: begin ; Varian data
                        err=read_varian_data(directory, filename2, smooth_val)
                      end
                      2: begin ; Signa data
                        err=read_signa_data(directory, filename2, smooth_val)
                      end
                      3: begin ; Bruker data
                        err=read_bruker_data(directory+'/'+filename2,smooth_val)
                      end
                      else: begin
                        print, "^GUnrecognised file format... Cannot read file"
                        print, "Check sys_names array in read_sys_names.pro"
                        data_loaded_flag=0
                      end
                    endcase
                    if (err ne 0) then begin
                      print, "Error: Can't read file "+directory+'/'+filename2
                    endif
                    if (err eq 0) then begin
                      roimap=base_roimap ; retrieve roimap
                      calc_field
                      diff_fieldmap=fieldmap-base_fieldmap
                      fieldmap=base_fieldmap ; retrieve old fieldmap
                      phsmap=base_phsmap ; retrieve old roimap
                      allimg=base_allimg ; retrieve old allimg array
                      wait, 0.25
                      print, "field difference map..."
                      dims=size(diff_fieldmap)
                      b0mapimg=bytscl(diff_fieldmap)
                      err=display_ims(b0mapimg(*,*,*,0))
                      ; calculate the variance
                      mask_arr=where(roimap(*,*,*) ne 0)
                      av_field=0.0
                      std_field=0.0
                      if (total(mask_arr) gt -1) then begin
                        av_field=total(diff_fieldmap(mask_arr))/ $
                              n_elements(mask_arr)
                        var_field=(diff_fieldmap(mask_arr)-av_field)* $
                              (diff_fieldmap(mask_arr)-av_field)
                        var_field=total(var_field)/(n_elements(mask_arr)-1)
                        std_field=sqrt(var_field)
                      endif

                      print, "average diff field (Hz) = ", av_field/(2.0*!pi)
                      print, "standard deviation (Hz) = ", std_field/(2.0*!pi)
                      if (n_elements(nudge_im_slide) gt 0) then begin
                        WIDGET_CONTROL, nudge_im_slide, SET_VAL=nudge_im
                      endif
                    endif
                  endif
                  WIDGET_CONTROL, cal_sys_base, SENSITIVE=1
                  END 

	"SAVE_FDMAP": BEGIN
                  WIDGET_CONTROL, cal_sys_base, SENSITIVE=0
                  if (n_elements(diff_fieldmap) gt 0) then begin
                    get_lun, unit
                    openw, unit, '~/field_diff_map.bin'
                    writeu, unit, diff_fieldmap/(2.0*!pi)
                    close, unit
                    free_lun, unit
                    print, "difference field map written in flat "+ $
                      "floating point binary format (Hz)"
                    dims=size(diff_fieldmap)
                    print, "filename=~/field_diff_map.bin, "+ $
                      "dimsensions :"+strtrim(string(dims(1)),2)+"x"+ $
                      strtrim(string(dims(2)),2)+"x"+strtrim(string(dims(3)),2)
                  endif else begin
                    print, "No difference field map generated"
                  endelse
                  WIDGET_CONTROL, cal_sys_base, SENSITIVE=1
                  END 

	"SAVE_FMAP": BEGIN
                  WIDGET_CONTROL, cal_sys_base, SENSITIVE=0
                  if (n_elements(fieldmap) gt 0) then begin
                    get_lun, unit
                    openw, unit, '~/field_map.bin'
                    writeu, unit, fieldmap/(2.0*!pi)
                    close, unit
                    free_lun, unit
                    print, "field map written in flat floating point "+ $
                      "binary format (Hz)"
                    dims=size(fieldmap)
                    print, "filename=~/field_map.bin, "+ $
                      "dimsensions :"+strtrim(string(dims(1)),2)+"x"+ $
                      strtrim(string(dims(2)),2)+"x"+strtrim(string(dims(3)),2)
                  endif else begin
                    print, "No field map generated"
                  endelse
                  WIDGET_CONTROL, cal_sys_base, SENSITIVE=1
                  END 

	"CANCEL": BEGIN
                  WIDGET_CONTROL, base, SENSITIVE=1
                  WIDGET_CONTROL, cal_sys_base, /DESTROY
                  END 

ENDCASE

END



PRO cal_system_win, GROUP = GROUP

common file_info, directory, filename, filename2, map_dim0, map_dim1, $
       map_slices, map2_dim0, map2_dim1, map2_slices, file_type, smooth_val
common misc_flags, data_loaded_flag, field_unwrapped_flag
common groupleader, base
common cal_sys_bases, cal_sys_base, diff_fieldmap, calc_arr,  nudge_im_slide
common roi_def_info, thresh_val, erosion_val, start_im, stop_im, draw_im,$
   num_slices, drawn_roi, dilation_val, edit_im, nudge_im

cal_sys_base = WIDGET_BASE(TITLE = 'LOAD CALIBRATION DATA', $
		   /COLUMN, $ ;Organize subsequent widgets in columns.
                   XOFFSET=1, YOFFSET=1)

; Make a ROW base widget so the label and text field can be
; side by side:

WIDGET_CONTROL, base, SENSITIVE=0

row1 = WIDGET_BASE(cal_sys_base, /ROW, /FRAME)
namelabel1 = WIDGET_LABEL(row1, VALUE = 'Directory:')
name1 = WIDGET_TEXT(row1, /EDITABLE, XSIZE = 30, YSIZE = 1, $
		   UVALUE = 'DIRECTORY', VALUE = directory)

row2 = WIDGET_BASE(cal_sys_base, /ROW, /FRAME)
namelabel2 = WIDGET_LABEL(row2, VALUE = ' Filename:')
name2 = WIDGET_TEXT(row2, /EDITABLE, XSIZE = 30, YSIZE = 1, $
		   UVALUE = 'FILENAME', VALUE = filename2)

min_smooth=1
max_smooth=10
smooth_slide = WIDGET_SLIDER(cal_sys_base, minimum=min_smooth, xsize=300, $
    maximum=max_smooth, title='smooth value', /FRAME, UVALUE='SMOOTH', $
    value=smooth_val)

load_data_button=WIDGET_BUTTON(cal_sys_base, UVALUE="EXECUTE", $
       VALUE="load calibration data")

  inner_base = WIDGET_BASE(cal_sys_base, /row)

  nudge_ROI_button=WIDGET_BUTTON(inner_base, UVALUE='NUDGE_MAP', $
     value='nudge map')

if (num_slices gt 1) then begin
  min_nudge_im=1
  max_nudge_im=num_slices
  nudge_im_slide = WIDGET_SLIDER(inner_base, minimum=min_nudge_im, xsize=225, $
   maximum=max_nudge_im, title='nudge image :', /FRAME, $
    UVALUE='NUDGE_VAL', value=nudge_im)
endif

fit_data_button=WIDGET_BUTTON(cal_sys_base, UVALUE="FIT_WIN", VALUE="fit data")

save_fieldmap_button=WIDGET_BUTTON(cal_sys_base, UVALUE="SAVE_FMAP", $
    VALUE="save base field")

save_field_diff_button=WIDGET_BUTTON(cal_sys_base, UVALUE="SAVE_FDMAP", $
    VALUE="save difference field")

canc_button=WIDGET_BUTTON(cal_sys_base, UVALUE="CANCEL", VALUE="cancel")

; Realize the widgets:
WIDGET_CONTROL, cal_sys_base, /REALIZE

; Hand off to the XMANAGER:
XMANAGER, 'cal_system_win', cal_sys_base, GROUP_LEADER = base

END
