pro construct_voi, contiguity_flag

common field_map_data, phsmap, allimg, fieldmap, strucmap
common shareroi, roimap, topb, botb, lefb, rightb
common roi_def_info, thresh_val, erosion_val, start_im, stop_im, draw_im,$
   num_slices, drawn_roi, dilation_val, edit_im, nudge_im
COMMON roi_base_info, roi_base, start_im_slide, stop_im_slide, draw_im_slide, $
  edit_im_slide, thresh_slide, erosion_slide, dilation_slide, edit_roi, $
  nudge_im_slide

; first step is to apply any ROI that may have been drawn
if (total(drawn_roi) gt -1) then begin
  for i=0, num_slices-1 do begin
    tmp_im=roimap(*,*,i)
    tmp_im(drawn_roi)=0
    roimap(*,*,i)=roimap(*,*,i)-tmp_im
  endfor
endif

roimap=roimap*edit_roi ; in case there have been additional edits

; next apply any thresholding
max_data_val=max(abs(allimg(*,*,*,0)))
for i=0, num_slices-1 do begin
  tmp_im=abs(allimg(*,*,i,0))
  tmp_roi=roimap(*,*,i)
  mask_data=where(tmp_im lt thresh_val*max_data_val/100)
  if (total(mask_data) gt -1) then tmp_roi(mask_data)=0
  roimap(*,*,i)=tmp_roi
endfor

; next apply any eroding
if (erosion_val gt 0) then begin
  ; make the structuring element and then apply
  struc=replicate(1, erosion_val, erosion_val)
  for i=0, num_slices-1 do begin
     tmp_roi=roimap(*,*,i)
     tmp_roi=erode(tmp_roi, struc)
     roimap(*,*,i)=tmp_roi
  endfor
endif

; next apply any dilating
if (dilation_val gt 0) then begin
  ; make the structuring element and then apply
  struc=replicate(1, dilation_val, dilation_val)
  for i=0, num_slices-1 do begin
     tmp_roi=roimap(*,*,i)
     tmp_roi=dilate(tmp_roi, struc)
     roimap(*,*,i)=tmp_roi
  endfor
endif

; next get rid of any slices below minimum cut off
if (start_im gt 1) then begin
  for i=0, start_im-2 do roimap(*,*,i)=0
endif

; next get rid of any slices above maximum cut off
if (stop_im lt num_slices) then begin
  for i=stop_im, num_slices-1 do roimap(*,*,i)=0
endif

; finally check for contiguity of the mask
if (contiguity_flag eq 1) then begin
  contiguity_check
endif

end
