
;===========================================================================
pro gallery1
;===========================================================================

; program to construct a gallery of shim term functions and their appearance

dim0=64
dim1=64
dim2=8
fov=100.0
fovz=50
slo=0.0

num_rows=7

window, xsize=dim0*(dim2+1), ysize=num_rows*dim1

mask=fltarr(dim0, dim1, dim2)+1.0
small_mask=fltarr(dim0, dim1)
for i=0, dim0 do begin
  for j=0, dim1 do begin
    if ((float(i-dim0/2)*float(i-dim0/2)+float(j-dim1/2)*float(j-dim1/2)) lt $
      float(dim0)*float(dim0)/4.0) then small_mask(i,j)=1.0
  endfor
endfor

for i=0, dim2-1 do mask(*,*,i)=mask(*,*,i)*small_mask

x=float(indgen(dim0, 1, 1)-dim0/2)*fov/dim0
x=rebin(x, dim0, dim1, dim2)
 
y=float(indgen(1,dim1,1)-dim1/2)*fov/dim1
y=rebin(y, dim0, dim1, dim2)
 
z=(float(indgen(1,1,dim2))-dim2/2.0+0.5)*fovz/dim2+slo
z=rebin(z, dim0, dim1, dim2)

x_shim=bytscl(x*mask)
for i=0, dim2-1 do tv, x_shim(*,*,i), i+1
xyouts, dim0/2-25, dim1*num_rows-dim1/2, "!17x", /device, size=1.5

y_shim=bytscl(y*mask)
for i=0, dim2-1 do tv, y_shim(*,*,i), i+(dim2+1)+1
xyouts, dim0/2-25, dim1*(num_rows-1)-dim1/2, "!17y", /device, size=1.5

z_shim=bytscl(z*mask)
for i=0, dim2-1 do tv, z_shim(*,*,i), i+2*(dim2+1)+1
xyouts, dim0/2-25, dim1*(num_rows-2)-dim1/2, "!17z", /device, size=1.5

z2_shim=bytscl(z*z*mask)
for i=0, dim2-1 do tv, z2_shim(*,*,i), i+3*(dim2+1)+1
xyouts, dim0/2-25, dim1*(num_rows-3)-dim1/2, "!17z2", /device, size=1.5

x2_y2_shim=bytscl((x*x+y*y)*mask)
for i=0, dim2-1 do tv, x2_y2_shim(*,*,i), i+4*(dim2+1)+1
xyouts, dim0/2-25, dim1*(num_rows-4)-dim1/2, "!17x2+y2", /device, size=1.5

xy_shim=bytscl(x*y*mask)
for i=0, dim2-1 do tv, xy_shim(*,*,i), i+5*(dim2+1)+1
xyouts, dim0/2-25, dim1*(num_rows-5)-dim1/2, "!17xy", /device, size=1.5

zx_shim=bytscl(z*x*mask)
for i=0, dim2-1 do tv, zx_shim(*,*,i), i+6*(dim2+1)+1
xyouts, dim0/2-25, dim1*(num_rows-6)-dim1/2, "!17zx", /device, size=1.5

end

;===========================================================================
pro gallery2
;===========================================================================

; program to construct a gallery of shim term functions and their appearance

dim0=64
dim1=64
dim2=8
fov=100.0
fovz=50
slo=0.0

num_rows=7

window, xsize=dim0*(dim2+1), ysize=num_rows*dim1

mask=fltarr(dim0, dim1, dim2)+1.0
small_mask=fltarr(dim0, dim1)
for i=0, dim0 do begin
  for j=0, dim1 do begin
    if ((float(i-dim0/2)*float(i-dim0/2)+float(j-dim1/2)*float(j-dim1/2)) lt $
      float(dim0)*float(dim0)/4.0) then small_mask(i,j)=1.0
  endfor
endfor

for i=0, dim2-1 do mask(*,*,i)=mask(*,*,i)*small_mask

x=float(indgen(dim0, 1, 1)-dim0/2)*fov/dim0
x=rebin(x, dim0, dim1, dim2)
 
y=float(indgen(1,dim1,1)-dim1/2)*fov/dim1
y=rebin(y, dim0, dim1, dim2)
 
z=(float(indgen(1,1,dim2))-dim2/2.0+0.5)*fovz/dim2+slo
z=rebin(z, dim0, dim1, dim2)

zy_shim=bytscl(z*y*mask)
for i=0, dim2-1 do tv, zy_shim(*,*,i), i+1
xyouts, dim0/2-25, dim1*num_rows-dim1/2, "!17zy", /device, size=1.5

x2_my2_shim=bytscl((x*x-y*y)*mask)
for i=0, dim2-1 do tv, x2_my2_shim(*,*,i), i+(dim2+1)+1
xyouts, dim0/2-25, dim1*(num_rows-1)-dim1/2, "!17x2-y2", /device, size=1.5

z3_shim=bytscl(z*z*z*mask)
for i=0, dim2-1 do tv, z3_shim(*,*,i), i+2*(dim2+1)+1
xyouts, dim0/2-25, dim1*(num_rows-2)-dim1/2, "!17z3", /device, size=1.5

xz2_shim=bytscl(x*z*z*mask)
for i=0, dim2-1 do tv, xz2_shim(*,*,i), i+3*(dim2+1)+1
xyouts, dim0/2-25, dim1*(num_rows-3)-dim1/2, "!17xz2", /device, size=1.5

yz2_shim=bytscl(y*z*z*mask)
for i=0, dim2-1 do tv, yz2_shim(*,*,i), i+4*(dim2+1)+1
xyouts, dim0/2-25, dim1*(num_rows-4)-dim1/2, "!17yz2", /device, size=1.5

xy2_shim=bytscl(x*y*y*mask)
for i=0, dim2-1 do tv, xy2_shim(*,*,i), i+5*(dim2+1)+1
xyouts, dim0/2-25, dim1*(num_rows-5)-dim1/2, "!17xy2", /device, size=1.5

yx2_shim=bytscl(y*x*x*mask)
for i=0, dim2-1 do tv, yx2_shim(*,*,i), i+6*(dim2+1)+1
xyouts, dim0/2-25, dim1*(num_rows-6)-dim1/2, "!17yx2", /device, size=1.5

end

;===========================================================================
pro gallery3
;===========================================================================

; program to construct a gallery of shim term functions and their appearance

dim0=64
dim1=64
dim2=8
fov=100.0
fovz=50
slo=0.0

num_rows=7
window, xsize=dim0*(dim2+1), ysize=num_rows*dim1

mask=fltarr(dim0, dim1, dim2)+1.0
small_mask=fltarr(dim0, dim1)
for i=0, dim0 do begin
  for j=0, dim1 do begin
    if ((float(i-dim0/2)*float(i-dim0/2)+float(j-dim1/2)*float(j-dim1/2)) lt $
      float(dim0)*float(dim0)/4.0) then small_mask(i,j)=1.0
  endfor
endfor

for i=0, dim2-1 do mask(*,*,i)=mask(*,*,i)*small_mask

x=float(indgen(dim0, 1, 1)-dim0/2)*fov/dim0
x=rebin(x, dim0, dim1, dim2)
 
y=float(indgen(1,dim1,1)-dim1/2)*fov/dim1
y=rebin(y, dim0, dim1, dim2)
 
z=(float(indgen(1,1,dim2))-dim2/2.0+0.5)*fovz/dim2+slo
z=rebin(z, dim0, dim1, dim2)

x_x2_y2_shim=bytscl((x*(x*x+y*y))*mask)
for i=0, dim2-1 do tv, x_x2_y2_shim(*,*,i), i+1
xyouts, dim0/2-25, dim1*num_rows-dim1/2, "!17x(x2+y2)", /device, size=1.5

y_x2_y2_shim=bytscl((y*(x*x+y*y))*mask)
for i=0, dim2-1 do tv, y_x2_y2_shim(*,*,i), i+(dim2+1)+1
xyouts, dim0/2-25, dim1*(num_rows-1)-dim1/2, "!17y(x2+y2)", /device, size=1.5

z_x2_y2_shim=bytscl((z*(x*x+y*y))*mask)
for i=0, dim2-1 do tv, z_x2_y2_shim(*,*,i), i+2*(dim2+1)+1
xyouts, dim0/2-25, dim1*(num_rows-2)-dim1/2, "!17z(x2+y2)", /device, size=1.5

z_x2_my2_shim=bytscl((z*(x*x-y*y))*mask)
for i=0, dim2-1 do tv, z_x2_my2_shim(*,*,i), i+3*(dim2+1)+1
xyouts, dim0/2-25, dim1*(num_rows-3)-dim1/2, "!17z(x2-y2)", /device, size=1.5

x3_shim=bytscl(x*x*x*mask)
for i=0, dim2-1 do tv, x3_shim(*,*,i), i+4*(dim2+1)+1
xyouts, dim0/2-25, dim1*(num_rows-4)-dim1/2, "!17x3", /device, size=1.5

y3_shim=bytscl(y*y*y*mask)
for i=0, dim2-1 do tv, y3_shim(*,*,i), i+5*(dim2+1)+1
xyouts, dim0/2-25, dim1*(num_rows-5)-dim1/2, "!17y3", /device, size=1.5

xyz_shim=bytscl(x*y*z*mask)
for i=0, dim2-1 do tv, xyz_shim(*,*,i), i+6*(dim2+1)+1
xyouts, dim0/2-25, dim1*(num_rows-6)-dim1/2, "!17xyz", /device, size=1.5

end

;===========================================================================
pro gallery
;===========================================================================

print_flag=1  ; print results to printer

gallery1
wait, 3
xsize=!d.x_size
ysize=!d.y_size
temp_screen=tvrd(0,0,xsize,ysize)
set_plot, 'PS'
tv, temp_screen
device, /close
set_plot, 'X'
if (print_flag eq 1) then spawn, "lp idl.ps"

gallery2
wait, 3
xsize=!d.x_size
ysize=!d.y_size
temp_screen=tvrd(0,0,xsize,ysize)
set_plot, 'PS'
tv, temp_screen
device, /close
set_plot, 'X'
if (print_flag eq 1) then spawn, "lp idl.ps"

gallery3
wait, 3
xsize=!d.x_size
ysize=!d.y_size
temp_screen=tvrd(0,0,xsize,ysize)
set_plot, 'PS'
tv, temp_screen
device, /close
set_plot, 'X'
if (print_flag eq 1) then spawn, "lp idl.ps"

end
