PRO main_win_event, event
; This is the event handler for a "pop-up" widget.

; The COMMON block is used because both main_win and 
; main_win_event must know about the group leader.
COMMON groupleader, base
common file_info, directory, filename, filename2, map_dim0, map_dim1, $
       map_slices, map2_dim0, map2_dim1, map2_slices, file_type, smooth_val
common buttons, roi_button, cal_button
common adjt_info, adjt_base
common canc_info, canc_popupbase
common sys_names_info, sys_names, curr_sys
common share1, dim0, dim1, dim2, diml, dimh, stindex, numfiles, $
           allmagimg,allmagmax,allmagmin
common roi_def_info2, bounce_thresh_val, bounce_change_val, bounce_min_val,$
   min_edges_val, max_dist_val
common mask, mask_fname

; Use WIDGET_CONTROL to get the user value of any widget touched and put
; that value into 'eventval':

WIDGET_CONTROL, event.id, GET_UVALUE = eventval

; Perform actions based on the user value of the button which was pressed.

CASE eventval OF
	'POPUP': popup_win 

       'ROIDEF': roi_def_win

        'CALIB': cal_system_win

         'LOAD': load_base_win

ENDCASE
END


PRO main_win, GROUP=GROUP
; This is the procedure that creates a widget application

; The COMMON block is used because both main_win and 
; main_win_event must know the group leader.
COMMON groupleader, base
common file_info, directory, filename, filename2, map_dim0, map_dim1, $
       map_slices, map2_dim0, map2_dim1, map2_slices, file_type, smooth_val
common misc_flags, data_loaded_flag, field_unwrapped_flag
common buttons, roi_button, cal_button
common roi_def_info2, bounce_thresh_val, bounce_change_val, bounce_min_val,$
   min_edges_val, max_dist_val

; A top-level base widget with the title "Pop-Up Widget Example" will
; hold the exclusive buttons:

base = WIDGET_BASE( TITLE = 'MAIN', /COLUMN, XOFFSET=1, YOFFSET=1, $
                    XSIZE=160)

load_button = WIDGET_BUTTON(base, UVALUE = 'LOAD', VALUE = 'load fid')

roi_button = WIDGET_BUTTON(base, UVALUE = 'ROIDEF', VALUE = 'define voi')

cal_button = WIDGET_BUTTON(base, UVALUE = 'CALIB', VALUE = 'calibrate')

button5 = WIDGET_BUTTON(base, UVALUE = 'POPUP', VALUE = 'quit')

; Desensitize those buttons which do not apply yet

if (data_loaded_flag eq 0) then begin
  WIDGET_CONTROL, roi_button, SENSITIVE=0
  WIDGET_CONTROL, cal_button, SENSITIVE=0
endif

; Realize the widgets:
WIDGET_CONTROL, base, /REALIZE

adjt_win

; Hand off control of the widget to the XMANAGER:
XMANAGER, "main_win", base, GROUP_LEADER=GROUP

END
