PRO popup_win_event, event
; This is the event handler for a "pop-up" widget.

COMMON groupleader, base
common popup_base_info, popup_base
common adjt_info, adjt_base

; Use WIDGET_CONTROL to get the user value of any widget touched and put
; that value into 'eventval':

WIDGET_CONTROL, event.id, GET_UVALUE = eventval

; Perform actions based on the user value of the button which was pressed.

CASE eventval OF
    'FULL_DONE': BEGIN
                   WIDGET_CONTROL, base, /DESTROY
                   WIDGET_CONTROL, adjt_base, /DESTROY
                   WIDGET_CONTROL, popup_base, /DESTROY
                   print, 'leaving shimcalc program...'
                   print, 'type ''exit'' to exit IDL'
                 END

       'CANCEL': BEGIN
                   WIDGET_CONTROL, popup_base, /DESTROY
                   ; Re-sensitize the main base
                   WIDGET_CONTROL, base, SENSITIVE=1
                 END

ENDCASE
END


PRO popup_win, GROUP=GROUP
; This is the procedure that creates a widget application

COMMON groupleader, base
common popup_base_info, popup_base
common adjt_info, adjt_base

popup_base = WIDGET_BASE(TITLE='DO YOU WISH TO QUIT?', $
                             /COLUMN, XSIZE=300, $
                             XOFFSET=100, YOFFSET=160)

popupbutton1 = WIDGET_BUTTON(popup_base, $
                             UVALUE = 'FULL_DONE', $
                             VALUE = 'really quit') ;, $

popupbutton2 = WIDGET_BUTTON(popup_base, $
                             UVALUE = 'CANCEL', $
                             VALUE = 'cancel') ;, $

; Desensitize the parent of popup
WIDGET_CONTROL, base, SENSITIVE=0

; Realize the popup:
WIDGET_CONTROL, popup_base, /REALIZE

; Hand off control of the widget to the XMANAGER:
XMANAGER, "popup_win", popup_base, GROUP_LEADER=GROUP
                                   
END
