;===============================================================================
PRO roi_def_win_event, event
;===============================================================================

COMMON groupleader, base
COMMON roi_base_info, roi_base, start_im_slide, stop_im_slide, draw_im_slide, $
  edit_im_slide, thresh_slide, erosion_slide, dilation_slide, edit_roi, $
  nudge_im_slide
common roi_def_info, thresh_val, erosion_val, start_im, stop_im, draw_im,$
   num_slices, drawn_roi, dilation_val, edit_im, nudge_im
common roi_def_info2, bounce_thresh_val, bounce_change_val, bounce_min_val,$
   min_edges_val, max_dist_val
common shareroi, roimap, topb, botb, lefb, rightb
common field_map_data, phsmap, allimg, fieldmap, strucmap
common shareunwrap, alignrow, aligncolumn, connectionmap, uncoloredmap,$
      colortab, colorlink, colorindex, colorindmap, totcolor, linkcord,$
      pointbak, slcn,map, max_colors, bounce_thresh, roiconnmap, connmap,$
      no_color_bounce
common shareshim, slo, slsep, fov, fovz, te, plane
common share1, dim0, dim1, dim2, diml, dimh, stindex, numfiles, $
           allmagimg,allmagmax,allmagmin
common misc_flags, data_loaded_flag, field_unwrapped_flag
common sys_names_info, sys_names, curr_sys
common mask, mask_fname

WIDGET_CONTROL, event.id, GET_UVALUE = eventval

CASE eventval OF

     'THRESH':BEGIN
                WIDGET_CONTROL, event.id, GET_VALUE=str
                thresh_val=fix(str(0))
                END

     'IGNORE_BELOW':BEGIN
                WIDGET_CONTROL, event.id, GET_VALUE=str
                start_im=fix(str(0))
                if (start_im gt stop_im) then begin
                  start_im=stop_im
                  WIDGET_CONTROL, start_im_slide, SET_VAL=start_im
                endif
                if (draw_im lt start_im) then begin
                  draw_im=start_im
                  WIDGET_CONTROL, draw_im_slide, SET_VAL=draw_im
                endif
                if (edit_im lt start_im) then begin
                  edit_im=start_im
                  WIDGET_CONTROL, edit_im_slide, SET_VAL=edit_im
                endif
                if (nudge_im lt start_im) then begin
                  nudge_im=start_im
                  WIDGET_CONTROL, nudge_im_slide, SET_VAL=nudge_im
                endif
                END

     'IGNORE_ABOVE':BEGIN
                WIDGET_CONTROL, event.id, GET_VALUE=str
                stop_im=fix(str(0))
                if (stop_im lt start_im) then begin
                  stop_im=start_im
                  WIDGET_CONTROL, stop_im_slide, SET_VAL=stop_im
                endif
                if (draw_im gt stop_im) then begin
                  draw_im=stop_im
                  WIDGET_CONTROL, draw_im_slide, SET_VAL=draw_im
                endif
                if (edit_im gt stop_im) then begin
                  edit_im=stop_im
                  WIDGET_CONTROL, edit_im_slide, SET_VAL=edit_im
                endif
                if (nudge_im gt stop_im) then begin
                  nudge_im=stop_im
                  WIDGET_CONTROL, nudge_im_slide, SET_VAL=nudge_im
                endif
                END

     'DRAW_VAL':BEGIN
                WIDGET_CONTROL, event.id, GET_VALUE=str
                draw_im=fix(str(0))
                if (draw_im lt start_im) then begin
                  draw_im=start_im
                  WIDGET_CONTROL, draw_im_slide, SET_VAL=draw_im
                endif
                if (draw_im gt stop_im) then begin
                  draw_im=stop_im
                  WIDGET_CONTROL, draw_im_slide, SET_VAL=draw_im
                endif
                END

     'EDIT_VAL':BEGIN
                WIDGET_CONTROL, event.id, GET_VALUE=str
                edit_im=fix(str(0))
                if (edit_im lt start_im) then begin
                  edit_im=start_im
                  WIDGET_CONTROL, edit_im_slide, SET_VAL=edit_im
                endif
                if (edit_im gt stop_im) then begin
                  edit_im=stop_im
                  WIDGET_CONTROL, edit_im_slide, SET_VAL=edit_im
                endif
                END

     'NUDGE_VAL':BEGIN
                WIDGET_CONTROL, event.id, GET_VALUE=str
                nudge_im=fix(str(0))
                if (nudge_im lt start_im) then begin
                  nudge_im=start_im
                  WIDGET_CONTROL, nudge_im_slide, SET_VAL=nudge_im
                endif
                if (nudge_im gt stop_im) then begin
                  nudge_im=stop_im
                  WIDGET_CONTROL, nudge_im_slide, SET_VAL=nudge_im
                endif
                END

     'DRAW_ROI':BEGIN
                WIDGET_CONTROL, roi_base, SENSITIVE=0
                print, "draw ROI from image : "+strtrim(string(draw_im), 2)
                tmp_im=abs(allimg(*,*,draw_im-1,0))
                dims=size(tmp_im)
                tvscl, rebin(tmp_im, 512, 512, sample=1)
                drawn_roi=defroi(dims(1), dims(2), zoom=512/dims(1))
                WIDGET_CONTROL, roi_base, SENSITIVE=1
                END

      'EDIT_ROI':BEGIN
                print, "edit ROI from image : "+strtrim(string(edit_im), 2)
                if (n_elements(fieldmap) eq 1) then begin
                  WIDGET_CONTROL, roi_base, SENSITIVE=0
                  tmp_im=bytscl(abs(allimg(*,*,edit_im-1,0))* $
                             roimap(*,*,edit_im-1)*edit_roi(*,*,edit_im-1))
                  dims=size(tmp_im)
                  tvscl, rebin(tmp_im, 512, 512, sample=1)
                  tmp_roi=defroi(dims(1), dims(2), zoom=512/dims(1))
                  tmp_edit_roi=edit_roi(*,*,edit_im-1)
                  tmp_edit_roi(tmp_roi)=0
                  edit_roi(*,*,edit_im-1)=tmp_edit_roi
                  WIDGET_CONTROL, roi_base, SENSITIVE=1
                endif else begin
                  WIDGET_CONTROL, roi_base, SENSITIVE=0
                  tmp_im=bytscl(fieldmap(*,*,edit_im-1)*edit_roi(*,*,edit_im-1))
                  dims=size(tmp_im)
                  tvscl, rebin(tmp_im, 512, 512, sample=1)
                  tmp_roi=defroi(dims(1), dims(2), zoom=512/dims(1))
                  tmp_edit_roi=edit_roi(*,*,edit_im-1)
                  tmp_edit_roi(tmp_roi)=0
                  edit_roi(*,*,edit_im-1)=tmp_edit_roi
                  WIDGET_CONTROL, roi_base, SENSITIVE=1
                endelse
                END

     'CLEAR_ROI':BEGIN
                print, "ROI cleared"
                drawn_roi=-1 ; to clear
                edit_roi=roimap*0+1  ; i.e., all values set back to 1
                roimap=roimap*0+1  ; to start from unity each time
                END

     'APPLY':BEGIN
                WIDGET_CONTROL, roi_base, SENSITIVE=0
                ;roimap=roimap*0+1  ; to start from unity each time
                print, ""
 
                construct_voi, 0

                print, "VOI mask..."
                erase
                err=display_ims(roimap*255)
                wait, 0.25

                ;now also alter fieldmap if exists (and display it)
                if (total(fieldmap) ne 0.0) then begin
                  fieldmap=fieldmap*roimap
                  print, "masked fieldmap..."
                  tmp_im=bytscl(fieldmap)
                  err=display_ims(tmp_im)
                  ; calculate the variance
                  mask_arr=where(roimap(*,*,*) ne 0)
                  av_field=0.0
                  std_field=0.0
                  if (total(mask_arr) gt -1) then begin
                    av_field=total(fieldmap(mask_arr))/n_elements(mask_arr)
                    var_field=(fieldmap(mask_arr)-av_field)* $
                      (fieldmap(mask_arr)-av_field)
                    var_field=total(var_field)/(n_elements(mask_arr)-1)
                    std_field=sqrt(var_field)
                  endif
 
                  print, "average field (Hz) = ", av_field/(2.0*!pi)
                  print, "standard deviation (Hz) = ", std_field/(2.0*!pi)
                  xyouts, 0, 0, "!17standard deviation (Hz) = "+ $
                  strtrim(string(std_field/(2.0*!pi)),2), /device, size=1.5
                endif else begin
                  print, "masked images..."
                  tmp_im=bytscl(abs(allimg(*,*,*,0))*roimap)
                  err=display_ims(tmp_im)
                endelse
                WIDGET_CONTROL, roi_base, SENSITIVE=1
                END
  
     'DONE':BEGIN
                WIDGET_CONTROL, base, SENSITIVE=1
		WIDGET_CONTROL, roi_base, /DESTROY
		END

     'SAVE_ROI':BEGIN
                print, "saving VOI info as ~/shimcalc_voi.idl"
                save, filename="~/shimcalc_voi.idl", drawn_roi, thresh_val, $
                  erosion_val, dilation_val, start_im, stop_im, draw_im
                END

         'MASK':BEGIN
                WIDGET_CONTROL, roi_base, SENSITIVE=0
                mask
                WIDGET_CONTROL, roi_base, SENSITIVE=1
              END

  "MASK_FNAME": BEGIN
                ;A RETURN has been pressed in the Filename field
                WIDGET_CONTROL, event.id, GET_VALUE=temp_var
                mask_fname=string(temp_var(0))
                END

     'UNWRAP':BEGIN
                field_unwrapped_flag=0
                print, "calculating field map..."
                WIDGET_CONTROL, roi_base, SENSITIVE=0
                construct_voi, 0 ; in case there are changes since "APPLYed"
                calc_field  ; generates the fieldmap array containing the map
                field_unwrapped_flag=1
                WIDGET_CONTROL, roi_base, SENSITIVE=1
                END

     'RESTORE_ROI':BEGIN
                print, "restoring VOI info from ~/shimcalc_voi.idl"
                ; first check that file is there
                load_ok_flag=0
                spawn, './find_file.scr ~/shimcalc_voi.idl', exist_file_flag
                if (fix(exist_file_flag(0)) eq 1) then begin
                  load_ok_flag=1
                endif else begin
                  print, 'Error : File ~/shimcalc_voi.idl not found'
                endelse
                if (load_ok_flag eq 1) then begin
                  restore, "~/shimcalc_voi.idl" ; restores the VOI info

                  if (start_im gt num_slices) then start_im=1
                  if (stop_im gt num_slices) then stop_im=num_slices

                  ; check that saved ROI isn't too big a matrix for loaded data
                  tmp_roi=roimap(*,*,0)
                  if (max(drawn_roi) ge n_elements(roimap)) then begin
                    print, "Warning: matrix sizes do not agree..."
                    drawn_roi=-1
                  endif

                  WIDGET_CONTROL, draw_im_slide, SET_VAL=draw_im
                  WIDGET_CONTROL, thresh_slide, SET_VAL=thresh_val
                  WIDGET_CONTROL, erosion_slide, SET_VAL=erosion_val
                  WIDGET_CONTROL, dilation_slide, SET_VAL=dilation_val
                  WIDGET_CONTROL, start_im_slide, SET_VAL=start_im
                  WIDGET_CONTROL, stop_im_slide, SET_VAL=stop_im
                  
                endif

                END

      else: BEGIN
                button_selected=eventval
                END
ENDCASE

END

;===============================================================================
PRO roi_def_win, GROUP=GROUP
;===============================================================================

COMMON groupleader, base
COMMON roi_base_info, roi_base, start_im_slide, stop_im_slide, draw_im_slide, $
  edit_im_slide, thresh_slide, erosion_slide, dilation_slide, edit_roi, $
  nudge_im_slide
common roi_def_info, thresh_val, erosion_val, start_im, stop_im, draw_im,$
   num_slices, drawn_roi, dilation_val, edit_im, nudge_im
common file_info, directory, filename, filename2, map_dim0, map_dim1, $
       map_slices, map2_dim0, map2_dim1, map2_slices, file_type, smooth_val
common shareroi, roimap, topb, botb, lefb, rightb
common misc_flags, data_loaded_flag, field_unwrapped_flag
common mask, mask_fname

WIDGET_CONTROL, base, SENSITIVE=0

roi_base = WIDGET_BASE(TITLE = 'DEFINE VOI', /row, XOFFSET=1, YOFFSET=1)

outer_base = WIDGET_BASE(roi_base, /column)

if (n_elements(edit_roi) lt 1) then begin
  edit_roi=roimap*0+1  ; to initialize
endif

; if mask_fname exists use as default else use directory
if (mask_fname eq "none") then begin
  default_value=directory
endif else begin
  default_value=mask_fname
endelse

maskrow = WIDGET_BASE(outer_base, /ROW, /FRAME)
masklabel = WIDGET_LABEL(maskrow, VALUE = ' Mask Fname:')
maskname = WIDGET_TEXT(maskrow, /EDITABLE, XSIZE = 30, YSIZE = 1, $
                   UVALUE = 'MASK_FNAME', VALUE = default_value)

maskbrainown_button = WIDGET_BUTTON(outer_base, UVALUE='MASK', $
               value='mask with mask fname')

min_thresh=0
max_thresh=100
thresh_slide = WIDGET_SLIDER(outer_base, minimum=min_thresh, xsize=200, $
    maximum=max_thresh, title='threshold, %', /FRAME, UVALUE='THRESH', $
    value=thresh_val)

if (num_slices gt 1) then begin
  min_start_im=1
  max_start_im=num_slices
  start_im_slide = WIDGET_SLIDER(outer_base, minimum=min_start_im, xsize=200, $
      maximum=max_start_im, title='ignore below image', /FRAME, $
      UVALUE='IGNORE_BELOW', value=start_im)
endif

if (num_slices gt 1) then begin
  min_stop_im=1
  max_stop_im=num_slices
  stop_im_slide = WIDGET_SLIDER(outer_base, minimum=min_stop_im, xsize=200, $
      maximum=max_stop_im, title='ignore above image', /FRAME, $
      UVALUE='IGNORE_ABOVE', value=stop_im)
endif

  inner_base = WIDGET_BASE(outer_base, /row)

  inner_inner_base = WIDGET_BASE(inner_base, /column)
  draw_ROI_button=WIDGET_BUTTON(inner_inner_base, UVALUE='DRAW_ROI', $
     value='draw ROI')

  clear_ROI_button=WIDGET_BUTTON(inner_inner_base, UVALUE='CLEAR_ROI', $
     value='clear ROI')

if (num_slices gt 1) then begin
  min_draw_im=1
  max_draw_im=num_slices
  draw_im_slide = WIDGET_SLIDER(inner_base, minimum=min_draw_im, xsize=200, $
    maximum=max_draw_im, title='draw from image:', /FRAME, $
    UVALUE='DRAW_VAL', value=draw_im)
endif

  inner_base2 = WIDGET_BASE(outer_base, /row)

  save_ROI_button=WIDGET_BUTTON(inner_base2, UVALUE='SAVE_ROI', $
     value=' Save VOI Info  ')

  restore_ROI_button=WIDGET_BUTTON(inner_base2, UVALUE='RESTORE_ROI', $
     value='Restore VOI Info')

  inner_base3 = WIDGET_BASE(outer_base, /row)

  edit_ROI_button=WIDGET_BUTTON(inner_base3, UVALUE='EDIT_ROI', $
     value=' edit ROI')

if (num_slices gt 1) then begin
  min_edit_im=1
  max_edit_im=num_slices
  edit_im_slide = WIDGET_SLIDER(inner_base3, minimum=min_edit_im, xsize=200, $
    maximum=max_edit_im, title='edit from image:', /FRAME, $
    UVALUE='EDIT_VAL', value=edit_im)
endif

  inner_base4 = WIDGET_BASE(outer_base, /row)

  nudge_ROI_button=WIDGET_BUTTON(inner_base4, UVALUE='NUDGE_MAP', $
     value='nudge map')

if (num_slices gt 1) then begin
  min_nudge_im=1
  max_nudge_im=num_slices
  nudge_im_slide = WIDGET_SLIDER(inner_base4, minimum=min_nudge_im, xsize=200, $
    maximum=max_nudge_im, title='nudge image:', /FRAME, $
    UVALUE='NUDGE_VAL', value=nudge_im)
endif

apply_button = WIDGET_BUTTON(outer_base, UVALUE='APPLY', value='apply mask')

unwrap_button = WIDGET_BUTTON(outer_base, UVALUE='UNWRAP', $
               value='calc base field')

done_button = WIDGET_BUTTON(outer_base, UVALUE='DONE', value='done')

; Realize the widgets:
WIDGET_CONTROL, roi_base, /REALIZE

; Hand off control of the widget to the XMANAGER:
XMANAGER, "roi_def_win", roi_base, GROUP_LEADER=GROUP

END
