;****************************************************************************
;This procedure searches the optimal shim current
;values within the current limits. A progressive
;tangential point method is used to identify the
;most limiting boundary dimension. 
;               Han Wen
;               04/12/93
;****************************************************************************
pro searchpoint
common shareeigen,ipmatrix, phsrow, result, bndv,pndpoint, curlimit,orgshim,nch

bndv=fltarr(nch)
bndv(*)=0
freedim=nch
pphsrow=phsrow
pbndvec=fltarr(nch)
pbndvec(*)=0
stop=0
bnddim=-1
outbflag=intarr(nch)
outbflag(*)=0
pipmatrix=ipmatrix
distance=0
testflag = intarr(nch)
tempipmatrix=fltarr(nch, nch)
tempphsrow=fltarr(nch)
tempbndvec=fltarr(nch)
tempndpoint=fltarr(nch)
disvec=fltarr(nch)

result=fltarr(nch)

reply=string(0)

invtm=invert(pipmatrix)
pndpoint=-(pbndvec+pphsrow)#invtm
testflag(*)=fix(pndpoint(*) gt curlimit(0,*))-fix(pndpoint(*) lt -curlimit(1,*))

while ( not stop ) do begin

 if ( total (testflag(*) ne 0) eq 0) then begin
   stop=1
 endif else begin

   case freedim of
     '1': begin
        pndpoint(*)=pndpoint(*)+outbflag(*)*curlimit(fix(outbflag(*) lt 0),*)  
        stop=1
     end
     else: begin
       distance=0
       outbflag(*)=0
       for i=0, nch-1 do begin
         if (testflag(i) ne 0) then begin
           tempipmatrix=pipmatrix
           tempipmatrix(i,*)=0
           tempipmatrix(*,i)=0
           tempipmatrix(i,i)=1
           tempphsrow=pphsrow
           tempphsrow(i)=0
           tempbndvec=pbndvec+testflag(i)*curlimit(fix(testflag(i) lt 0),i)* $
               pipmatrix(*,i)
           tempbndvec(i)=0
           tempndpoint=-(tempbndvec+tempphsrow)#invert(tempipmatrix)
           disvec=tempndpoint-pndpoint
           disvec(i)=disvec(i)+testflag(i)*curlimit(fix(testflag(i) lt 0),i)
           tempdistance=total(disvec*(disvec#pipmatrix))
           if ( tempdistance gt distance ) then begin
             distance= tempdistance
             bnddim=i
             outbflag(*)=fix(tempndpoint(*) gt curlimit(0,*))- $
               fix(tempndpoint(*) lt -curlimit(1,*))
             nndpoint=tempndpoint
           endif
         endif
       endfor

       freedim= freedim-fix(total(outbflag(*) ne 0) ne 0)
       pndpoint=nndpoint
       if (freedim gt 1) then begin
         bndv(bnddim)=testflag(bnddim)*curlimit(fix(testflag(bnddim) lt 0), $
             bnddim)
         pbndvec(*)=pbndvec(*)+pipmatrix(*,bnddim)*testflag(bnddim)* $
            curlimit(fix(testflag(bnddim) lt 0), bnddim)
         pipmatrix(bnddim,*)=0
         pipmatrix(*,bnddim)=0
         pipmatrix(bnddim,bnddim)=1
         pphsrow(bnddim)=0
         pbndvec(bnddim)=0
         testflag=outbflag
       endif 
     end
   endcase
 endelse  
endwhile

result(*)=pndpoint(*)+bndv(*)

return

end
