pro construct_voi

common field_map_data, phsmap, allimg, fieldmap, strucmap
common roi_def_info, thresh_val, erosion_val,dilation_val
common share1, roimap, dim0, dim1, dim2

; apply any thresholding
if (thresh_val gt 0) then begin
  max_data_val=max(abs(allimg(*,*,*,0)))
  tmp_im=abs(allimg(*,*,*,0))
  tmp_roi=roimap
  mask_data=where(tmp_im lt thresh_val*max_data_val/100)
  if (total(mask_data) gt -1) then tmp_roi(mask_data)=0
  roimap=tmp_roi
endif

; next apply any eroding
if (erosion_val gt 0) then begin
  ; make the structuring element and then apply
  struc=replicate(1, erosion_val, erosion_val)
  for i=0, dim2-1 do begin
     tmp_roi=roimap(*,*,i)
     tmp_roi=erode(tmp_roi, struc)
     roimap(*,*,i)=tmp_roi
  endfor
endif

; next apply any dilating
if (dilation_val gt 0) then begin
  ; make the structuring element and then apply
  struc=replicate(1, dilation_val, dilation_val)
  for i=0, dim2-1 do begin
     tmp_roi=roimap(*,*,i)
     tmp_roi=dilate(tmp_roi, struc)
     roimap(*,*,i)=tmp_roi
  endfor
endif

end
