function fieldmap_ft, in_arr, verbose=verbose

if (n_elements(verbose) eq 0) then verbose=0

dims=size(in_arr)

if (total(in_arr) eq -1) then return, -1

; assume that in_arr is arranged as in_arr(dim0,dim1,nslices,nechoes)

if (dims(1) gt dims(2)) then begin
  out_arr=complexarr(dims(1),dims(1),dims(3),dims(4))
  if (verbose gt 0) then print, "zero filling phase encode dimension"
  for  echo_no=0, dims(4)-1 do begin
    for slice_no=0, dims(3)-1 do begin
      out_arr(*,dims(1)/2-dims(2)/2:dims(1)/2+dims(2)/2-1,slice_no,echo_no) = $
         in_arr(*,*,slice_no,echo_no)
    endfor
  endfor
endif

if (dims(1) lt dims(2)) then begin
  out_arr=complexarr(dims(2),dims(2),dims(3),dims(4))
  if (verbose gt 0) then print, "zero filling read dimension"
  for  echo_no=0, dims(4)-1 do begin
    for slice_no=0, dims(3)-1 do begin
      out_arr(dims(2)/2-dims(1)/2:dims(2)/2+dims(1)/2-1,*,slice_no,echo_no) = $
         in_arr(*,*,slice_no,echo_no)
    endfor
  endfor
endif

if (dims(1) eq dims(2)) then begin
  out_arr=in_arr
endif

for echo_no=0, dims(4)-1 do begin
  for slice_no=0, dims(3)-1 do begin
    out_arr(*,*,slice_no,echo_no)=shift(fft(shift(out_arr(*,*,slice_no, $
       echo_no), dims(1)/2, dims(2)/2), 1), dims(1)/2, dims(2)/2)
    if (verbose) then tvscl, out_arr(*,*,slice_no,echo_no)
  endfor
endfor

return, out_arr

end
