#include <standard.h>

pulsesequence()
{
  float trph,tramp,tgrad,twait,trfd,d3,decay,npulse,t_end,amp,tr,gate,pd;
  char *gs,gradc;


  npulse= getval("npulse");  /* number of RF pulses */
  trph= getval("trph");      /* transmitter phase */
  twait= getval("twait");    /* delay between FID series */
  trfd= getval("trfd");      /* delay between RF and acquisition */
  decay= getval("decay");    /* delay between gradient and first RF */
  tramp= getval("tramp");    /* ramptime gradient */
  tgrad= getval("tgrad");    /* 'flat' time of gradient */
  tr   = getval("tr");       /* TR of RF pulses */
  pd   = getval("pd");       /* post delay */
  gate = getval("gate");     /* gating flag */
  amp=getval("amp");         /* amplitude of grad. (G/cm) */
  gs=(char *) malloc(100);   /* gradient (X/Y/Z) */
  getstr("grad",gs);
  gradc=gs[0];
  
  t_end= tr- pw- rof1- rof2- 0.5*np/sw-d2;
  if (t_end < 0) {
    printf("Requested TR too short, min: %f\n", pw+ rof1+ rof2+ np/sw);
    abort(1);}
  
  d3= twait- tramp*2- tgrad- decay;
  if (d3 < 0) {
    printf("Requested twait too short, min: %f\n", tramp*2+ tgrad+ decay+ d2);
    abort(1);}
    
 /* Begin sequence */   
       
  status(A);
  sp4off();
  obspower(tpwr);
  initval(npulse,v1);
  initval(trph,v3); 
  
  assign(zero,oph); 
  
  if (gate) xgate(1.0);

  delay(tramp*2+tgrad+decay);

  loop(v1,v2); 
    sp4on();
    pulse(pw,zero);
    sp4off();
    delay(trfd);
    acquire(np,1.0/sw); 
    delay(t_end);
  endloop(v2); 

  delay(d3);
   
  if (gate) xgate(1.0);

  shapedgradient("ramp_hold",tramp,amp/gmax*32767,gradc,1,WAIT);
  delay(tgrad);
  shapedgradient("ramp_down",tramp,amp/gmax*32767,gradc,1,WAIT); 
  delay(decay);  
   
  assign(one,oph); 
   
  loop(v1,v2); 
    sp4on();
    pulse(pw,v3);
    sp4off();
    delay(trfd);
    acquire(np,1.0/sw);
    delay(t_end); 
  endloop(v2);  
   
  delay(pd);
}
 
