/* Global variables */
double pslab[MAXSLICE],nslab;

/* Calculate utilities */

calculate_slab_inversion_gradients(double *t_inv_b,double *t_inv_a)
{
  char shape_name[MAXSTR];

  gss5 = getval("gss5");

  sprintf(shape_name,"gss5");
  pw_gss5 = create_trap_gradient(fabs(gss5),shape_name,p5+rof1+rof2,grate,ix);

  *t_inv_b = fabs(gss5)*grate + rof1 + p5/2;
  *t_inv_a = fabs(gss5)*grate + rof2 + p5/2;

  if(rftep>fabs(gss5)*grate) *t_inv_a += rftep-fabs(gss5)*grate;
}

calculate_slab_offsets(int blocks)
{
  int i,j,spb;
  double av=0;

  spb=(int)ns/blocks;

  for(i=0;i<blocks;i++){
    av=0;
    for(j=0;j<spb;j++)av+=(pss[i*spb+j]/spb);
    pslab[i]=av;
  }
  nslab = blocks;
}

/* Playout utilities */

slab_inversion_pulse(codeint vslab)
{
  char tag_plane[MAXSTR];

  if((nslab>1)&&(slablist<0))slablist=curlist++;
  position_offset_list(pslab,gss5,nslab,resto,OBSch,slablist,vslab);
  
  if(!strncmp(p5pat,"sech",4))obspower(tpwr5);
  else{
    if(rfmod[0]=='y'){
      getelem(t58,vslab,v12);
      power(v12,OBSch);
      getelem(t59,vslab,v12);    
    }
    else obspower(tpwr5);
  }

  getstr("tag_plane",tag_plane);

  if(tag_plane[0]=='p'){
    obl_shapedgradient("gss5","","",pw_gss5,gss5,0.0,0.0,1,NOWAIT);
  }
  else {
    if(tag_plane[0]=='r'){
      obl_shapedgradient("","gss5","",pw_gss5,0.0,gss5,0.0,1,NOWAIT);
    }
    else {
      obl_shapedgradient("","","gss5",pw_gss5,0.0,0.0,gss5,1,NOWAIT);
    }
  }
  delay(fabs(gss5)*grate+rftep);

  sp4on();
  if(!strncmp(p5pat,"sech",4))shaped_pulse(p5pat,p5,v1,rof1,rof2);
  else {
    if(rfmod[0]=='y') shapedvpulse(p5pat,p5,v12,v1,rof1,rof2);
    else shaped_pulse(p5pat,p5,v1,rof1,rof2);
  }
  sp4off();
  if(rftep<fabs(gss5)*grate)delay(fabs(gss5)*grate-rftep);  
}

calculate_slab_rf_modulation()
{
  double pss1,pss2,pwr1,pwr2,target,newtarg,dbi;
  char tpwr_file[MAXSTR],rfcoil[MAXSTR],full_fname[MAXSTR],*home_dir;
  int pwr_mod[MAXSTR],db_incr[MAXSTR],i,ret;
  FILE *fp,*table;
  char err_string[MAXSTR];

  getstr("rfcoil",rfcoil);

  home_dir=(char *)getenv("HOME");
  sprintf(tpwr_file,"%s/vnmrsys/shapelib/%s.SCALE",home_dir,rfcoil);

  fp=fopen(tpwr_file,"r");
  if(fp==NULL){
    sprintf(tpwr_file,"/vnmr/shapelib/%s.SCALE",rfcoil);
    fp=fopen(tpwr_file,"r");
    if(fp==NULL){
      sprintf(err_string,"%s: Unable to open file ~/vnmrsys/shapelib/%s.SCALE\n"
	      ,seqfil,rfcoil);
      printf(err_string);
      log_error(err_string);
      abort(1);
    }
  }

  for(i=0;i<nslab;i++){
    rewind(fp);
    ret=fscanf(fp,"%lf\t%lf\n",&pss1,&pwr1);
    rewind(fp);
    while(1){
      ret=fscanf(fp,"%lf\t%lf\n",&pss2,&pwr2);
      if(ret==EOF){
	sprintf(err_string,"%s: pslab out of range of tpwr_file\n",seqfil);
	printf(err_string);
	log_error(err_string);
	abort(1);
      }
      if(pss2>pslab[i]){
	target=pwr1;
	pwr2-=pwr1;
	pwr2*=((pslab[i]-pss1)/(pss2-pss1));
	target+=pwr2;
	break;
      }
      pss1=pss2;
      pwr1=pwr2;
    }
    /* calculate db increase */
    dbi=20*log10(target);
    db_incr[i]=ceil(dbi);
    newtarg=pow(10,(double)db_incr[i]/20);
    newtarg=target/newtarg;
    pwr_mod[i]=(int)(newtarg*32767);
  }

  fclose(fp);

  sprintf(full_fname,"%s/vnmrsys/tablib/tpwr_table",home_dir);
  table=fopen(full_fname,"w");
  if(table==NULL){
    sprintf(err_string,"%s: Unable to open ~/vnmrsys/tablib/tpwr_table\n",
	    seqfil);
    printf(err_string);
    log_error(err_string);
    abort(1);
  }
  fprintf(table,"t58 = ");
  for(i=0;i<nslab;i++){
    fprintf(table,"%d ",db_incr[i]+(int)tpwr5);
  }
  fprintf(table,"\nt59 = ");
  for(i=0;i<nslab;i++){
    fprintf(table,"%d ",pwr_mod[i]);
  }
  fprintf(table,"\n");
  fclose(table);
  
  loadtable("tpwr_table");
}
