;=============================================================================
function get_varian_par, procpar_dir, par_name
;=============================================================================
; function to return varian procpar parameters
; procpar_dir is the directrory stem containing the procpar file
; par_name is a string containing the string parameter
;=============================================================================
; Peter Jezzard, Oxford, July 2000
;=============================================================================

fname=procpar_dir+'/procpar'
par_val=-9999999

get_lun, unit
openr, unit, fname

found_par=0
line=string(0)

while ((eof(unit) eq 0) and (found_par eq 0)) do begin
  readf, unit, line
  if (strpos(line, par_name+' ') eq 0) then begin
    found_par=1
    readf, unit, line
    line_len=strlen(line)

    space_positions=strpos(line, ' ')

    found_all_spaces=0
    tmp_line_len=strlen(line)
    tmp_line=strmid(line, space_positions+1, tmp_line_len-space_positions-1)
    old_pos=space_positions

    while(found_all_spaces eq 0) do begin
      tmp_pos=strpos(tmp_line, ' ')
      if (tmp_pos eq -1) then begin
        found_all_spaces=1
      endif else begin
        new_pos=old_pos+tmp_pos+1
        space_positions=[space_positions, new_pos]
        old_pos=new_pos
        tmp_line_len=strlen(line)
        tmp_line=strmid(tmp_line, tmp_pos+1, tmp_line_len-tmp_pos-1)
      endelse
    endwhile

    num_pars=fix(strmid(line,0,space_positions(0)))

    if (num_pars eq 1) then begin
      par_val=float(strmid(line,space_positions(0),line_len-space_positions(0)))
    endif else begin
      par_val=float(strmid(line,space_positions(0), $
          space_positions(1)-space_positions(0)))
    endelse

    if (num_pars gt 1) then begin
      if (n_elements(space_positions) eq num_pars) then $
         space_positions=[space_positions,line_len]
      for i=1, num_pars-1 do begin
        par_val=[par_val, float(strmid(line,space_positions(i), $
            space_positions(i+1)))]
      endfor
    endif
  endif
endwhile

close, unit
free_lun, unit

if (found_par eq 0) then begin
  print, 'string not found'
endif

return, par_val

end
