function kspace_view, fname1, fname2

im1=rd_varian_bin(fname1+'/fid')
im2=rd_varian_bin(fname2+'/fid')

sw=get_varian_par(fname1, 'sw')
pss=get_varian_par(fname1, 'pss')
gmax=get_varian_par(fname1, 'gmax')

iii=complex(0,1)
phsmap1=acos(float(im1)/abs(im1))
phsmap1=phsmap1*2.0*((float(-im1*iii) gt 0.0)-0.5)
phsmap2=acos(float(im2)/abs(im2))
phsmap2=phsmap2*2.0*((float(-im2*iii) gt 0.0)-0.5)

thresh=!pi
phadiff1=phsmap1-shift(phsmap1, 1)
mask=where(phadiff1 gt thresh)
if (total(mask) gt -1) then phadiff1(mask)=phadiff1(mask)-2.0*!pi
mask=where(phadiff1 lt -thresh)
if (total(mask) gt -1) then phadiff1(mask)=phadiff1(mask)+2.0*!pi
phadiff2=phsmap2-shift(phsmap2, 1)
mask=where(phadiff2 gt thresh)
if (total(mask) gt -1) then phadiff2(mask)=phadiff2(mask)-2.0*!pi
mask=where(phadiff2 lt -thresh)
if (total(mask) gt -1) then phadiff2(mask)=phadiff2(mask)+2.0*!pi

diff=(phadiff2-phadiff1)*sw/(2.0*!pi*pss*4257.5)

plot, diff, yrange=[-gmax,gmax], ytitle='gradient, g/cm'

return, diff

end
