get_tweekers()
{
  char err_string[MAXSTR];

  /* grad risetime to full strength */
  P_getreal(GLOBAL,"grise",&grise,1); 
  if ((grise < 0.0) || (grise > 0.002)) {
    sprintf(err_string,"%s: impropper grise time defined in global file\n",
	    seqfil);
    printf(err_string);
    log_error(err_string);
    abort(1);
  }
  grate=grise/gmax;

  /* small tweaker time (us) to allow for
     the gradient propagation time, causes echoes to
     appear symmetrically about echo center line */    
  P_getreal(GLOBAL,"tep",&tep,1);		     
  tep=tep/1e6; /* convert from us */

  /* read dephase tweaker (percent) */
  epigroa = 0.0;
  P_getreal(GLOBAL,"epigroa",&epigroa,1);
  
  /* grad risetime to full strength */
  epigrof = 0.0;
  P_getreal(GLOBAL,"epigrof",&epigrof,1);
  
  /* grad risetime to full strength */
  epigssf = 0.0;
  P_getreal(GLOBAL,"epigssf",&epigssf,1);
  
  /* allows extra time to be
     inserted into the length of each flat top */
  episwing = 0.0;
  P_getreal(GLOBAL,"episwing",&episwing,1);
  episwing=episwing /1.0e6;  /* convert from us */

  /* short delay at start of each overall AQ */
  del_seq = getval("del_seq");

  /* phase encode gradient tweaker (default=1.0) */
  gbdf = getval("gbdf");

  /* small tweaker time (us) to compensate
     for situations where the phase encode blip 
     needs a longer duration than grate*agro */
  echo_del = getval("echo_del");  echo_del=echo_del/1e6;
  
 /* gradient coil in use */
  getstr("gcoil",gcoil);   
  
  /* Set list numbers */
  exlist=invlist=selist=-1;
  curlist=0;    
}
