pro ox_ecc_cal, fname

; assumes array='d2,image,pss'

im=rd_varian_bin(fname+'/fid')

sw=get_varian_par(fname, 'sw')
pss=get_varian_par(fname, 'pss')
n_slices=n_elements(pss)
gread=get_varian_par(fname, 'gread')
image=get_varian_par(fname, 'image')
n_images=n_elements(image)
d2_arr=get_varian_par(fname, 'd2')
n_delays=n_elements(d2_arr)
np=get_varian_par(fname, 'np')

im=reform(im, np/2, n_slices, n_images, n_delays)

diff=fltarr(np/2,n_slices,n_images/2,n_delays)
delay_arr=fltarr(np/2,n_delays)
for i=0, n_delays-1 do begin
  delay_arr(*,i)=findgen(np/2)/sw+d2_arr(i)
endfor

iii=complex(0,1)
for sl_no=0, n_slices-1 do begin
  for im_no=0, n_images/2-1 do begin
    for del_no=0, n_delays-1 do begin
      x1=im(*,sl_no,im_no*2,del_no)
      phsmap1=acos(float(x1)/abs(x1))
      phsmap1=phsmap1*2.0*((float(-x1*iii) gt 0.0)-0.5)
      x2=im(*,sl_no,im_no*2+1,del_no)
      phsmap2=acos(float(x2)/abs(x2))
      phsmap2=phsmap2*2.0*((float(-x2*iii) gt 0.0)-0.5)

      thresh=!pi
      phadiff1=phsmap1-shift(phsmap1, 1)
      mask=where(phadiff1 gt thresh)
      if (total(mask) gt -1) then phadiff1(mask)=phadiff1(mask)-2.0*!pi
      mask=where(phadiff1 lt -thresh)
      if (total(mask) gt -1) then phadiff1(mask)=phadiff1(mask)+2.0*!pi
      phadiff2=phsmap2-shift(phsmap2, 1)
      mask=where(phadiff2 gt thresh)
      if (total(mask) gt -1) then phadiff2(mask)=phadiff2(mask)-2.0*!pi
      mask=where(phadiff2 lt -thresh)
      if (total(mask) gt -1) then phadiff2(mask)=phadiff2(mask)+2.0*!pi

      diff(*,sl_no,im_no,del_no)=(phadiff2-phadiff1)*sw/(2.0*!pi)
    endfor
  endfor
endfor

; at this point diff is in units of Hz at each slice position

b0_eddy=fltarr(np/2,n_images/2,n_delays)
grad_eddy=fltarr(np/2,n_images/2,n_delays)

for im_no=0, n_images/2-1 do begin
  for del_no=0, n_delays-1 do begin
    for i=0, np/2-1 do begin
      tmp=reform(diff(i,*,im_no,del_no))
      fit_vals=polyfitw(pss, tmp, fltarr(n_slices)+1, 1)
      b0_eddy(i,im_no,del_no)=fit_vals(0)/(42.575*gread*10.0) ; uT/(mT/m)
      grad_eddy(i,im_no,del_no)=fit_vals(1)/4257.5 ; units of gauss/cm
    endfor
  endfor
endfor

plot, delay_arr, grad_eddy(*,0,*)/gread*100.0, yrange=[-1.0, 1.0], $
   xtitle='time, sec', ytitle='% grad eddy', title='read direction'
wait, 2

if (n_images gt 2) then begin
  plot, delay_arr, grad_eddy(*,1,*)/gread*100.0, yrange=[-1.0, 1.0], $
     xtitle='time, sec', ytitle='% grad eddy', title='phase direction'
  wait, 2
endif

if (n_images gt 4) then begin
  plot, delay_arr, grad_eddy(*,2,*)/gread*100.0, yrange=[-1.0, 1.0], $
     xtitle='time, sec', ytitle='% grad eddy', title='slice direction'
  wait, 2
endif

plot, delay_arr, b0_eddy(*,0,*), yrange=[-1.0, 1.0], $
   xtitle='time, sec', ytitle='B0 eddy, uT/(mT/m)', title='read direction'
wait, 2

if (n_images gt 2) then begin
  plot, delay_arr, b0_eddy(*,1,*), yrange=[-1.0, 1.0], $
     xtitle='time, sec', ytitle='B0 eddy, uT/(mT/m)', title='phase direction'
  wait, 2
endif

if (n_images gt 4) then begin
  plot, delay_arr, b0_eddy(*,2,*), yrange=[-1.0, 1.0], $
     xtitle='time, sec', ytitle='B0 eddy, uT/(mT/m)', title='slice direction'
endif

end
