pro write_data, path_str, fstem, in_arr, npoints, nviews, nslices, ntpts, $
       header_flag=header_flag, slice_no=slice_no

if (n_elements(header_flag) eq 0) then header_flag=0
if (n_elements(slice_no) eq 0) then slice_no=-1

mac_head=intarr(4)

mac_head(0)=0
mac_head(1)=32767
mac_head(2)=npoints/2
mac_head(3)=nviews

; write out and reconstruct each data file
for time_no=0, ntpts-1 do begin
  if (time_no lt 9) then timeext='00'+strtrim(string(time_no+1), 2)
  if (time_no ge 9) then timeext='0'+strtrim(string(time_no+1), 2)
  if (time_no ge 99) then timeext=strtrim(string(time_no+1), 2)
  for sl_no=0, nslices-1 do begin
    if (slice_no eq -1) then begin
      if (sl_no lt 9) then slext='0'+strtrim(string(sl_no+1), 2)
      if (sl_no ge 9) then slext=strtrim(string(sl_no+1), 2)
    endif else begin
      if (slice_no lt 9) then slext='0'+strtrim(string(slice_no), 2)
      if (slice_no ge 9) then slext=strtrim(string(slice_no), 2)
    endelse
    if (nslices gt 1) then begin
      temp_arr=in_arr(*,*,sl_no,time_no)
    endif else begin
      temp_arr=in_arr(*,*,time_no)
    endelse
    out_name="sl"+slext+"."+fstem+"."+timeext
    ; for now do a simple fft
    temp_arr=abs(shift(fft(shift(temp_arr, npoints/4, nviews/2), 1), $
           npoints/4, nviews/2))/nviews
    print, "time point "+strtrim(string(time_no+1),2)+", slice "+ $
         strtrim(string(sl_no+1),2)+". max val = "+ $
         strtrim(string(max(temp_arr)), 2)
    if (max(temp_arr) gt 32767.0) then begin
      print, "Warning: integer value for file "+out_name+" > 32767"
    endif

    get_lun, unit
    openw, unit, path_str+"/"+out_name
    if (header_flag eq 1) then writeu, unit, mac_head
    writeu, unit, fix(temp_arr)
    close, unit
    free_lun, unit
  endfor
endfor
 
end
