/* ADJ_PILOT_PROCPAR.C                                                       */
/*****************************************************************************

    File to rewrite the procpar file for use with the pilot.c pulse programme.
    Peter Jezzard, University of Oxford, 1999

******************************************************************************/

#include <stdio.h>

void
main(argc, argv)
   int     argc;
   char   *argv[];
{

   int     nv, i, j, k;

   char    string[100],
           string1[100];

   char    input_file[128],
           curexpdir[128];

   char    proc_string[5000];

   FILE   *in_ptr,
          *out_ptr,
          *fopen();

   if (argc != 2) {
     printf("\nUSAGE: adj_pilot_procpar fid_filename\n\n");
     exit(1);
   }
   strcpy(curexpdir, argv[1]);

   /* read in the nv parameter from the procpar file */
   strcpy(input_file, curexpdir);
   strcat(input_file, "/procpar");
   if ((in_ptr = fopen(input_file, "r")) == NULL)
   {
      perror("Open");
      printf("EPIRRI: Can't open input procpar file %s/procpar.\n",input_file);
      exit(8);
   }

   while (fgets(proc_string, 5000, in_ptr) != NULL)
   {
      if (!strncmp(proc_string, "nv ", 3))
      {
         fgets(proc_string, 5000, in_ptr);
         sscanf(proc_string, "1 %d\n", &nv);
      }
    }
   fclose(in_ptr);

   /* Update procpar with the new values */
   strcpy(input_file, curexpdir);
   strcat(input_file, "/procpar");
   if ((in_ptr = fopen(input_file, "r")) == NULL)
   {
      perror("Open");
      printf("ADJ_PILOT_PROCPAR: Can't open input procpar file %s.\n", input_file);
      exit(8);
   }

   /* Open "new" procpar file for writing */
   strcpy(input_file, curexpdir);
   strcat(input_file, "/procpar.new");
   if ((out_ptr = fopen(input_file, "w")) == NULL)
   {
      perror("Open");
      printf("ADJ_PILOT_PROCPAR: Can't open output procpar file %s.\n", input_file);
      exit(8);
   }

   /* Read in the "old" procpar file, line by line. copy to and 
      update "new" procpar as necessary */ 
   while (fgets(proc_string, 5000, in_ptr) != NULL)
   {
      if (!strncmp(proc_string, "seqcon", 6))
      {
	 fputs(proc_string, out_ptr);
	 fgets(proc_string, 5000, in_ptr);
	 fprintf(out_ptr, "1 \"nscnn\" \n");
	 fgets(proc_string, 5000, in_ptr);
      }
      if (!strncmp(proc_string, "ne", 2))
      {
	 fputs(proc_string, out_ptr);
	 fgets(proc_string, 5000, in_ptr);
	 fprintf(out_ptr, "1 1 \n");
	 fgets(proc_string, 5000, in_ptr);
      }
      if (!strncmp(proc_string, "pss", 3))
      {
	 fputs(proc_string, out_ptr);
	 fgets(proc_string, 5000, in_ptr);
	 fprintf(out_ptr, "3 0 0 0 \n");
	 fgets(proc_string, 5000, in_ptr);
      }
      if (!strncmp(proc_string, "ni", 2))
      {
	 fputs(proc_string, out_ptr);
	 fgets(proc_string, 5000, in_ptr);
	 sscanf(proc_string, "%d %d", &i, &j);
	 fprintf(out_ptr, "1 %d \n", nv);
	 fgets(proc_string, 5000, in_ptr);
      }
      if (!strncmp(proc_string, "nf", 2))
      {
	 fputs(proc_string, out_ptr);
	 fgets(proc_string, 5000, in_ptr);
	 fprintf(out_ptr, "1 1 \n");
	 fgets(proc_string, 5000, in_ptr);
      }
      if (!strncmp(proc_string, "celem", 5))
      {
	 fputs(proc_string, out_ptr);
	 fgets(proc_string, 5000, in_ptr);
	 fprintf(out_ptr, "1 3 \n");
	 fgets(proc_string, 5000, in_ptr);
      }
      if (!strncmp(proc_string, "arrayelem", 9))
      {
	 fputs(proc_string, out_ptr);
	 fgets(proc_string, 999, in_ptr);
	 sscanf(proc_string, "%d %d", &i, &j);
	 fprintf(out_ptr, "1 %d \n", j + 1);
	 fgets(proc_string, 5000, in_ptr);
      }
      if (!strncmp(proc_string, "arraydim", 8))
      {
	 fputs(proc_string, out_ptr);
	 fgets(proc_string, 5000, in_ptr);
	 sscanf(proc_string, "%d %d", &i, &j);
	 fprintf(out_ptr, "1 %d \n", nv*3);
	 fgets(proc_string, 5000, in_ptr);
      }
      if (!strncmp(proc_string, "array ", 6))
      {
	 fputs(proc_string, out_ptr);
	 fgets(proc_string, 5000, in_ptr);
	 sscanf(proc_string, "%d %s", &i, string);
	 k = strlen(string);
	 if (k < 3)
	    fprintf(out_ptr, "1 \"pss\"\n");
	 else
	 {
	    for (i = 0; i < k - 1; i++)
	       string1[i] = string[i];
	    string1[k - 1] = '\0';
	    strcat(string1, ",pss\"");
	    fprintf(out_ptr, "1 %s \n", string1);
	 }
	 fgets(proc_string, 5000, in_ptr);
      }
      fputs(proc_string, out_ptr);
   }
   fclose(in_ptr);
   fclose(out_ptr);

   /* Now replace the unmodified procpar with the new procpar */
   sprintf(string, "cp %s/procpar %s/procpar.orig", curexpdir, curexpdir);
   system(string);
   sprintf(string, "mv -f %s/procpar.new %s/procpar", curexpdir, curexpdir);
   system(string);

}
