
spatial_saturation_pulse()
{
  /* uses psat : satpwr : satpat : gsssat */
  /* also uses sat_psi, sat_phi and sat_theta rather than psi, phi, theta */
  /* Enables definition of independent sat planes relative to slice plane */
  position_offset(presat_off,gsssat,resto,OBSch);
  if(!strncmp(satpat,"sech",4))obspower(satpwr);
  else{
    if(rfmod[0]=='y'){
      getelem(t58,one,v12);  /* t58 contains the coarse power settings */
      power(v12,OBSch);      /* element "one" is the presat_off val */
      getelem(t59,one,v12);  /* t59 contains the fine power settings */ 
    }
    else obspower(satpwr);
  }
  
  if (tag_plane[0]=='r') {
    oblique_shapedgradient("gsat","","",pw_gsssat,gsssat,0.0,0.0,sat_psi,sat_phi,sat_theta,1,NOWAIT);
  } else if (tag_plane[0]=='p') {
    oblique_shapedgradient("","gsat","",pw_gsssat,0.0,gsssat,0.0,sat_psi,sat_phi,sat_theta,1,NOWAIT);
  } else {
    oblique_shapedgradient("","","gsat",pw_gsssat,0.0,0.0,gsssat,sat_psi,sat_phi,sat_theta,1,NOWAIT);
  }

  delay(fabs(gsssat)*grate+tep);
  if(!strncmp(satpat,"sech",4)) shaped_pulse(satpat,psat,v1,rof1,rof2);
  else {
    if(rfmod[0]=='y') shapedvpulse(satpat,psat,v12,v1,rof1,rof2);
    else shaped_pulse(satpat,psat,v1,rof1,rof2);
  }
  if(tep<fabs(gsssat)*grate)delay(fabs(gsssat)*grate-tep);        

  /* Crushers */
  if ((fabs(gcrush) > 0.0) && (tcrush > 0.0)) {
    crusher_gradients();
  }
  delay(post_presat_del);
}
spatial_saturation_pulse1()
{
  /* uses psat : satpwr : satpat : gsssat */
  /* also uses sat_psi, sat_phi and sat_theta rather than psi, phi, theta */
  /* Enables definition of independent sat planes relative to slice plane */
  position_offset(presat_off,gsssat,resto,OBSch);
  if(!strncmp(satpat,"sech",4))obspower(satpwr);
  else{
    if(rfmod[0]=='y'){
      getelem(t58,one,v12);  /* t58 contains the coarse power settings */
      power(v12,OBSch);      /* element "one" is the presat_off val */
      getelem(t59,one,v12);  /* t59 contains the fine power settings */ 
    }
    else obspower(satpwr);
  }
  
  if (tag_plane[0]=='r') {
    oblique_shapedgradient("gsat","","",pw_gsssat,gsssat,0.0,0.0,sat_psi,sat_phi,sat_theta,1,NOWAIT);
  } else if (tag_plane[0]=='p') {
    oblique_shapedgradient("","gsat","",pw_gsssat,0.0,gsssat,0.0,sat_psi,sat_phi,sat_theta,1,NOWAIT);
  } else {
    oblique_shapedgradient("","","gsat",pw_gsssat,0.0,0.0,gsssat,sat_psi,sat_phi,sat_theta,1,NOWAIT);
  }

  delay(fabs(gsssat)*grate+tep);
  if(!strncmp(satpat,"sech",4)) shaped_pulse(satpat,psat,v1,rof1,rof2);
  else {
    if(rfmod[0]=='y') shapedvpulse(satpat,psat,v12,v1,rof1,rof2);
    else shaped_pulse(satpat,psat,v1,rof1,rof2);
  }
  if(tep<fabs(gsssat)*grate)delay(fabs(gsssat)*grate-tep);        

  /* Crushers */
  if ((fabs(gcrush) > 0.0) && (tcrush > 0.0)) {
    obl_shapedgradient("gcr_up","","gcr_up",pw_gcrush,
		       gcrush,0.0,gcrush,1,WAIT);
    delay(tcrush-pw_gcrush);
    obl_shapedgradient("gcr_dn","","gcr_dn",
		       pw_gcrush,gcrush,0.0,gcrush,1,WAIT);
  }
  delay(post_presat_del);
}
spatial_saturation_pulse2()
{
  /* uses psat : satpwr : satpat : gsssat */
  /* also uses sat_psi, sat_phi and sat_theta rather than psi, phi, theta */
  /* Enables definition of independent sat planes relative to slice plane */
  position_offset(presat_off,gsssat,resto,OBSch);
  if(!strncmp(satpat,"sech",4))obspower(satpwr);
  else{
    if(rfmod[0]=='y'){
      getelem(t58,one,v12);  /* t58 contains the coarse power settings */
      power(v12,OBSch);      /* element "one" is the presat_off val */
      getelem(t59,one,v12);  /* t59 contains the fine power settings */ 
    }
    else obspower(satpwr);
  }
  
  if (tag_plane[0]=='r') {
    oblique_shapedgradient("gsat","","",pw_gsssat,gsssat,0.0,0.0,sat_psi,sat_phi,sat_theta,1,NOWAIT);
  } else if (tag_plane[0]=='p') {
    oblique_shapedgradient("","gsat","",pw_gsssat,0.0,gsssat,0.0,sat_psi,sat_phi,sat_theta,1,NOWAIT);
  } else {
    oblique_shapedgradient("","","gsat",pw_gsssat,0.0,0.0,gsssat,sat_psi,sat_phi,sat_theta,1,NOWAIT);
  }

  delay(fabs(gsssat)*grate+tep);
  if(!strncmp(satpat,"sech",4)) shaped_pulse(satpat,psat,v1,rof1,rof2);
  else {
    if(rfmod[0]=='y') shapedvpulse(satpat,psat,v12,v1,rof1,rof2);
    else shaped_pulse(satpat,psat,v1,rof1,rof2);
  }
  if(tep<fabs(gsssat)*grate)delay(fabs(gsssat)*grate-tep);        

  /* Crushers */
  if ((fabs(gcrush) > 0.0) && (tcrush > 0.0)) {
    obl_shapedgradient("gcr_up","gcr_up","",pw_gcrush,
		       gcrush,gcrush,0.0,1,WAIT);
    delay(tcrush-pw_gcrush);
    obl_shapedgradient("gcr_dn","gcr_dn","",
		       pw_gcrush,gcrush,gcrush,0.0,1,WAIT);
  }
  delay(post_presat_del);
}
spatial_saturation_pulse3()
{
  /* uses psat : satpwr : satpat : gsssat */
  /* also uses sat_psi, sat_phi and sat_theta rather than psi, phi, theta */
  /* Enables definition of independent sat planes relative to slice plane */
  position_offset(presat_off,gsssat,resto,OBSch);
  if(!strncmp(satpat,"sech",4))obspower(satpwr);
  else{
    if(rfmod[0]=='y'){
      getelem(t58,one,v12);  /* t58 contains the coarse power settings */
      power(v12,OBSch);      /* element "one" is the presat_off val */
      getelem(t59,one,v12);  /* t59 contains the fine power settings */ 
    }
    else obspower(satpwr);
  }
  
  if (tag_plane[0]=='r') {
    oblique_shapedgradient("gsat","","",pw_gsssat,gsssat,0.0,0.0,sat_psi,sat_phi,sat_theta,1,NOWAIT);
  } else if (tag_plane[0]=='p') {
    oblique_shapedgradient("","gsat","",pw_gsssat,0.0,gsssat,0.0,sat_psi,sat_phi,sat_theta,1,NOWAIT);
  } else {
    oblique_shapedgradient("","","gsat",pw_gsssat,0.0,0.0,gsssat,sat_psi,sat_phi,sat_theta,1,NOWAIT);
  }

  delay(fabs(gsssat)*grate+tep);
  if(!strncmp(satpat,"sech",4)) shaped_pulse(satpat,psat,v1,rof1,rof2);
  else {
    if(rfmod[0]=='y') shapedvpulse(satpat,psat,v12,v1,rof1,rof2);
    else shaped_pulse(satpat,psat,v1,rof1,rof2);
  }
  if(tep<fabs(gsssat)*grate)delay(fabs(gsssat)*grate-tep);        

  /* Crushers */
  if ((fabs(gcrush) > 0.0) && (tcrush > 0.0)) {
    obl_shapedgradient("","gcr_up","gcr_up",pw_gcrush,
		       0.0,gcrush,gcrush,1,WAIT);
    delay(tcrush-pw_gcrush);
    obl_shapedgradient("","gcr_dn","gcr_dn",
		       pw_gcrush,0.0,gcrush,gcrush,1,WAIT);
  }
  delay(post_presat_del);
}
selective_inversion_pulse(codeint vslice)
{
  if((ns>1)&&(invlist<0))invlist=curlist++;
  position_offset_list(pss,gss3,ns,resto,OBSch,invlist,vslice);
  if(!strncmp(p3pat,"sech",4))obspower(tpwr3);
  else{
    if(rfmod[0]=='y'){
      getelem(t3,vslice,v12);
      power(v12,OBSch);
      getelem(t60,vslice,v12);    
    }
    else obspower(tpwr3);
  }
  
  obl_shapedgradient("","","gss3",pw_gss3,0.0,0.0,gss3,1,NOWAIT);
  delay(fabs(gss3)*grate+tep);

  if(!strncmp(p3pat,"sech",4))shaped_pulse(p3pat,p3,v1,rof1,rof2);
  else{
    if(rfmod[0]=='y') shapedvpulse(p3pat,p3,v12,v1,rof1,rof2);
    else shaped_pulse(p3pat,p3,v1,rof1,rof2);
  }
  if(tep<fabs(gss3)*grate)delay(fabs(gss3)*grate-tep);        
  
  delay(fabs(gss3)*grate);
  delay(p3+rof1+rof2);
  delay(fabs(gss3)*grate);
}
nonselective_inversion_pulse()
{
  poffset(0.0,0.0);
  obspower(tpwr3);

  delay(fabs(gss3)*grate+tep);
  shaped_pulse(p3pat,p3,v1,rof1,rof2);
  if(tep<fabs(gss3)*grate)delay(fabs(gss3)*grate-tep);
  
  obl_shapedgradient("","","gss3",pw_gss3,0.0,0.0,gss3,1,WAIT);
}
quipss_excitation_pulse(codeint vslice)
{

  /* uses old style Varian obl_gradient calls */

  if((ns>1)&&(exlist<0))exlist=curlist++;
  position_offset_list(pss,gss,ns,resto,OBSch,exlist,vslice);
  if(rfmod[0]=='y'){
    getelem(t1,vslice,v12);
    power(v12,OBSch);
    getelem(t60,vslice,v12);
  }
  else obspower(tpwr1);

  /* put out trigger on sp1 every spin excitation */
  sp1on();
  /* put out trigger on sp2 every volume */
  ifzero(v9);
    ifzero(v14);
       sp2on();
    endif(v14);
  endif(v9);

  obl_gradient(0.0,0.0,gss);
  delay(fabs(gss)*grate+tep);
  if(rfmod[0]=='y') shapedvpulse(p1pat,p1,v12,v1,rof1,rof2);
  else shaped_pulse(p1pat,p1,v1,rof1,rof2);
  zero_all_gradients();
  delay(fabs(gss)*grate);

  sp1off();
  sp2off();

  /* refocus pulse */
  obl_gradient(0.0,0.0,gssr);
  delay(tref);
  zero_all_gradients();
  delay(pw_gssr);
}
excitation_pulse(codeint vslice)
{
  if((ns>1)&&(exlist<0))exlist=curlist++;
  position_offset_list(pss,gss,ns,resto,OBSch,exlist,vslice);
  if(rfmod[0]=='y'){
    getelem(t1,vslice,v12);
    power(v12,OBSch);
    getelem(t60,vslice,v12);
  }
  else obspower(tpwr1);

  /* put out trigger on sp1 every spin excitation */
  sp1on();
  /* put out trigger on sp2 every volume */
  ifzero(v9);
    ifzero(v14);
       sp2on();
    endif(v14);
  endif(v9);

  obl_shapedgradient("","","gss",pw_gss,0.0,0.0,gss,1,NOWAIT);
  delay(fabs(gss)*grate+tep);
  if(rfmod[0]=='y') shapedvpulse(p1pat,p1,v12,v1,rof1,rof2);
  else shaped_pulse(p1pat,p1,v1,rof1,rof2);
  if(tep<fabs(gss)*grate)delay(fabs(gss)*grate-tep);        

  sp1off();
  sp2off();

  /* refocus pulse */
  obl_shapedgradient("","","gssr_up",pw_gssr,0.0,0.0,gssr,1,WAIT);
  delay(tref-pw_gssr);
  obl_shapedgradient("","","gssr_dn",pw_gssr,0.0,0.0,gssr,1,WAIT);
}
spinecho_pulse(codeint vslice)
{
  double bigger_grad;

  bigger_grad= (fabs(gss2) > fabs(gspoil)) ? gss2 : gspoil;

  if((ns>1)&&(selist<0))selist=curlist++;
  position_offset_list(pss,gss2,ns,resto,OBSch,selist,vslice);
  if(rfmod[0]=='y'){
    getelem(t2,vslice,v12);
    power(v12,OBSch);
    getelem(t60,vslice,v12);    
  }
  else obspower(tpwr2);

  obl_shapedgradient("","","gss2",pw_gss2,0.0,0.0,bigger_grad,1,NOWAIT);
  delay(pw_gse_crush+tep);
  if(rfmod[0]=='y') shapedvpulse(p2pat,p2,v12,v2,rof1,rof2);
  else shaped_pulse(p2pat,p2,v2,rof1,rof2);
  delay(pw_gse_crush-tep);
}
quipss_spinecho_pulse(codeint vslice)
{

  /* uses old style Varian obl_gradient calls */

  double bigger_grad;

  bigger_grad= (fabs(gss2) > fabs(gspoil)) ? gss2 : gspoil;

  if((ns>1)&&(selist<0))selist=curlist++;
  position_offset_list(pss,gss2,ns,resto,OBSch,selist,vslice);
  if(rfmod[0]=='y'){
    getelem(t2,vslice,v12);
    power(v12,OBSch);
    getelem(t60,vslice,v12);    
  }
  else obspower(tpwr2);

  obl_gradient(0.0,0.0,gspoil);
  delay(fabs(gspoil)*grate+tspoil);
  obl_gradient(0.0,0.0,gss2);
  delay(fabs(gss2-gspoil)*grate+tep);
  if(rfmod[0]=='y') shapedvpulse(p2pat,p2,v12,v2,rof1,rof2);
  else shaped_pulse(p2pat,p2,v2,rof1,rof2);
  obl_gradient(0.0,0.0,gspoil);
  delay(fabs(gss2-gspoil)*grate+tspoil-tep);
  zero_all_gradients();
  delay(fabs(gspoil)*grate);
}
fatsat_pulse()
{
  obspower(tpwr4);

  /* move the centre frequency to fat peak */
  obsoffset(resto-3.45*sfrq);
  shaped_pulse(p4pat,p4,v1,rof1,rof2);
  obl_shapedgradient("","gfat","",pw_gfat,0.0,gmax/2,0.0,1,WAIT);

  /* reset centre frequency back to water */
  obsoffset(resto);
  delay(2.0e-6+12.0*12.5e-9);
}
navigator_acquire()
{
  obl_shapedgradient("gnavr_up","","",pw_gnav_r,-1*gnav_r,0.0,0.0,1,WAIT);
  delay(tnav_r-pw_gnav_r);
  obl_shapedgradient("gnavr_dn","","",pw_gnav_r,-1*gnav_r,0.0,0.0,1,WAIT);

  obl_shapedgradient("gnav","","",2*pw_gnav+(np/2/sw),gnav,0.0,0.0,1,NOWAIT);
  delay(pw_gnav+tep);
  acquire(np,1.0/sw);
  
  if(pw_gnav>=tep) delay(pw_gnav-tep);

  obl_shapedgradient("gnavr_up","","",pw_gnav_r,-1*gnav_r,0.0,0.0,1,WAIT);
  delay(tnav_r-pw_gnav_r);
  obl_shapedgradient("gnavr_dn","","",pw_gnav_r,-1*gnav_r,0.0,0.0,1,WAIT);
}
epi_gradients_and_acquire()
{
  int pt,rp,ftp,points;
  double last;
  double debug;

  double spe_tweak=1.0;
  double sgbd_tweak=1.0;
  double gbd_tweak=1.0;

  debug=1.0;   /* set to 1 for normal operation, 0 to null the epi gradients */
  
  /*spe_tweak=getval("spe_tweak");*/
  /*sgbd_tweak=getval("sgbd_tweak");*/
  /*gbd_tweak=getval("gbd_tweak");*/

  /* phase and read gradient dephaser */
  phase_encode_shapedgradient("gdp_up",pw_gror,gror*debug,gbd*gbd_tweak*debug,
            0.0,sgbd*sgbd_tweak*debug,
	      v9,num_ints,psi,phi,theta,v7,WAIT,0);
  delay(tref2-pw_gror);
  phase_encode_shapedgradient("gdp_dn",pw_gror,gror*debug,gbd*debug,0.0,
            sgbd*sgbd_tweak*debug,
	      v9,num_ints,psi,phi,theta,v7,WAIT,1);
  
  /* epi gradients */
  obl_shapedgradient("epird","epiph","",(2.0*pw_gro+echo_del+at)*etl,
		     gro*debug,sgbpe*spe_tweak*debug,0.0,1,NOWAIT);

  obsoffset(resto);

  delay(tep);
  
  /* sets v5 to etl and incs v6 up to it */ 
  /* peloop(seqcon[2],etl,v5,v6); */
  initval(etl,v5);
  assign(v5,v6);
  starthardloop(v6);

  /* Acquire echo */
  if(nonlinsamp[0]=='y') {

    points=np/2;
    last=samptime[0];
    
    for(rp=1;rp<points;rp++){
    	if(samptime[rp]==last)break;
    	last=samptime[rp];
    }

    delay(sampwait);
    for(pt=0;pt<rp;pt++){
      acquire(2.0,samptime[pt]);
    }
    
    ftp=points-2*rp;
    acquire((double)ftp*2,last);
    
    for(pt=rp+ftp;pt<points;pt++){
      acquire(2.0,samptime[pt]);
    }
    delay(samptime[points]+episwing+echo_del);
  }
  else {
    delay(pw_gro + episwing);
    acquire(np,1.0/sw);
    delay(pw_gro + echo_del);
  }

  /* increment the peloop counter v6 */
  /* endpeloop(seqcon[2],v6); */ 
  endhardloop();
}
epi_gradients_no_acquire()
{  
  double spe_tweak=1.0;
  double sgbd_tweak=1.0;
  double gbd_tweak=1.0;

  /* phase and read gradient dephaser */
  phase_encode_shapedgradient("gdp_up",pw_gror,gror,gbd*gbd_tweak,0.0,sgbd*sgbd_tweak,
			      v9,num_ints,psi,phi,theta,v7,WAIT,0);
  delay(tref2-pw_gror);
  phase_encode_shapedgradient("gdp_dn",pw_gror,gror,gbd,0.0,sgbd*sgbd_tweak,
			      v9,num_ints,psi,phi,theta,v7,WAIT,1);
  
  /* epi gradients */
  obl_shapedgradient("epird","epiph","",(2.0*pw_gro+echo_del+at)*etl,
		     gro,sgbpe*spe_tweak,0.0,1,NOWAIT);

  delay(tep);
  delay(etl*(2*pw_gro + episwing + echo_del + np/2/sw));
}
crusher_gradients()
{
  if ((fabs(gcrush) > 0.0) && (tcrush > 0.0)) {
    obl_shapedgradient("gcr_up","gcr_up","gcr_up",pw_gcrush,
		       gcrush,gcrush,gcrush,1,WAIT);
    delay(tcrush-pw_gcrush);
    obl_shapedgradient("gcr_dn","gcr_dn","gcr_dn",
		       pw_gcrush,gcrush,gcrush,gcrush,1,WAIT);
  }
}

int ox_position_offset_list(posarray,grad,nslices,resfrq,device,listno,apv1)

double  posarray[],resfrq,grad,nslices;
int     device, listno;
codeint apv1;
{
    int     k,retlist=-1;
    double  freqarray[MAXSLICE], nucgamma;

    if (nslices <= 1)
        position_offset(posarray[0],grad,resfrq,device);
    else {
        nucgamma = nucleus_gamma(device);
        for (k=0; k<(int)nslices; k++) {
            freqarray[k] = resfrq + nucgamma*grad*posarray[k];
        }
        retlist=create_offset_list(freqarray,(int)nslices,device,listno);
        voffset(listno,apv1);
    }
    return(retlist);
}
