pro t2star_recon, file_stem, interleave=interleave

if (n_elements(interleave) eq 0) then interleave=1

fname=file_stem+'/fid'

res=fix(get_varian_par(file_stem,'np')/2)
num_slices=fix(get_varian_par(file_stem,'ns'))
num_echoes=fix(get_varian_par(file_stem,'nv'))

out_fname=file_stem+'/fid_recon'

dummy_head=bytarr(32+20)
dc_offset=complex(0)
get_lun, unit
openr, unit, fname
readu, unit, dummy_head, dc_offset
close, unit
free_lun, unit

im=read_varian_bin_data(fname)

dims=size(im)
im=reform(im, 2, n_elements(im)/2)
im=reform(im, 2, res, num_echoes, num_slices, res)

new_slice_list=indgen(num_slices)

; reorder slices if interleave equals 1
if (interleave eq 1) then begin
  new_slice_list=intarr(num_slices)
  ns2=fix((num_slices+1)/2)
  for i=1, num_slices do begin
    if (i le ns2) then begin
      new_slice_list(i-1)=2*i-1
    endif else begin
      new_slice_list(i-1)=2*(i-ns2)
    endelse
  endfor
endif

print, "writing out file ", out_fname+'.img'
get_lun, unit
openw, unit, out_fname+'.img'

mod_flag=1
for j=0, num_echoes-1 do begin
  out_im=complexarr(res,res,num_slices)
  for i=0, num_slices-1 do begin
    if (mod_flag eq 1) then begin
      tmp_im=reform(complex(im(0,*,j,i,*),im(1,*,j,i,*)))-dc_offset
    endif else begin
      tmp_im=rotate(reform(complex(im(0,*,j,i,*),im(1,*,j,i,*)))- $
                  dc_offset, 5)
    endelse
    tmp_im=shift(fft(shift(tmp_im,res/2,res/2),1),res/2,res/2)
    out_im(*,*,new_slice_list(i)-1)=tmp_im
  endfor
  mod_flag=-1*mod_flag
  writeu, unit, out_im
  if (j eq 0) then begin
    ; also write out a first_echo image
    out_fname2=file_stem+'/fid_first_echo'
    print, "writing out file ", out_fname2+'.img'
    get_lun, unit2
    openw, unit2, out_fname2+'.img'
    writeu, unit2, abs(out_im)
    close, unit2
    free_lun, unit2
  endif
endfor

close, unit
free_lun, unit

; fake a size(big_out_im)
func_args=[4,res,res,num_slices,num_echoes,6,long(res)*res*num_slices,num_echoes]
; write out enough ANALYZE header info that the fit program can read the data
write_analyze_header, func_args, file_stem, out_fname+'.hdr'

; write out enough ANALYZE header info that the fit program can read the data
write_analyze_header, size(abs(out_im)), file_stem, out_fname2+'.hdr'

end
