#ifndef LINT
static char SCCSid[] = "@(#)s2pul.c 11.1 05/07/96 Copyright (c) 1991-1996 Varian Assoc.,Inc. All Rights Reserved";
#endif

/*  twopuls - standard two-pulse sequence */

#include <standard.h>
#include <math.h>
#include "sequence_utilities.h"

pulsesequence()
{

   double seq_time, min_te;
   char err_string[MAXSTR];

   min_te=2*(pw);
   if (te < min_te) {
          sprintf(err_string,"%s: TE too short. Min TE = %f\n",seqfil,min_te);
          printf(err_string);
          log_error(err_string);
          abort(1);
   }

   seq_time=pw/2+te+at/2;
   if (tr < seq_time) {
          sprintf(err_string,"%s: TR too short. Min TR = %f\n",seqfil,seq_time);
          printf(err_string);
          log_error(err_string);
          abort(1);
   }
   
   /* equilibrium period */
   status(A);
   sp4off();
   delay(tr-seq_time);

   /* --- tau delay --- */
   status(B);

   /* --- observe period --- */
   obsoffset(resto);
   status(C);
   sp4on();
   pulse(pw,oph);
   sp4off();

   delay(te/2-pw/2-pw);

   sp4on();
   pulse(2*pw,oph);
   sp4off();

   delay(te/2-pw);

   acquire(np, 1.0/sw);
}
