
calculate_multi_inversion_gradients(double *t_inv_b, double *t_inv_a)
{
  char shape_name[MAXSTR];
  double t_cr;

  sprintf(shape_name,"gss3");
  pw_gss3 = create_trap_gradient(fabs(gss3),shape_name,p3+rof1+rof2,grate,ix);

  *t_inv_b = fabs(gss3)*grate + rof1 + p3/2;
  *t_inv_a = fabs(gss3)*grate + p3/2 + rof2;
 
  if ((fabs(gcrush) > 0.0) && (tcrush > 0.0)) {
    calculate_crusher_gradients(&t_cr);
    *t_inv_a=*t_inv_a + t_cr;
  }
}

multi_inversion_pulses(double ti_delay)
{
  extern codeint v19,v20,v24;

  if(invlist<0)invlist=curlist++;
  
  sub(v19,one,v19); /* take one off the subset_ns temporarily */
  loop(v19,v20);
    if(!strncmp(p3pat,"sech",4))obspower(tpwr3);
    else{
      if(rfmod[0]=='y'){
        getelem(t3,v24,v12);
        power(v12,OBSch);
        getelem(t60,v24,v12);    
      }
      else obspower(tpwr3);
    }
    position_offset_list(pss,gss3,ns,resto,OBSch,invlist,v24);
    obl_shapedgradient("","","gss3",pw_gss3,0.0,0.0,gss3,1,NOWAIT);
    delay(fabs(gss3)*grate+tep);
    if(!strncmp(p3pat,"sech",4)) shaped_pulse(p3pat,p3,v1,rof1,rof2);
    else {
      if(rfmod[0]=='y') shapedvpulse(p3pat,p3,v12,v1,rof1,rof2);
      else shaped_pulse(p3pat,p3,v1,rof1,rof2);
    }
    if(tep<fabs(gss3)*grate)delay(fabs(gss3)*grate-tep);        
    if ((fabs(gcrush) > 0.0) && (tcrush > 0.0)) {
      crusher_gradients();
    }
    incr(v24);
    delay(ti_delay);
  endloop(v20);
  incr(v19);  /* increment v19 back to the desired subset_ns */

  /* play out the last slice position */
  if(!strncmp(p3pat,"sech",4))obspower(tpwr3);
  else{
    if(rfmod[0]=='y'){
      getelem(t3,v24,v12);
      power(v12,OBSch);
      getelem(t60,v24,v12);    
    }
    else obspower(tpwr3);
  }
  position_offset_list(pss,gss3,ns,resto,OBSch,invlist,v24);
  obl_shapedgradient("","","gss3",pw_gss3,0.0,0.0,gss3,1,NOWAIT);
  delay(fabs(gss3)*grate+tep);
  if(!strncmp(p3pat,"sech",4)) shaped_pulse(p3pat,p3,v1,rof1,rof2);
  else {
    if(rfmod[0]=='y') shapedvpulse(p3pat,p3,v12,v1,rof1,rof2);
    else shaped_pulse(p3pat,p3,v1,rof1,rof2);
  }
  if(tep<fabs(gss3)*grate)delay(fabs(gss3)*grate-tep);
  incr(v24);
  if ((fabs(gcrush) > 0.0) && (tcrush > 0.0)) {
    crusher_gradients();
  }
}
